// ===========================================================================
//	LComparator.h				PowerPlant 2.0		1995-1999 Metrowerks Inc.
// ===========================================================================

#ifndef _H_LComparator
#define _H_LComparator

#include "types.h"
typedef const void* CompareKeyT;


// 

class	LComparator {
public:
						LComparator();
	virtual				~LComparator();

	virtual SInt32		Compare(
								const void*			inItemOne,
								const void* 		inItemTwo,
								UInt32				inSizeOne,
								UInt32				inSizeTwo) const;

	virtual Boolean		IsEqualTo(
								const void*			inItemOne,
								const void* 		inItemTwo,
								UInt32				inSizeOne,
								UInt32				inSizeTwo) const;
								
	virtual	SInt32		CompareToKey(
								const void*			inItem,
								UInt32				inSize,
								const void*			inKey) const;
								
	virtual	Boolean		IsEqualToKey(
								const void*			inItem,
								UInt32				inSize,
								const void*			inKey) const;
								
	virtual LComparator*	Clone();
								
	static LComparator*	GetComparator();
								
protected:
	static	LComparator*	sComparator;
};


// 

class	LLongComparator : public LComparator {
public:
						LLongComparator();
	virtual				~LLongComparator();
			
	virtual SInt32		Compare(
								const void*			inItemOne,
								const void* 		inItemTwo,
								UInt32				inSizeOne,
								UInt32				inSizeTwo) const;
								
	virtual Boolean		IsEqualTo(
								const void*			inItemOne,
								const void* 		inItemTwo,
								UInt32				inSizeOne,
								UInt32				inSizeTwo) const;
								
	virtual LComparator*	Clone();
								
	static LLongComparator*		GetComparator();
	
protected:
	static LLongComparator*	sLongComparator;
};


#endif
