#include "TConvertImageDialog.h"
#include "TButton.h"
#include <stdio.h>

TConvertImageDialog::TConvertImageDialog() 
	: TDialog(kDialogPosX,kDialogPosY, 200, 170,"Convert Image") {
	
	
	TGroupBox *grpBox = new TGroupBox(10,10,180,130,"Convert Complex Image To") ;	
	AddObject(grpBox) ;
	
	mConvertType = kConvertModulusSquared ;
	
	mCurrentType = mModulusSquared = new TRadioButton(20,20,170,40,"Modulus squared") ;
	mModulusSquared->SetState(true) ;
	AddObject(mModulusSquared) ;
	
	mModulus = new TRadioButton(20,40,170,60,"Modulus") ;
	AddObject(mModulus) ;
	
	mPhase = new TRadioButton(20,60,170,80,"Phase") ;
	AddObject(mPhase) ;
	
	mReal = new TRadioButton(20,80,170,100,"Real part") ;
	AddObject(mReal) ;
	
	mImaginary = new TRadioButton(20,100,170,120,"Imaginary part") ;
	AddObject(mImaginary) ;
	
	mDefaultButton = mOKButton = new TButton(120,140,180,160,"OK") ;
	AddObject(mOKButton) ;
	
	mCancelButton = new TButton(50,140,110,160,"Cancel") ;
	AddObject(mCancelButton) ;
	
}

void	TConvertImageDialog::DoMouseDownInObject(TObject *obj,Point *pt) {
	if (pt != nil)
		if (!obj->DoMouseDown(pt)) return ;
	if (obj == mOKButton) {
		mDone = true ;
		mDialogReturnCode = kDialogOK ;
	}
	else if (obj == mCancelButton) {
		mDone = true ;
		mDialogReturnCode = kDialogCancel ;
	}
	if (obj == mModulusSquared && mCurrentType != mModulusSquared) {
		mConvertType = kConvertModulusSquared ;
		mCurrentType->SetState(0) ;
		mCurrentType = obj ;
		mCurrentType->SetState(1) ;
	}
	if (obj == mModulus && mCurrentType != mModulus) {
		mConvertType = kConvertModulus ;
		mCurrentType->SetState(0) ;
		mCurrentType = obj ;
		mCurrentType->SetState(1) ;
	}
	if (obj == mPhase && mCurrentType != mPhase) {
		mConvertType = kConvertPhase ;
		mCurrentType->SetState(0) ;
		mCurrentType = obj ;
		mCurrentType->SetState(1) ;
	}
	if (obj == mReal && mCurrentType != mReal) {
		mConvertType = kConvertReal ;
		mCurrentType->SetState(0) ;
		mCurrentType = obj ;
		mCurrentType->SetState(1) ;
	}
	if (obj == mImaginary && mCurrentType != mImaginary) {
		mConvertType = kConvertImaginary ;
		mCurrentType->SetState(0) ;
		mCurrentType = obj ;
		mCurrentType->SetState(1) ;
	}
}

