#ifndef __TDefineContentDialog_H
#define __TDefineContentDialog_H

#include "TTable.h"
#include "TDialog.h"
#include "TList.h"

#include "FS98ControlRecord.h"

class TContentAtom {
	public:
		TContentAtom() ;
		char	mSymbol[5] ;
		float	mDW ;
		float	mOccupancy ;
		long	mNumInCell ;
} ;

class TAtomEntry {	
	public:
		TAtomEntry() ;
		~TAtomEntry() ;
		friend class TAtomList ;
	private:	
		TContentAtom		*mAtom ;
		TAtomEntry	*mNextAtomEntry ;
}  ;

class TAtomList {
	public:
		TAtomList() ;
		~TAtomList() ;
		void 			AddAtom(TContentAtom *theAtom) ;
		void			RemoveAtom(short num) ;
		short			GetNumberOfAtoms(void) { return mNumAtoms ; } ;
		TContentAtom	*GetAtom(int number) ;
	private:
		short		mNumAtoms ;
		TAtomEntry	*mAtomEntry ;
	
}  ;


class	TContentList : public TList {
	public:
		TContentList(Rect	*theListRect) ;
	protected:
		void 	DrawCellValue(ListCellT &inCell,Rect &cellFrame) ;
		void 	DrawColLabel(short colNumber) ;
} ;

class TDefineContentDialog : public TDialog {
	public:
		TDefineContentDialog(TAtomList *atomList) ;
		
		TAtomList	*GetAtomData() ;
		void		DoKeyDownInObject(TObject *) ;
		void		DoMouseDownInObject(TObject *,Point *) ;
		
	protected:
	
		void			AddAtom() ;
		void			DeleteAtom() ;
		void			ModifyAtom() ;

		TEditText		*mChemicalSymbol;
		TEditText		*mDebyeWallerfactor;		
		TEditText		*mOccupancyFactor;		
		TEditText		*mNumberOfAtoms;		
		
		TButton			*mAddAtom ;
		TButton			*mDeleteAtom ;
		TButton			*mModifyAtom ;
		
		TContentList	*mContentList ;

} ;


#endif
