C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ECONT (FIN, E, H, K, NREF, SYMM )
         DIMENSION FIN(*), E(*), F(4)
         INTEGER HE(20), KE(20), ISE(20)
         CHARACTER*7 ISCHAR
         INTEGER H(*), K(*)
         CHARACTER*4 SYMM
         REAL KURT
C     First, print out ideal cases
         CALL STATER
         WRITE (6, *) '**********Real Data Statistics****************'
         WRITE (10, *) '**********Real Data Statistics****************'
 
C     Convert to E values
 
C     Get the mean and square
         FMEAN = 0.
         SQUARE = 0.
         NTOT = 0
         DO   J=1,NREF
           IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             FMEAN = FMEAN + FIN(J) * E(J)
             SQUARE = SQUARE + FIN(J) * FIN(J) * E(J)
             NTOT = NTOT + E(J)
           END IF
         END DO
         FMEAN = FMEAN / FLOAT (NTOT)
         SQUARE = SQRT (SQUARE / FLOAT (NTOT))
 
C     Get the STD, cube and fourth power
         STD = 0.
         CUBE = 0.
         FOURTH = 0.
         DO   J=1,NREF
           IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             DIFF = FIN(J) - FMEAN
             STD = STD + DIFF * DIFF * E(J)
             CUBE = CUBE + DIFF * DIFF * DIFF * E(J)
             FOURTH = FOURTH + DIFF * DIFF * DIFF * DIFF * E(J)
           END IF
         END DO
         STD = SQRT (STD / FLOAT (NTOT))
         SKEW = CUBE / ((STD * STD * STD) * FLOAT (NTOT))
         KURT = (-3.D0) + FOURTH / ((STD * STD * STD * STD) * FLOAT (
     X      NTOT))
 
C     conversion to E values, and see % above certain values
         I05 = 0
         I1 = 0
         I2 = 0
         I3 = 0
         I4 = 0
         DO   J=1,NREF
           E(J) = FIN(J) / SQUARE
           IF (E(J) .GT. 0.5D0) I05 = I05 + 1
           IF (E(J) .GT. 1.D0) I1 = I1 + 1
           IF (E(J) .GT. 2.D0) I2 = I2 + 1
           IF (E(J) .GT. 3.D0) I3 = I3 + 1
           IF (E(J) .GT. 4.D0) I4 = I4 + 1
         END DO
         F(1) = FLOAT (I1) * 100.D0 / FLOAT (NREF - 1)
         F(2) = FLOAT (I2) * 100.D0 / FLOAT (NREF - 1)
         F(3) = FLOAT (I3) * 100.D0 / FLOAT (NREF - 1)
         F(4) = FLOAT (I4) * 100.D0 / FLOAT (NREF - 1)
         F0 = FLOAT (I05) * 100.D0 / FLOAT (NREF - 1)
         WRITE (10, 11) F0
         WRITE (6, 11) F0
   11    FORMAT(' Number with E values above 0.5 is ',F4.1,'%')
         DO   J=1,4
           WRITE (10, 1) J, F(J)
           WRITE (6, 1) J, F(J)
    1      FORMAT(' Number with E values above   ',I1,' is ',F4.1,'%')
         END DO
         WRITE (10, 2) FMEAN, FMEAN / SQUARE
         WRITE (6, 2) FMEAN, FMEAN / SQUARE
    2    FORMAT(' Initial mean ',F12.5,' Mean of E        ',F9.4)
         WRITE (10, 3) STD, STD / SQUARE
         WRITE (6, 3) STD, STD / SQUARE
    3    FORMAT(' Initial std  ',F12.5,' Mean of STD of E ',F9.4)
         WRITE (10, 4) 'Skew     is ', SKEW
         WRITE (10, 4) 'Kurtosis is ', KURT
         WRITE (6, 4) 'Skew', SKEW
         WRITE (6, 4) 'Kurtosis', KURT
    4    FORMAT(' Value of ',A,F9.4)
         WRITE (10, 4810)
 4810    FORMAT(/'Rescaled Data (without Epsilon term):'/
     X      '******************* WARNING ***********************'/
     X      '*  E for (0,0) should be sqrt(Number of atoms)    *'/
     X      '*  To use inequalities, scaling of U and No atoms *'/
     X      '*  is critical.                                   *'/
     X      '*  Note: none of the U''s should be > 1.0         *'/
     X      '*  If they are, consider using more atoms         *'/
     X      '******************* WARNING ***********************'//,
     X      '    H    K       U        E     Mult  Range')
         DO   I=1,NREF
           CALL EQUIV2 (HE,KE,ISE,H(I),K(I),NE,SYMM)
           CALL ISERST (ISE(1),ISCHAR)
           IF(FIN(I).GT.0.9 .and. H(I).ne.0 .and. K(I).ne.0)then
           WRITE (10,49)H(I),K(I),FIN(I),E(I),NE,ISCHAR,
     X     ' <<< WARNING, U MAY BE TOO LARGE'
           ELSE
           WRITE (10, 49) H(I), K(I), FIN(I), E(I), NE, ISCHAR
           ENDIF
   49      FORMAT(2I5,2F10.5,I5,'  ',2A)
         END DO
         RETURN
       END
       SUBROUTINE ISERST (I, ISCHAR )
         CHARACTER*7 ISCHAR
         IF (I .EQ. 3 .OR. I .EQ. 1000) THEN
           ISCHAR = '180/360'
         ELSE IF (I .EQ. 6 .OR. I .EQ. 2000) THEN
           ISCHAR = ' 90/360'
         ELSE
           ISCHAR = 'General'
         END IF
         RETURN
       END
 
