       PROGRAM MERGER
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C  mindiv: maximal number of chromosomes per population
C         PARAMETER (MPARAM = 80, MNBITS = 4, MINDIV = 2000)
        INCLUDE 'CrossPars.h'
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 10 - Increased from 8 to 10 for multislice use
C     Number of members 100 - Decreased from 120 to 100 to avoid
C                 memory problems after increasing mnbits
C     Take the input from a sorted calc2.log type file
C     Convert it back to a binary string in outfl
         CHARACTER*30 INFILE, OUTFL
         DIMENSION NBIT(MPARAM), BLOW(MPARAM), BHIGH(MPARAM)
         DIMENSION BSTEP(MPARAM), PARS(MPARAM)
         INTEGER*2 BIT(MPARAM,MPARAM)
         DOUBLEPRECISION DD1, DD2
         PARAMETER (DD1 = 1.D0 / 2.D0, DD2 = 1.D0 / 2.D0)
         INTEGER II1
         REAL RR1
         CALL GETARG (1,INFILE)
         CALL GETARG (2,OUTFL)
         OPEN (UNIT=10, FILE=INFILE)
         OPEN (UNIT=11, FILE=OUTFL)
         OPEN (UNIT=12, FILE='control')
         READ (12, *) NPAR
         DO   J=1,NPAR
           READ (12, 1) NBIT(J), BLOW(J), BHIGH(J)
           BSTEP(J) = BHIGH(J) - BLOW(J)
           BSTEP(J) = BSTEP(J) / (2 ** NBIT(J) - 1.D0)
    1      FORMAT(I4,2F12.0)
         END DO
         DO   J=1,1000
           READ (10, *, ERR=3, END=3) NPOP, FOM, (PARS(K), K=1,NPAR)
           DO   II1=1,NPAR
C           convert into 0-1-chain
             IF (NBIT(II1) .EQ. 1) THEN
               IF (ABS (PARS(II1) - 360.D0) .LT. 1) THEN
                 BIT(II1,1) = 1
                 GO TO 221
               ELSE IF (ABS (PARS(II1) - 180.D0) .LT. 1) THEN
                 BIT(II1,1) = 0
                 GO TO 221
               END IF
             END IF
             IF (PARS(II1) .GT. BHIGH(II1)) THEN
               IF (ABS (PARS(II1) - BHIGH(II1)) .GT. ABS (PARS(II1) -
     X            360 - BLOW(II1))) THEN
                 PARS(II1) = BLOW(II1)
               ELSE
                 PARS(II1) = BHIGH(II1)
               END IF
             ELSE IF (PARS(II1) .LT. BLOW(II1)) THEN
               IF (ABS (PARS(II1) - BLOW(II1)) .GT. ABS (PARS(II1) +
     X            360 - BHIGH(II1))) THEN
                 PARS(II1) = BHIGH(II1)
               ELSE
                 PARS(II1) = BLOW(II1)
               END IF
             END IF
             ACTVAL = PARS(II1) - BLOW(II1)
             IF (ACTVAL .LT. -BSTEP(II1) * DD1) THEN
               ACTVAL = 360.D0 + ACTVAL
             ELSE IF (ACTVAL .GT. 360.D0 + BSTEP(II1) * DD2) THEN
               ACTVAL = ACTVAL - 360.D0
             END IF
C            actval=actval-bstep(k)/4.
             IA = ACTVAL / BSTEP(II1)
             IF (ACTVAL .GT. (0.5D0 + IA) * BSTEP(II1)) IA = IA + 1
             ACTVAL = IA * BSTEP(II1)
             RR1 = BHIGH(II1) - BLOW(II1)
             DO 220 KK=1,NBIT(II1)
               CRIT = RR1 / (2.D0 ** KK)
               IF (ACTVAL .GE. CRIT) THEN
                 BIT(II1,KK) = 1
                 ACTVAL = ACTVAL - CRIT
               ELSE
                 BIT(II1,KK) = 0
               END IF
  220          CONTINUE
C       Trap for the last bit
C                if(actval.gt.bstep(k)*0.5)then
C                        kk=nbit(k)
C                        bit(k,kk)=1
C                endif
  221        CONTINUE
           END DO
C           write bit chain for present chromosome
C        write (11,20)(' ',l=1,17),((bit(i,k),k=1,nbit(i)),i=1,npar)
C20       format (17a1,300i1)
           WRITE (11, 20) (' ', L=1,9), FOM, ((BIT(I,K), K=1,NBIT(I)), I
     X        =1,NPAR)
   20      FORMAT(9A1,F6.4,'  ',300I1)
         END DO
    3    CONTINUE
       END
