C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       PROGRAM FS2DP
C
C     Do fs on a population - for the genet code
 
C     ************GENETIC*************
C     Parameters for the genet coding
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C     This is fixed at 1 for binary data !
C  mindiv: maximal number of chromosomes per population
C         PARAMETER (MPARAM = 80, MNBITS = 4, MINDIV = 2000)
        INCLUDE 'CrossPars.h'
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 6  - Increased from 8 to 10 for multislice use
C     Number of members - 500
C     Number of children - 4*mindiv (2400)
         PARAMETER (MCHILD = 2000)
C     Note: mnbits*mparam appears in several array declarations
C
C     nhk2 for total number of beams (also must change nhk !
C         PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         include 'Nbeams.h'
         include 'NewIncludes.h'
         include 'NewStuff.h'
         include 'TModel.h'
         Include 'Sfacts.h'
         include 'Xray.h'
          LOGICAL PATTCHECK
         DIMENSION LL(9), M(3), L(NHK)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(NHK)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK), EWTS(NHK), MULTI(NHK)
         DIMENSION WPOS(NHK)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
 
 
 
C     Dimensions local to this
         DIMENSION ASK(MINDIV,MPARAM)
         DIMENSION FOMF(MINDIV), IFOM(MINDIV)
         INTEGER PARAM, CHILD, BITS, IFIT(MINDIV)
C     ************GENETIC*************
 
C     Dimension stuff local to sref
C
         PARAMETER (NMAX = NLIMIT)
         DIMENSION VV(NMAX*2), F(NMAX*2)
         DIMENSION S(2048), IS(1024)
         INTEGER HE(20), KE(20), ISE(20)
         DIMENSION IH(NHK), K(NHK), FHK(NHK), AHK(NHK), AIN(NHK), CDNAME
     X      (20)
         DIMENSION F2(6000)
         CHARACTER*4 SYMM
         CHARACTER*78 TITLE
         LOGICAL CFLAG, FLAGS, FNORM, PMASK
         CHARACTER*50 FORMT
         SAVE F2, AIN, AHK, FHK, K, IH, IS, S, ASK, /FOMALL/ , /MPCOMM/
     X      , /WCOM2/ , /WCOM/ , /FOM5/
         DOUBLEPRECISION DD1, DD2, DD3, DD4, DD5, DD6, DD7, DD8
         PARAMETER (DD1 = -1D-2, DD2 = -0.5D0, DD3 = -0.5D0, DD4 = -
     X      0.5D0, DD5 = -0.5D0)
         PARAMETER (DD6 = -0.5D0, DD7 = -0.5D0, DD8 = -0.01D0)
C         REAL RR1, RR2, RR3, RR4, RR5, RR6
 
C     ************GENETIC*************
C     Let's start by getting control parameters
C     Note: since this can change from what's in control, let's have
C     our own control file
         OPEN (UNIT=13, FILE='sref.control')
C     Number of parameters
         READ (13, *) PARAM
C     Number of children to be calculated (or individuals)
         READ (13, *) CHILD
C     Which population is this ?
         READ (13, *) IPOP
C     Total number of bits ?
         READ (13, *) BITS
         CLOSE (UNIT=13)
 
C     Now let's see how many we have previously calculated
         CALL CMPGEN (PARAM,FOMF,ASK,CHILD,NGOT,IFIT,KFIT)
 
C     get the input as arguements and open
         CALL UOPEN2 (1)
C      READ(2,5) CDNAME
    5    FORMAT(20A4)
         CALL BOPT (PCOR,SYMM,MODE,IOPT,PMASK,PCORM,XRAY,CDNAME,NCON,
     X      CVAR)
         WRITE (10, 501)  'Title is: ',CDNAME
         WRITE (6, 501)  'Title is: ',CDNAME
501     format(5a) 
C     if we got everything, jump to the end
         WRITE (6, 51) 'Found ', NGOT, ' of a possible ', CHILD
         WRITE (10, 51) 'Found ', NGOT, ' of a possible ', CHILD
   51    FORMAT(A,I4,A,I4)
         IF (NGOT .EQ. CHILD) THEN
 
C     Double check that all foms are set
           NF = 0
           DO   J=1,CHILD
             IF (FOMF(J) .LT. DD1) NF = 2
           END DO
           IF (NF .GT. 0) THEN
             WRITE (6, *) 'Warning: confusion in data ?'
             GO TO 3001
           END IF
           DO   J=1,CHILD
             IFOM(J) = 0
           END DO
           GO TO 3000
         END IF
 3001    CONTINUE
C     No, so let's get on with it!
C     ************GENETIC*************
C
         FORMT = '((20f9.5))     '
 
 
C      read(2,5)symm
C      READ(2,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
C     cflag, to control retaining values
         IF (CVAR .GT. 0) THEN
           CFLAG = .TRUE.
           WRITE (10, 141) 'Changing all values except 0,0'
           WRITE (6, 141) 'Changing all values except 0,0'
         ELSE
           CFLAG = .FALSE.
           WRITE (10, 141) 'Changing only unknowns'
           WRITE (6, 141) 'Changing only unknowns'
         END IF
 
         WTSON = .FALSE.
 
C      WRITE(10,27)NREF
C      WRITE(6,27)NREF
   27    FORMAT(/'NUMBER OF REFLECTIONS IS ',I5/)
 
         CENTRO = .FALSE.
C      printf=.true.
         ACONV = 90.D0 / ASIN (1.D0)
         IF (SYMM .EQ. 'p3mt') SYMM = 'p6mm'
         IF (PRINTF) WRITE (10, 48)
         IF (PRINTF) WRITE (6, 48)
   48    FORMAT('Input Data:'/,'    H    K    L    FHK        Angle')
C  Do an unformatted read of the data
         I0 = (-1)
         NREF = 0
         DO   I=1,9999
           EWTS(I) = 0.
           IF( WT2ON ) THEN
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I),EWTS(I)
           ELSE
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I)
           ENDIF
           NREF = NREF + 1
           IF (IH(I) .EQ. 0 .AND. K(I) .EQ. 0) I0 = I
           AHK(I) = AIN(I)
           IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           AHK(I) = AHK(I) / ACONV
         END DO
 1777    IF (I0 .LT. 0) THEN
           I0 = NREF + 1
           NREF = NREF + 1
           IH(NREF) = 0
           K(NREF) = 0
           L(NREF) = 0
           FHK(NREF) = 1.
           AIN(NREF) = 360.
           AHK(NREF) = 360.D0 / ACONV
         END IF
   49    FORMAT(3I5,5F11.5,F10.4,5f11.5)
C     For p3 cases, reduce h,k
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=1,NREF
             KLOW = 9999
             INDD = 1
             CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
             DO   JJ=1,NE
               IF (ISE(JJ) .GT. 0) THEN
                 IF (ABS (KE(JJ)) .LT. KLOW) THEN
                   KLOW = ABS (KE(JJ))
                   INDD = JJ
                 ELSE IF (ABS (KE(JJ)) .EQ. KLOW) THEN
                   IF (HE(JJ) .GT. HE(INDD)) INDD = JJ
                 END IF
               END IF
             END DO
             IH(J) = HE(INDD)
             K(J) = KE(INDD)
           END DO
         END IF
C     xray=.false.
C     General Normalization Code for X-ray or Electrons
 
C     write(10,*)' '
C           Normalization
C     Note: get scaler here
         ISCALE = 1
         IF (IH(1) .EQ. 0 .AND. K(1) .EQ. 0) ISCALE = 2
 9901    CONTINUE
         IF (FHK(ISCALE) .LT. 1D-8) THEN
           ISCALE = ISCALE + 1
           GO TO 9901
         END IF
 
C     calculate the structure factors
        INCLUDE 'NewNorm.h' 
         F0PASS = SQRT (F0)
C     if(fstest(15).gt.0)call  tpos2D(IH,K,symm,vv,m)
 
         DO JJ=NREF+1,NPAD
                L(JJ)=0
         ENDDO 
C     O.K. Now we do our loop for the unknown values
C     ************GENETIC*************
         OPEN (UNIT=15, FILE='calc2.log', ACCESS='append')
         DO   JPOP=1,CHILD
 
           IF (FOMF(JPOP) .GT. DD8) THEN
C           Flag for later use that we already had it
             IFOM(JPOP) = 0
             GO TO 2000
           END IF
           IFOM(JPOP) = 1
C     ************GENETIC*************
 
           WRITE (10, *) ' '
           WRITE (6, 1013) JPOP
           WRITE (10, 1013) JPOP
 1013      FORMAT('Calculating Pass ...... ',I4)
 
           DO   JJ=1,NREF
             AHK(JJ) = AIN(JJ) / ACONV
           END DO
           DO   J=1,PARAM
             AIN(J) = 0.
             AHK(J) = ASK(JPOP,J) / ACONV
C             write(6,*)J,FHK(J),AHK(J),ACONV,ASK(JPOP,J)
           END DO
 
C  The guts, do a convolution analysis
C     iopt=1
C           write(6,*)'Going in'
           CALL SB2D (VV,IH,K,FHK,AHK,AIN,SYMM,NREF,NCON,256,NHK,NMAX,
     X        CFLAG,IOPT)

C  Trap a Patterson solution
C        IF(PATTCHECK(IH,K,PARAM,AHK,symm))then
C                SFERR1=SFERR1*2
C                SFERR2=SFERR2*2
C        endif 
           SFERR1=min(9.99,SFERR1)
           SFERR2=min(9.99,SFERR2)
           WRITE (6, 1011) SFERR1, SFERR2
 1011      FORMAT('FOMS: ',2E12.4)
 
C     ************GENETIC*************
C     Store in fomf the value
           FOMF(JPOP) = SFERR2
           IF(JPOP.gt.0)PRINTF = .FALSE.
 
           WRITE (15, 3101) IPOP, SFERR2, (AHK(KK), KK=1,PARAM)
 
 2000      CONTINUE
 3101      FORMAT(I3,F7.4,200F6.1)
         END DO
 
C     Now let's store everything
 3000    CALL STGEN (FOMF,IFOM,CHILD,PARAM,ASK,IPOP,BITS,IFIT,KFIT)
C     ************GENETIC*************
 
         STOP
   91    FORMAT(2X,2I5,2X,F12.7,2X,2F11.6)
  191    FORMAT(2X,2(I5,' , '),F12.6,' , ',F12.6)
       END
 
