C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C       This routine does a straight phase extension, assuming some known phases
C
C
        PROGRAM FS2DPE
C           SUBROUTINE FS2DPE_(filen)
C           character*(*) filen
C           call FS2DPE(filen)
C           return
C           end
C           SUBROUTINE FS2DPE(filen)
C
C
C        PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         include 'Nbeams.h'
         include 'NewIncludes.h'
         include 'NewStuff.h'
         include 'TModel.h'
         include 'Xray.h'
         DIMENSION LL(9), M(3), L(NHK)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
         include 'Nlimit.h'
C         PARAMETER (NHK2 = NHK, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(NHK)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK), EWTS(NHK), MULTI(NHK)
         DIMENSION WPOS(NHK)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         PARAMETER (NMAX = NLIMIT)
         DIMENSION VV(NMAX*2), F(NMAX*2)
         DIMENSION S(2048), IS(1024)
         INTEGER HE(20), KE(20), ISE(20)
         DIMENSION IH(NHK), K(NHK), FHK(NHK), AHK(NHK), AIN(NHK)
         DIMENSION F2(6000)
         CHARACTER*4 SYMM
         CHARACTER*78 TITLE, CDNAME
         LOGICAL CFLAG, FLAGS, FNORM, PMASK
         CHARACTER*50 FORMT
         SAVE F2, AIN, AHK, FHK, K, IH, IS, S, F, /COPT2/ , /COPT/ , /
     X      MVIS/ , /SFCOM2/ , /SFCOM1/ , /FOMALL/ , /MPCOMM
     X      / , /WCOM2/ , /WCOM/ , /FOM5/
         DOUBLEPRECISION DD1, DD2, DD3, DD4, DD5, DD6
         PARAMETER (DD1 = -0.5D0, DD2 = -0.5D0, DD3 = -0.5D0, DD4 = -
     X      0.5D0, DD5 = -0.5D0)
         PARAMETER (DD6 = -0.5D0)
C         REAL RR1, RR2, RR3, RR4, RR5, RR6, RR7, RR8
         LOGICAL LL1
 
C
         FORMT = '((20f9.5))     '
 
C     get the input as arguement
         CALL UOPEN2 (2)
 
C      READ(2,5) CDNAME
    5    FORMAT(A)
         CALL BOPT (PCOR,SYMM,MODE,IOPT,PMASK,PCORM,XRAY,CDNAME,NCON,
     X      CVAR)
         WRITE (10, 501)  'Title is: ',CDNAME
         WRITE (6, 501)  'Title is: ',CDNAME
501     format(5a) 
C      read(2,5)symm
C      READ(2,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
C     cflag, to control retaining values
         IF (CVAR .GT. 0) THEN
           CFLAG = .TRUE.
           WRITE (10, 141) 'Changing all values except 0,0'
           WRITE (6, 141) 'Changing all values except 0,0'
         ELSE
           CFLAG = .FALSE.
           WRITE (6, 141) 'Changing only unknowns'
           WRITE (10, 141) 'Changing only unknowns'
         END IF
 
         WTSON = .FALSE.
 
C      WRITE(10,27)NREF
C      WRITE(6,27)NREF
   27    FORMAT(/'NUMBER OF REFLECTIONS IS ',I5/)
 
         CENTRO = .FALSE.
C      printf=.true.
         ACONV = 90.D0 / ASIN (1.D0)
         IF (SYMM .EQ. 'p3mt') SYMM = 'p6mm'
         IF (PRINTF) WRITE (10, 48)
         IF (PRINTF) WRITE (6, 48)
   48    FORMAT('Input Data:'/,'    H    K    L    FHK        Angle')
C  Do an unformatted read of the data
         I0 = (-1)
         NREF = 0
         DO   I=1,9999
           EWTS(I) = 0.
           IF( WT2ON ) THEN
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I),EWTS(I)
           ELSE
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I)
           ENDIF
C       Trap negatives as an artifact
        if(ain(i).lt.-0.1)ain(i)=ain(i)+360     
           NREF = NREF + 1
           IF (IH(I) .EQ. 0 .AND. K(I) .EQ. 0) I0 = I
           AHK(I) = AIN(I)
           IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           AHK(I) = AHK(I) / ACONV
         END DO
 1777    IF (I0 .LT. 0) THEN
           I0 = NREF + 1
           NREF = NREF + 1
           IH(NREF) = 0
           K(NREF) = 0
           L(NREF) = 0
           FHK(NREF) = 1.
           AIN(NREF) = 360.
           AHK(NREF) = 360.D0 / ACONV
         END IF
   49    FORMAT(3I5,5F11.5,F10.4,5F11.5)
C     For p3 cases, reduce h,k
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=1,NREF
             KLOW = 9999
             INDD = 1
             CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
             DO   JJ=1,NE
               IF (ISE(JJ) .GT. 0) THEN
                 IF (ABS (KE(JJ)) .LT. KLOW) THEN
                   KLOW = ABS (KE(JJ))
                   INDD = JJ
                 ELSE IF (ABS (KE(JJ)) .EQ. KLOW) THEN
                   IF (HE(JJ) .GT. HE(INDD)) INDD = JJ
                 END IF
               END IF
             END DO
             IH(J) = HE(INDD)
             K(J) = KE(INDD)
           END DO
         END IF
C     xray=.false.
C     General Normalization Code for X-ray or Electrons
 
C     write(10,*)' '
C           Normalization
C     Note: get scaler here
         ISCALE = 1
         IF (IH(1) .EQ. 0 .AND. K(1) .EQ. 0) ISCALE = 2
 9901    CONTINUE
         IF (FHK(ISCALE) .LT. 1D-8) THEN
           ISCALE = ISCALE + 1
           GO TO 9901
         END IF
 
C     calculate the structure factors
        INCLUDE 'NewNorm.h' 
 
         F0PASS = SQRT (F0)
C     if(fstest(15).gt.0)call  tpos2D(IH,K,symm,vv,m)
 
         WRITE (10, *) ' '
         WRITE (6, 1013)
 1013    FORMAT('Calculating First Pass ...... ')
 
         DO   JJ=1,NREF
           RR7 = AIN(JJ)
           AHK(JJ) = RR7 / ACONV
         END DO
         DO JJ=NREF+1,NPAD
                L(JJ)=0
         ENDDO 
 
C     Now run through and unset ain(jj) for the the first "N" beams
C     Using information from "control"
C         OPEN (UNIT=1, FILE='control')
C         READ (1, *) NCNTRL
C         CLOSE (UNIT=1)
C         DO   JJ=1,NCNTRL
C           AIN(JJ) = 0.
C         END DO
        NCNTRL=0
 
C  The guts, do a convolution analysis
C     iopt=1
         CALL SB2D (VV,IH,K,FHK,AHK,AIN,SYMM,NREF,NCON,256,NHK,NMAX,
     X      CFLAG,IOPT)
 
         WRITE (6, 1011) SFERR1, SFERR2
 1011    FORMAT(/'FOM of first pass: '/
     X      '    R-factor for Structure Factors:',E12.4/
     X      '    R-factor of complex Structure Factors: ',E12.4)
C
 
 
C  Store the data, form appropriate for a re-read
         IF (PRINTF) WRITE (6, 482)
         IF (PRINTF) WRITE (10, 482)
  482    FORMAT('Output Data:'/,'    H    K    L    FHK       Angle')
C      WRITE(7,50)CDNAME(1:64),sferr2
   50    FORMAT(A,' FOM= ',F8.4)
C      write(7,5)symm
C      write(7,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
C      if(pcor.gt.1e-3)then
C      WRITE(8,50)CDNAME,sferr2
C      write(8,5)symm
C      write(8,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
C      endif
 
 
C     Rewinds, for safety
         REWIND (UNIT=7)
         REWIND (UNIT=8)
         LL1 = PCOR .GT. 1D-3
         DO   I=1,NREF
           IF (IH(I) .NE. 0 .OR. K(I) .NE. 0) THEN
             IF (LL1) THEN
               WRITE (7, 91) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(I)
               WRITE (8, 91) IH(I), K(I), L(I), FHK(I), AHK(I)
               IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I) *
     X            WTS(I), AHK(I)
               IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I) * WTS
     X            (I), AHK(I)
             ELSE
               WRITE (7, 91) IH(I), K(I), L(I), FHK(I), AHK(I)
               IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK
     X            (I)
               IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(
     X            I)
             END IF
           END IF
         END DO
         IF (PCOR .GT. 1D-3) THEN
           IF (PRINTF) THEN
             IF (PRINTF) THEN
               DO   I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
                 WRITE (8, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (10, 490) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK
     X              (I)
                 WRITE (6, 490) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
               END DO
             ELSE
               DO 6 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
                 WRITE (8, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (10, 490) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK
     X              (I)
    6            CONTINUE
             END IF
           ELSE
             IF (PRINTF) THEN
               DO 7 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
                 WRITE (8, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (6, 490) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
    7            CONTINUE
             ELSE
               DO 8 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I) * WTS(I), AHK(
     X              I)
                 WRITE (8, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
    8            CONTINUE
             END IF
           END IF
         ELSE
           IF (PRINTF) THEN
             IF (PRINTF) THEN
               DO 9 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (10, 490) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (6, 490) IH(I), K(I), L(I), FHK(I), AHK(I)
    9            CONTINUE
             ELSE
               DO 10 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (10, 490) IH(I), K(I), L(I), FHK(I), AHK(I)
   10            CONTINUE
             END IF
           ELSE
             IF (PRINTF) THEN
               DO 11 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
                 WRITE (6, 490) IH(I), K(I), L(I), FHK(I), AHK(I)
   11            CONTINUE
             ELSE
               DO 12 I=NREF+1,NPAD
                 WRITE (7, 910) IH(I), K(I), L(I), FHK(I), AHK(I)
   12            CONTINUE
             END IF
           END IF
         END IF
   91    FORMAT(2X,3I5,2X,F12.7,2X,2F11.4)
  191    FORMAT(2X,3(I5,' , '),F12.6,' , ',F12.6)
  910    FORMAT(2X,3I5,2X,F13.8,2X,F12.4,' ** ESTIMATE')
  490    FORMAT(3I5,2F11.5,' ** ESTIMATE')
 
 
 
C     Output the image
         REWIND (UNIT=7)
         READ (7, 141) TITLE
         DO   J=1,NPAD
           AHK(J) = AHK(J) / ACONV
           FHK(J) = FHK(J)*WTS(J)
         END DO
C      call eimg2D(F,IH,K,FHK,AHK,NREF,symm,title)
         CALL EIMG2D (VV,F,IH,K,FHK,AHK,NPAD,SYMM,TITLE)
       END
 
 
