C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE LMIN (X, Y, A, VAL )
C     given a 3x3 array a, finds the local maximum,
C     returns the expected value there
         DIMENSION A((-1):1,(-1):1)
         DOUBLEPRECISION DD1, DD2
         PARAMETER (DD1 = 1.D0 / 3.D0, DD2 = 1.D0 / 3.D0)
         DXX = DD1 * (A(1,1) + A(0,1) * (-2.D0) + A((-1),1) + A(1,0) + A
     X      (0,0) * (-2.D0) + A((-1),0) + A(1,(-1)) + A(0,(-1)) * (-2.D0
     X      ) + A((-1),(-1)))
         DYY = DD2 * (A(1,1) + A(1,0) * (-2.D0) + A(1,(-1)) + A(0,1) + A
     X      (0,0) * (-2.D0) + A(0,(-1)) + A((-1),1) + A((-1),0) * (-2.D0
     X      ) + A((-1),(-1)))
         DXY = 0.25D0 * (A(1,1) - A(1,(-1)) - A((-1),1) + A((-1),(-1)))
         DX = 0.5D0 * (A(1,0) - A((-1),0))
         DY = 0.5D0 * (A(0,1) - A(0,(-1)))
         DET = DXX * DYY - DXY * DXY
         IF (ABS (DET) .LT. 1D-10) THEN
           X = 0.
           Y = 0.
           VAL = A(0,0)
           RETURN
         END IF
         X = -(DYY * DX - DXY * DY) / DET
         Y = -(DXX * DY - DXY * DX) / DET
         VAL = A(0,0) + DX * X + DY * Y + 0.5D0 * (X * X * DXX + Y * Y *
     X       DYY) + X * Y * DXY
         RETURN
       END
