#include "config.h"
#ifdef HAVE_SFFTW_H
#include "sfftw.h"
#else
#include "fftw.h"
#endif
int rank, nx, ny, nz, flags;
/* static fftwnd_plan plan2Dp, plan2Dn; */
static fftw_plan plan2Dp, plan2Dn;
static float fac;
static int npts;

void fft2dp(a)
fftw_complex a[];
{
	fftwnd(plan2Dp, 1,(fftw_complex *)  a, 1, 0 ,0,0,0);
}
void fft2dp_(a)
fftw_complex a[];
{
	fftwnd(plan2Dp, 1,(fftw_complex *)  a, 1, 0 ,0,0,0);
}
void fft2dn(a)
fftw_complex a[];
{
	int i;
	fftwnd(plan2Dn, 1, (fftw_complex *) a, 1, 0 ,0,0,0);
/* Normalize, for compatibility with harm */
	for (i = 0; i < npts ; ++i) {
		c_re(a[i]) = c_re(a[i])*fac ;
		c_im(a[i]) = c_im(a[i])*fac ;
	}

}
void fft2dn_(a)
fftw_complex a[];
{
	int i;
	fftwnd(plan2Dn, 1, (fftw_complex *) a, 1, 0 ,0,0,0);
/* Normalize, for compatibility with harm */
	for (i = 0; i < npts ; ++i) {
		c_re(a[i]) = c_re(a[i])*fac ;
		c_im(a[i]) = c_im(a[i])*fac ;
	}

}
void pbuf2(dims,a)
int dims[];
fftw_complex a[];
{
/* Note: reversed order for compatibility with harm */
	nx=dims[1];
	ny=dims[0];
	flags=FFTW_ESTIMATE | FFTW_IN_PLACE;
	plan2Dn=fftw2d_create_plan_specific(nx,ny,FFTW_FORWARD,flags,a,1,0,0);
	plan2Dp=fftw2d_create_plan_specific(nx,ny,FFTW_BACKWARD,flags,a,1,0,0);
/*	plan2Dn=fftw2d_create_plan(nx,ny,FFTW_FORWARD,flags);
	plan2Dp=fftw2d_create_plan(nx,ny,FFTW_BACKWARD,flags); */
	npts=nx*ny;
	fac=nx*ny;
	fac=1./fac;
}
void pbuf2_(dims,a)
int dims[];
fftw_complex a[];
{
/* Note: reversed order for compatibility with harm */
	nx=dims[1];
	ny=dims[0];
	flags=FFTW_ESTIMATE | FFTW_IN_PLACE;
	plan2Dn=fftw2d_create_plan_specific(nx,ny,FFTW_FORWARD,flags,a,1,0,0);
	plan2Dp=fftw2d_create_plan_specific(nx,ny,FFTW_BACKWARD,flags,a,1,0,0);
/*	plan2Dn=fftw2d_create_plan(nx,ny,FFTW_FORWARD,flags);
	plan2Dp=fftw2d_create_plan(nx,ny,FFTW_BACKWARD,flags); */
	npts=nx*ny;
	fac=nx*ny;
	fac=1./fac;
}

void mbuf2(dims,a)
int dims[];
fftw_complex a[];
{
/* Note: reversed order for compatibility with harm */
	nx=dims[1];
	ny=dims[0];
	flags=FFTW_MEASURE | FFTW_IN_PLACE;
	plan2Dn=fftw2d_create_plan_specific(nx,ny,FFTW_FORWARD,flags,a,1,0,0);
	plan2Dp=fftw2d_create_plan_specific(nx,ny,FFTW_BACKWARD,flags,a,1,0,0);
/*	plan2Dn=fftw2d_create_plan(nx,ny,FFTW_FORWARD,flags);
	plan2Dp=fftw2d_create_plan(nx,ny,FFTW_BACKWARD,flags); */
	npts=nx*ny;
	fac=nx*ny;
	fac=1./fac;
}
void mbuf2_(dims,a)
int dims[];
fftw_complex a[];
{
/* Note: reversed order for compatibility with harm */
	nx=dims[1];
	ny=dims[0];
	flags=FFTW_MEASURE | FFTW_IN_PLACE;
	plan2Dn=fftw2d_create_plan_specific(nx,ny,FFTW_FORWARD,flags,a,1,0,0);
	plan2Dp=fftw2d_create_plan_specific(nx,ny,FFTW_BACKWARD,flags,a,1,0,0);
/*	plan2Dn=fftw2d_create_plan(nx,ny,FFTW_FORWARD,flags);
	plan2Dp=fftw2d_create_plan(nx,ny,FFTW_BACKWARD,flags); */
	npts=nx*ny;
	fac=nx*ny;
	fac=1./fac;
}

void dpln2d()
{
	fftw_destroy_plan( plan2Dp );
	fftw_destroy_plan( plan2Dn );
}
void dpln2d_()
{
	fftw_destroy_plan( plan2Dp );
	fftw_destroy_plan( plan2Dn );
}
