      SUBROUTINE GEN3DR(P,IH,KB,LB,NREF,xray)
C
C       CALCULATES STRUCTURE FACTORS FOR A GIVEN UNIT CELL 
C       GAUSIAN FITTING PARAMETERS
C
        include 'controls.h'
        include 'rfact.h'
       Common /tdata3D/L,AB,D2,THETA,C
       DIMENSION P(*)
       DIMENSION L(9),D(3)
       integer ih(*),kb(*),lb(*)
       logical xray
C     READ IN OPTION PARAMETERS
C	xray=xrayl
	nslice=1
	f00ent=ff0
C
	A=cell(1)
	B=cell(2)
	C=cell(3)
	Alpha=cell(4)
	betta=cell(5)
	gamma=cell(6)
       PF=2.d0*asin(1.d0) /180.0d0
C     CONVERT ANGLES TO RADIANS
       ALPHA=ALPHA*PF
       BETTA=BETTA*PF
       GAMMA=GAMMA*PF
       CA=COS(ALPHA)
       CB=COS(BETTA)
       CG=COS(GAMMA)
       SA=SIN(ALPHA)
       SB=SIN(BETTA)
       SG=SIN(GAMMA)
c
C   SET UP "D" SPACINGS
	L(1)=1
	L(2)=0
	L(3)=0
	L(4)=0
	L(5)=1
	L(6)=0
c
       L(7)=L(1)-L(4)
       L(8)=L(2)-L(5)
       L(9)=L(3)-L(6)
       DQ=1.+2.*CA*CB*CG-CA*CA-CB*CB-CG*CG
c
       DO 51 I=1,3
       K=3*I-3
       D(I)=L(1+K)*L(1+K)*SA*SA/(A*A)+L(2+K)*L(2+K)*SB*SB/(B*B)
     1+L(3+K)*L(3+K)*SG*SG/(C*C)
     2+(2.d0*L(1+K)*L(2+K)/(A*B))*(CA*CB-CG)
     3+(2.d0*L(2+K)*L(3+K)/(B*C))*(CB*CG-CA)
     4+(2.d0*L(3+K)*L(1+K)/(A*C))*(CG*CA-CB)
       D(I)=DQ/D(I)
   51 D(I)=SQRT(D(I))
       CT=0.5*D(1)*D(2)*(D(1)**(-2)+D(2)**(-2)-D(3)**(-2))
 7002 CONTINUE
       THETA=ACOS(CT)
       TH=THETA/PF
c
C     OUTPUT OF SPACING AND REFLECTIONS
C       WRITE(10,990)     (L(I),I=1,3),D(1),(L(I),I=4,6) ,D(2)
c
C       WRITE(10,989)TH
c
       AB=D(1)
       D2=D(2)
       D(3)=C
      ntype=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
         ntype=ntype+1
         endif
      enddo
C
C     LOOP OVER SLICES
C	NSLICE=1 forced here
       NSLICE=1
       DO 100 NSL=1,NSLICE
       VSUMZ=0.
       IOPT3=0
C       WRITE(10,6798)NSL,NTYPE
c
C     SET ARRAY P TO ZERO
C      do j=1,nrref
C          P(j)=0.0
C      enddo
C
C     CALL POT3DR FOR THE PROJECTED POTENTIAL
C	write(10,*)'Dump2 ',L,AB,D2,THETA,C
C
C     Add (0,0,0) at end
      nreft=nrref+1
      rh(nreft)=0
      rk(nreft)=0
      rl(nreft)=0
       CALL POT3DR(P,rh,rk,rl,NREFT,D,L,
     $ VSUMZ,CT,NTYPE,F0,xray)
C
C
c
c
c     correction term
c   Omega - volume of unit cell
c   Structure factors converted to potential factors by
c  v(h,k,l)=f(h,k,l)*(h*h/((2.*pi*m0*e)*volume of unit cell)
c  the bracketed term is the term cor:
c       omega=sqrt(1.+2.*ca*cb*cg-ca*ca-cb*cb-cg*cg)
c       omega=a*b*c*omega
c       cor=47.8746/omega
c
c     However, we need here the volume of the slice unit cell
c     Not what is normal in multislice!
c
C      omega=sin(theta)*d(1)*d(2)*c
C      cor=47.87460/omega
c
C	write(10,*)	
C       WRITE(10,*)' Calculated Mean Inner Potential',VSUMZ*cor
C	write(10,*)' CIP ',vsumz,cor
  100  CONTINUE
      fbig=-0.5
      do j=1,ntype
         if(zatom(j).gt.fbig)fbig=zatom(j)
      enddo
C	write(10,*)'Rescale term fbig ',fbig
      do j=1,ntype
         zatom(j)=zatom(j)/fbig
	 do jj=1,nrref
		rfact(jj,j)=rfact(jj,j)/fbig
		rfactb(j,jj)=rfact(jj,j)
C                write(10,*)rfactb(j,jj),j,jj
	 enddo
C      write(6,*)'Full zatom ',zatom(j),j
      enddo
	f00=f00ent
       RETURN
2     FORMAT(/'  Cell size used is ',i4,' x ',i4)
481   format('  Maximum sampling along H to +/- ',f6.3,
     $ ' reciprocal Angstroms '/
     $       '                         K to +/- ',f6.3,
     $ ' reciprocal Angstroms ')
  899 FORMAT(6F10.6)
  901 FORMAT(4I5)
  902 FORMAT(6F8.4)
  903 FORMAT(6I6)
  985 format(1h ,29h The unit cell parameters are /7x,2h A,9x,2h B,9x,2h
     1 C,/1x, 3f11.4/5X,6H ALPHA,5X,6H BETTA,5X,6H GAMMA/1X,3F11.4)
  988 FORMAT(1H ,4(I3,1X,I3,2E12.4))
  989 FORMAT(1H ,3X,34H The angle between the two axis is ,f8.3,2x,
     18H degrees)
  990 FORMAT(1H ,3X,' Axis along the ' ,3i2,'  reflection is ',
     1F8.3,' Angstroms long')
 5000 FORMAT(2I1)
 6677 FORMAT(5x,'Average projected potential for slice ',i5,' is ',
     $ e14.8,' Volts'/5x,'Sum of zero Fourier coeff',
     2 'icients ',11x,'is ',e14.8,' Volts')
 6789 FORMAT('  No. of slices=',i5,' : Dimensions of calculation=',i5)
 6798 FORMAT(/5x,'Slice ',i3,' has ',i3,' type(s) of atoms.')
C
C Copyright (C) 1987:  Northwestern University,  All Rights Reserved
C
       END
