	Logical function pattcheck(IH,IK,NUSE,AHKL,symm)
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
	dimension IH(*),IK(*),AHKL(*)
	character*4 symm
	dimension XT(6),YT(6)
C       Angular tolerance
        parameter (tol=1.5)
         LOGICAL PATTON
         COMMON /MOPTS/ PATTON, PLUS1, PLUS2, PLUS3, PLUS4, PLUS5
        pattcheck=.true.
	IF(.NOT.PATTON)THEN
		pattcheck=.false.
		return
	ENDIF
C	Check if we have a Patterson
C	Later, add specific checks using symm
C	For now, just test NUSE angles
	call ptran(XT,YT,NN,symm)
C       Loop over different translations
	DO N=1,NN
	ITRAP=0
	DO I=1,NUSE
	ANG=AHKL(I)
C       Shifted origin possibility
	IPATT=NINT(IH(I)*XT(N)+IK(I)*YT(N))
	DIFF=ABS(ANG-IPATT)
	ID=NINT(DIFF)
	DIFF=DIFF-(ID/360)*360
	IF(DIFF.lt.-tol)DIFF=DIFF+360
	IF(DIFF.gt.(360-tol))DIFF=DIFF-360
        IF (ABS(DIFF).gt.tol)THEN
		ITRAP=1
		GOTO 10
	ENDIF
	ENDDO
10	IF(ITRAP.EQ.0)then
		pattcheck=.true.
	else
		pattcheck=.false.
	endif
	if(pattcheck)return
	enddo		
	end
	subroutine ptran(XT,YT,N,SYMM)
C       Generate origin-shift terms in angles
	character*4 Symm
	dimension XT(*),YT(*)
C       No shift case - at origin
	XT(1)=0
	YT(1)=0
	N=1
C	p3 cases
	if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')then
C	1/3,2/3 translation
		XT(2)=120
		YT(2)=240
C	2/3,1/3 translation
		XT(3)=240
		YT(3)=120
		N=3
        else if(symm(1:2).eq.'p2')then
                XT(2)=180
                YT(2)=0
                XT(3)=0
                YT(3)=180
                XT(4)=180
                YT(4)=0
                N=4
        else if(symm(1:2).eq.'c2')then           
                XT(2)=180
                YT(2)=0
                N=2
        else if(symm(1:2).eq.'p4')then
                XT(2)=180
                YT(2)=180
                N=2
	endif
	return
	end
