C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE TRS2D (IH, K, FHK, AHK, NREF, SYMM, NHK, C, M )
C
C     Reset c to correct values
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2), AHK(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         CHARACTER*4 SYMM
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         INTEGER II1, II2
         LOGICAL LL1
         COMPLEX CC1, CC2, CC3, CC4, CC5, CC6, CC7, CC8
 
C     Origin for arrays (for consistency with FFT's)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ASIN (1.D0) * 2.D0
 
         DO   J=1,M(1)*M(2)
           C(J) = (0., 0.)
         END DO
         II2 = M(1)
         FMAX=FHK(1)
C     setup in c the symmetry related values
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AHK(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (AHK(J) / PI)
             IF (NINT (AHK(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.
             SINAN = 0.
             F = 1.
           ELSE IF (ABS (ANG) .LT. 1D-4) THEN
             F = 0.
             COSAN = 0.
             SINAN = 0.
           ELSE
             IF (FHK(J) .GT. FMAX) FMAX = FHK(J)
             COSAN = COS (ANG) * FHK(J)
             SINAN = SIN (ANG) * FHK(J)
           END IF
 
C     Information about symmetry coding of phases
           LL1 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
           II1 = II2
           CC1 = CMPLX (COSAN, -SINAN)
           CC2 = CMPLX (COSAN, 0.D0)
           CC3 = CMPLX (0.D0, SINAN)
           CC4 = CMPLX (COSAN, SINAN)
           CC5 = -CC4
           CC6 = -CC1
           CC7 = -CC2
           CC8 = CMPLX (0.D0, -SINAN)
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (LL1) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
C             ihjj=2*he(je)+n1c
C             ikjj=2*ke(je)+he(je)+n2c
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * II1 + IHJJ
C       write(10,*)'PUT TO ',ihjj,ikjj,he(jj),ke(jj),
C     $     ihjj-n1c,ikjj-n2c,ise(jj),ind
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CC1
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CC2
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CC3
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CC4
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = CC5
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = CC6
 
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = CC7
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CC8
             END IF
           END DO
 
C     endif
         END DO
 
         RETURN
       END
 
