C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       REAL FUNCTION TONE (IH, K, NREF, SYMM, NHK, C, M, TOL, RMAX, AA,
     X    BB, AB, IOPT )
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
C
C     generate an approximate mask iteratively in wts
         DIMENSION IH(NHK2), K(NHK2), FCALC(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         CHARACTER*4 SYMM
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         INTEGER II1, II2
         LOGICAL LL1, LL2
         COMPLEX CC1, CC2, CC3, CC4, CC5, CC6, CC7
 
C     Exponential Mask
         DO   J=1,NREF
           RR = IH(J) * IH(J) * AA + K(J) * K(J) * BB + IH(J) * K(J) *
     X        AB
C     wts(j)=exp(-RR/RMAX)
           WTS(J) = 1 - SQRT (RR / RMAX)
         END DO
 
C     setup fft tables
         CALL PBUF2 (M)
 
C     Make sure that iopt=13 (slow development) uses iopt=12
C     window
         IUSE = IOPT
 
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
         CC1 = CMPLX (0.D0, 0.D0)
 
C     setup in fo and ag the symmetry related values
C     zero beams
         DO   J=1,M(1)*M(2)
           C(J) = CC1
         END DO
 
C     setup in fo and ag the symmetry related values
         PI = ASIN (1.D0) * 2.D0
         II2 = M(1)
         CC7 = CMPLX (0.D0, 0.)
         DO   J=1,NREF
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = WTS(J)
           COSAN = WTS(J)
 
C     Information about symmetry coding of phases
           LL1 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
           II1 = II2
           CC2 = CMPLX (COSAN, 0.)
           CC3 = CMPLX (COSAN, 0.D0)
           CC4 = CC7
           CC5 = -CC2
           CC6 = -CC3
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (LL1) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
C             ihjj=2*he(je)+n1c
C             ikjj=2*ke(je)+he(je)+n2c
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * II1 + IHJJ
C       write(10,*)'PUT TO ',ihjj,ikjj,he(jj),ke(jj),
C     $     ihjj-n1c,ikjj-n2c,ise(jj),ind
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CC2
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CC3
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CC4
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CC2
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = CC5
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = CC5
 
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = CC6
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CC4
             END IF
           END DO
 
         END DO
 
C     Perform the transformation
         CALL ESHP2D (N1,N2,M,C,IUSE,POSRSCL)
 
C     Outer loop for target reflection
         SUM1 = 0.
         SUM2 = 0.
         SUM3 = 0.
         DO   I=1,NREF
           IF (IH(I) .NE. 0 .OR. K(I) .NE. 0) THEN
             CALL EQUIV2 (HE,KE,ISE,IH(I),K(I),NE,SYMM)
             NAV = 0
             FC = 0.
             LL2 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
             DO   JE=1,NE
C     Average over equivalents
               IF (ISE(JE) .EQ. 1 .OR. ISE(JE) .EQ. 3) THEN
                 NAV = NAV + 1
C           trap problems with p3 symmetry to give rectangular axes
                 IF (LL2) THEN
                   CALL P3EXP (IHJJ,IKJJ,HE(JE),KE(JE))
                   IHJJ = IHJJ + N1C
                   IKJJ = IKJJ + N2C
                 ELSE
                   IHJJ = HE(JE) + N1C
                   IKJJ = KE(JE) + N2C
                 END IF
                 IND = (IKJJ - 1) * N1 + IHJJ
                 FC = FC + C(IND)
               END IF
             END DO
             FC = FC / FLOAT (NAV)
             FCALC(I) = FC
             SUM1 = SUM1 + NE * FC * FC
             SUM2 = SUM2 + NE * FC * WTS(I)
             SUM3 = SUM3 + WTS(I) * WTS(I) * NE
           END IF
 
         END DO
 
C     Relative scaling of fcalc and input
         SCALE = SUM2 / SUM1
C     Error
         SUM = 0.
         DO   I=1,NREF
           IF (IH(I) .NE. 0 .OR. K(I) .NE. 0) THEN
             IHH = IH(I)
             IKK = K(I)
             CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
             ERR = WTS(I) - FCALC(I) * SCALE
C           if(tlog(2))then
             SUM = SUM + ERR * ERR * MULTI(I)
           END IF
C           else
C              sum=sum+err*err
C           endif
         END DO
         TONE = SQRT (SUM / SUM3)
C     remove fft tables
         CALL DPLN2D
         RETURN
       END
 
