C	General 2D trim code
C
C  Copyright (c) 2003 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
	program trim2D(filen)
	character*60 filen
	integer h(5000),k(5000),hmax
	dimension f(5000)
	logical p3,rt
	open(unit=11,file=filen)
        open(unit=12,file='trim.hkl')
	open(unit=13,file='skip.hkl')
        write(6,9)'Enter cell axes (A,B) & angle (degrees)'
        read(5,*)a,b,ang
        aa=1./(a*a)
        bb=1./(b*b)
C	Convert to reciprocal
	angr=180-ang
C	Convert to radians
	pi2=asin(1.0d0)
	angr=angr*pi2/90
C	Reciprocal space units
C	A.a = B.b = 1 ; A.b=B.a=0
C	A.a = |A||a|cos(pi/2-angr)
	arec=1./(cos(pi2-angr)*a)
	brec=1./(cos(pi2-angr)*b)
	aa=arec*arec
	bb=brec*brec
	ab=2.*cos(angr)*arec*brec
        fmax=0
	  r2d=0
	  hmax=0
	  kmax=0
        n=0
C	Read in data an find ranges
        do j=1,9999
        read(11,*,err=201,end=201)h(j),k(j),ll,f(j)
        if(f(j).gt.fmax)fmax=f(j)
        r2=h(j)*h(j)*aa+k(j)*k(j)*bb+ab*h(j)*k(j)
	  if(r2.gt.r2d)r2d=r2
	  if(abs(h(j)).gt.hmax)hmax=abs(h(j))
	  if(abs(k(j)).gt.kmax)kmax=abs(k(j))
        n=n+1
        enddo
201	write(6,*)'Max values along h,k are',hmax,kmax
	r2d=sqrt(r2d)
	write(6,*)'Maximum 2D sampling',1./r2d,' Angstroms'

	write(6,9)' Enter 2D resolution to use (e.g. 1 Angstrom)'
9	format(a,'_',$)
	read(5,*)res
	res=1./res
        write(6,9)' Convert from I to F (i.e. take sqrt), enter > 0'
        read(5,*)trt
        rt=.false.
        if(trt.gt.0)rt=.true.
	num=0
	num1=0
	do j=1,n
	r=h(j)*h(j)*aa+k(j)*k(j)*bb+h(j)*k(j)*ab
	if(r.gt.1e-3)r=sqrt(r)
        ft=f(j)
        if(rt)then
                if(ft.gt.1e-6)ft=sqrt(ft)
        endif
	rr=0
	if(r.gt.1e-3)rr=1./r
        if(r.le.res)then
		write(12,1)h(j),k(j),0,ft,0,r,rr
		num=num+1
	else
		write(13,1)h(j),k(j),0,f(j),0,r,rr
		num1=num1+1
	endif
1	format(3i5,f13.7,f7.1,4f12.3)
	enddo
	write(6,*)'Number of reflections ',num
	write(6,*)'Skipped ',num1
	end
