C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE CMPGEN (PARAM, FOMF, ASK, CHILDN, NGOT, IFIT, KCNT )
C  mparam: maximal number of parameters
C  mnbits: maximal number of bits allowed to describe one parameter
C     This is fixed at 1 for binary data !
C  mindiv: maximal number of chromosomes per population
C         PARAMETER (MPARAM = 80, MNBITS = 4, MINDIV = 2000)
        INCLUDE 'CrossPars.h'
C
C  Current limits
C     mparam to 30 - may need to be increased
C     mnbits to 6  - Increased from 8 to 10 for multislice use
C     Number of members - 500
C     Number of children - 4*mindiv (2400)
         PARAMETER (MCHILD = MINDIV)
C     Note: mnbits*mparam appears in several array declarations
C
C     nhk2 for total number of beams (also must change nhk !
C        PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         include 'Nbeams.h'
C         LOGICAL XRAY
         DIMENSION LL(9)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
 
 
         DIMENSION PARS(MPARAM), FOMF(*), ASK(MCHILD,MPARAM)
         INTEGER CHILD, PARAM, CHILDN, IFIT(*)
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
         DOUBLEPRECISION DD1
         PARAMETER (DD1 = -0.2D0)
         INTEGER II1
         REAL RR1
C     Compare input and already calculated
         OPEN (UNIT=12, FILE='calculated.log')
         OPEN (UNIT=13, FILE='popw')
C        write(6,*)'Debug ',param,childn,child
C     Trap in case the number of children smaller than expected
         CHILD = 0
         DO   J=1,CHILDN
           READ (13, 30, END=99, ERR=99) (PARS(K), K=1,PARAM)
   30      FORMAT(8X,200F8.4)
           FOMF(J) = (-1.)
           IFIT(J) = (-1)
           CHILD = CHILD + 1
           DO   II1=1,PARAM
             RR1 = PARS(II1)
             ASK(J,II1) = RR1
           END DO
         END DO
         KCNT = 0
   99    NGOT = 0
 
  100    CONTINUE
         READ (12, *, END=1000, ERR=1000) IP, FOM, (PARS(K), K=1,PARAM)
         KCNT = KCNT + 1
 
         DO   J=1,CHILD
C       Skip if already set (duplicates in calculated.log?)
           IF (FOMF(J) .LE. DD1) THEN
             DO   K=1,PARAM
               IF (ABS (PARS(K) - ASK(J,K)) .GT. 0.2D0) GO TO 200
             END DO
C     We get here if there is a match
             FOMF(J) = FOM
             IFIT(J) = KCNT
             NGOT = NGOT + 1
C     If we have found everything, jump out
             IF (NGOT .EQ. CHILD) GO TO 1000
           END IF
C     goto 300
 
C     Go to the next individual
  200      CONTINUE
C     write(10,*)'Missed:',(icalc(k),k=1,param)
         END DO
 
C     Let's look at the next one
         GO TO 100
 
 1000    CONTINUE
C     count to the end of calculated.log
         DO   J=1,9999999
           READ (12, *, ERR=1010, END=1010) IP, FOM
           KCNT = KCNT + 1
         END DO
 1010    CONTINUE
C     Now we have everything possible
         CLOSE (UNIT=12)
         CLOSE (UNIT=13)
         RETURN
       END
