C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
       subroutine ERRNT2 (FHK, FCALC, ACALC, NREF, IH, K, SCAL, AOLD )
C      subroutine errrob(fhk,fcalc,acalc,nref,ih,k,scal,aold)
C
C     Given fhk as the input
C     fcalc and acalc (cos of difference)
C     Calculate the residual with various approximations
C     Note: this version compensates for a possible error
C     in the earlier form with non-centrosymmetric cases
        common /ecalcd/dferr1,dferr2
        COMMON /ECALC/SFERR1, ANGERR, SFERR2
C       common /ecalcd2/duerr,duerr2
            double precision dferr1,dferr2
            double precision dcalc,dfhk,dacalc
            double precision dsumu1,dsumu3,scale
            double precision erru0,erru1,err
            dimension fhk(*),fcalc(*),acalc(*),ih(*),k(*)
           dimension aold(*)
C     Options common block
C      include 'Params3.h'
C      include 'controls.h'
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
      real*8 fu1(nhk2),fu2(nhk2),fu3(nhk2)

C     Test
C     Squares case first
      dsumu1=0.
      dsumu3=0.
      nm=0
      do j=1,nref-1
C     If a beam is undefined, we should not use it for the scaling
C     However, we should still use it for the error
C     Thus, do TWO passes in general
C           a) To generate the scaling
C           b) To get the error
      if(aold(j).gt.0.1)then
         dcalc=fcalc(j)
         dacalc=acalc(j)
         dfhk=fhk(j)
         dsumu1=dsumu1+dcalc*dacalc*dfhk
         dsumu3=dsumu3+dcalc*dcalc
C     Robust terms for later
         nm=nm+1
         fu1(nm)=dfhk*dfhk
         fu2(nm)=dcalc*dcalc
         fu3(nm)=dcalc*dfhk*2.d0*dacalc
      endif
      enddo
      
C	If dsum3 is very small, we have nothing - crash!
	if(abs(dsumu3).lt.1d-10)then
 		write(10,*)'Panic attack - looks like nothing!'
C	Let's return now
                sferr2=1e2
                sferr1=1e2
                dferr2=1e2
                dferr1=1e2
                scal=1
                return
	endif
C     Estimage of scale
      scale=dsumu1/dsumu3
	if(scale.lt.-1e-5)then
		write(10,*)'Panic attack - scale negative!'
C	Let's return now
                sferr2=1e2
                sferr1=1e2
                dferr2=1e2
                dferr1=1e2
                scal=1
                return
	endif

C     Golden Search
        call scalecalc(fu1,fu2,fu3,nm,scale,erru)
      
C     Trap scale as positive
      scale=abs(scale)
C       else
C       scale=0
C       endif

10    erru0=0.0
      erru1=0.0
      do j=1,nref-1
         dcalc=dble(fcalc(j))*scale
         dacalc=acalc(j)
         dfhk=fhk(j)
C     Trap here to make undefined as bad as reasonable
C       Avoid treating just defined as good
         if(aold(j).lt.0.1)then
              err=dfhk*dfhk+dcalc*dcalc
         else
              err=dfhk*dfhk+dcalc*dcalc
     $          -2.d0*dcalc*dacalc*dfhk
         endif
            erru1=erru1+sqrt(abs(err))
            erru0=erru0+dfhk
      enddo
      aerru1=10.0d0*erru1/erru0
C     Which one to use ?
C     Unitary term, with window
      sferr2=aerru1
      sferr1=aerru1
      dferr2=sferr2
      dferr1=sferr1
      scal=scale
      return
      end
C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
       subroutine ERRFIX (FHK, FCALC, ACALC, NREF, IH, K, SCAL, AOLD )
C
C     Given fhk as the input
C     fcalc and acalc (cos of difference)
C     Calculate the residual with fixed scale of 1
        common /ecalcd/dferr1,dferr2
        COMMON /ECALC/SFERR1, ANGERR, SFERR2
        dimension fhk(*),fcalc(*),acalc(*),aold(*)
        real*8 dferr1,dferr2
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
      erru0=0.0
      erru1=0.0
      do j=1,nref-1
         dcalc=dble(fcalc(j))
         dacalc=acalc(j)
         dfhk=fhk(j)
C     Trap here to make undefined as bad as reasonable
C       Avoid treating just defined as good
         if(aold(j).lt.0.1)then
              err=dfhk*dfhk+dcalc*dcalc
         else
              err=dfhk*dfhk+dcalc*dcalc
     $          -2.d0*dcalc*dacalc*dfhk
         endif
            erru1=erru1+sqrt(abs(err))
C            erru1=erru1+err
            erru0=erru0+dfhk !*dfhk
      enddo
      aerru1=10.0d0*erru1/erru0
C     Which one to use ?
C     Unitary term, with window
      sferr2=aerru1
      sferr1=aerru1
      dferr2=sferr2
      dferr1=sferr1
      scal=1
      return
      end
