C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPM2D (N1, N2, M, C, MPROJ )
C      This version just applies the model, nothing else
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C       For Debugging
C         CHARACTER*50 FORMT
C         CHARACTER*78 TITLE,TITLE2
C         data idebout/0/
C         save idebout
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
           END DO
         END DO
C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(0.25,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C       Debug output
C         if(Idebout .eq. 0)then
C         idebout=1
C         FORMT = '((20e10.3))     '
C         TITLE = ' '
C           OPEN (UNIT=80, FILE='Model.semp')
C           OPEN (unit=81, FILE='Filter.semp')
C           OPEN (unit=82, FILE='Current.semp')
C           DO JJJ=80,82
C             WRITE (jjj, 140) N1, N2, 1, 1, 2, 20, FORMT
C             WRITE (jjj, 141) TITLE2(1:20)
C   30    FORMAT(20E10.3)
C  140    FORMAT(6I6,1X,A20)
C  141    FORMAT(A)
C          ENDDO
C          JK = 0
C           DO   I=1,N2
C     Output a line
C             WRITE (80, 30) (aimag(C(JK+J)), J=1,N1)
C             write (81, 30) (FILT(JK+J), J=1,N1)
C             write (82, 30) (real(C(JK+J)), J=1,N1)
C             JK= JK + N1
C           END DO
C          ENDIF
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               X = (EA*(1-FILT(JK)) + EM*FILT(JK)) * FTEMP
               C(JK) = X * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               X =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               X = XC * FILT(JK) + (1 - FILT(JK)) * X
               C(JK) = MAX (DBLE (X), 0.D0) * FAC
    2          CONTINUE
         END IF
 
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
C
       SUBROUTINE modelsharp (N1, N2, M, C, MPROJ )
C      This version returns the model in the imaginary part
C      The conventional entropy in the real part
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO, UFLIP
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C       For Debugging
         CHARACTER*50 FORMT
         CHARACTER*78 TITLE,TITLE2
         data idebout/0/
         save idebout
         parameter (overrel = 1.5)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip  .gt. 1e-4)then
                uflip=.true.
                XFLIP=FLIP/DBLE(N1*N2)
C                XFLIP=0.01*FLIP/(STOE*STOE)
         else
                XFLIP=1./DBLE(N1*N2)
         endif
C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
           END DO
         END DO
C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
C        write(10,*)'Model Scale ',S1/S2
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
               SCL = MIN(cutmodel2,SCL)
        ELSE
               SCL = 2
        ENDIF
C       Debug output
C         if(Idebout .eq. 0)then
C         idebout=1
C         FORMT = '((20e10.3))     '
C         TITLE = ' '
C           OPEN (UNIT=80, FILE='Model.semp')
C           OPEN (unit=81, FILE='Filter.semp')
C           OPEN (unit=82, FILE='Current.semp')
C           DO JJJ=80,82
C             WRITE (jjj, 140) N1, N2, 1, 1, 2, 20, FORMT
C             WRITE (jjj, 141) TITLE2(1:20)
C   30    FORMAT(20E10.3)
C  140    FORMAT(6I6,1X,A20)
C  141    FORMAT(A)
C          ENDDO
C          JK = 0
C           DO   I=1,N2
C     Output a line
C             WRITE (80, 30) (aimag(C(JK+J)), J=1,N1)
C             write (81, 30) (FILT(JK+J), J=1,N1)
C             write (82, 30) (real(C(JK+J)), J=1,N1)
C             JK= JK + N1
C           END DO
C          endif
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF*XMEAN
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               EM = (EA*(1-overrel*FILT(JK)) + EM*FILT(JK))*overrel
               C(JK) = cmplx(EA,EM) * FAC
             END DO
           END DO
         ELSE
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = XC * FILT(JK)*overrel + (1 - overrel*FILT(JK)) * XR
C     Entropy term for solution
               XR = XR/XMEAN
               IF (XR .GT. 1D-6) THEN
                 XR = XR * LOG (XR) *XMEAN
               ELSE
                 XR = 0.
               END IF
             IF(UFLIP .AND. (XI .LT. XFLIP))then
                XI=-XI
             ELSE
                XI = MAX(XI, 0.0)
             endif
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF
               C(JK) = CMPLX(XR,XI)
    2          CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
C

       SUBROUTINE modelsharp0 (N1, N2, M, C, MPROJ )
C      This version returns the model in the imaginary part
C      The conventional entropy in the real part
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO, UFLIP
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
        parameter (overrel = 1.5)
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip  .gt. 1e-4)then
                uflip=.true.
                XFLIP=FLIP/DBLE(N1*N2)
C                XFLIP=0.01*FLIP/(STOE*STOE)
         else
                XFLIP=1./DBLE(N1*N2)
         endif
C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
           END DO
         END DO
C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
C        write(10,*)'Model Scale in zero ',S1/S2
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
        ELSE
               SCL = 1
        ENDIF
C     X*ln(X) case only
         JK = 0
         MF = (-1)
C     Projection ?
         IF (MPROJ) THEN
           SCL=SCL/XMEAN
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF*XMEAN
               X = REAL(C(JK))/ XMEAN
               XC = AIMAG (C(JK))*SCL
C     Entropy term for model
               IF (XC .GT. 1D-6) THEN
                 EM = XC * LOG (XC)
               ELSE
                 EM = 0.
               END IF
C     Entropy term for solution
               IF (X .GT. 1D-6) THEN
                 EA = X * LOG (X)
               ELSE
                 EA = 0.
               END IF
C     Add the two, filter character
               EM = (EA*(1-overrel*FILT(JK)) + overrel*EM*FILT(JK))
               C(JK) = cmplx(EM,EM) * FAC
             END DO
           END DO
         ELSE
C           We use this one except in peaks
           DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = overrel*XC * FILT(JK) + (1 - overrel*FILT(JK)) * XR
C     Entropy term for solution
               XR = XR/XMEAN
               IF (XR .GT. 1D-6) THEN
                 XR = XR * LOG (XR) *XMEAN
               ELSE
                 XR = 0.
               END IF
             IF(UFLIP .AND. (XI .LT. XFLIP))then
                XI=-XI
             ELSE
                XI = MAX(XI, 0.0)
             endif
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF
               C(JK) = CMPLX(XI,XI)
    2          CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
C

