C       General 2D trim code
C
C       program trim2D(filen)
        character*60 filen
        character*100 line
        parameter (nptmax=5000)
        integer h(nptmax),k(nptmax),hmax
        dimension f(nptmax),err(nptmax),ang(nptmax)
        logical p3,rt,eok,wien,haverr,purge
        character*1 yon
        character*20 yon2
         wmag = 1.0D0
         NUMBER = 1
         CALL GETARG (NUMBER,FILEN)
        open(unit=11,file=filen)
        open(unit=12,file='trim.hkl')
        open(unit=13,file='skip.hkl')
        write(6,9)'Enter cell axes (A,B) & angle (degrees)'
        read(5,*)a,b,angr
        aa=1./(a*a)
        bb=1./(b*b)
        angi=angr
C       Convert to reciprocal
        angr=180-angr
C       Convert to radians
        pi2=asin(1.0d0)
        angr=angr*pi2/90
C       Reciprocal space units
C       A.a = B.b = 1 ; A.b=B.a=0
C       A.a = |A||a|cos(pi/2-angr)
        arec=1./(cos(pi2-angr)*a)
        brec=1./(cos(pi2-angr)*b)
        aa=arec*arec
        bb=brec*brec
        ab=2.*cos(angr)*arec*brec
        if(abs(angi-120).lt.1e-3)then
                ab=aa
                bb=aa
        else if(abs(angi-90).lt.1e-3)then
                ab=0
        endif
C       write(6,*)aa,bb,ab,aa/ab
        fmax=0
          r2d=0
          hmax=0
          kmax=0
        n=0
C       Are there errors ?
        haverr=.false.
        read(11,77)line
        rewind(unit=11)
        read(line,*,err=301,end=301)i1,i2,i3,ft,at,et
        haverr=.true.
301     continue
77      format(a)
C       Read in data an find ranges
        do j=1,9999
        if(haverr)then
        read(11,*,err=201,end=201)h(j),k(j),ll,f(j),ang(j),err(j)
        else
        read(11,*,err=201,end=201)h(j),k(j),ll,f(j),ang(j)
        err(j)=1
        endif
        if(f(j).gt.fmax)fmax=f(j)
        r2=h(j)*h(j)*aa+k(j)*k(j)*bb+ab*h(j)*k(j)
          if(r2.gt.r2d)r2d=r2
          if(abs(h(j)).gt.hmax)hmax=abs(h(j))
          if(abs(k(j)).gt.kmax)kmax=abs(k(j))
        n=n+1
        if(n.eq.nptmax)then
                write(6,*)'Maybe more than ',nptmax,' Values'
                write(6,*)'You may have to recompile trim2D'
        endif
        enddo
201     write(6,*)'Max values along h,k are',hmax,kmax
        r2d=sqrt(r2d)
        write(6,*)'Maximum 2D sampling',1./r2d,' Angstroms'

        write(6,9)' Enter 2D resolution to use (e.g. 1 Angstrom)'
9       format(a,'_',$)
        read(5,*)res
        res=1./res
C        write(6,9)' Lower 2D cut to use (-ve for none)'
C        read(5,*)resL
C        if(resL.gt.1e-5)then
C                resL=1./resL
C        else
                resL=-1
C        endif
        write(6,9)' Convert from I to F (i.e. take sqrt), enter > 0'
        read(5,*)trt
        rt=.false.
        if(trt.gt.0)rt=.true.
        wien=.false.
        write(6,9)' Wiener filter (Y/N/Number for strength e.g. 1.5)'
        read(5,99)yon2
        purge=.true.
99      format(a)
        wmag=1
        if(yon2(1:1).eq.'y'.or.yon2(1:1).eq.'Y')then
                wien=.true.
        else if(yon2(1:1) .eq.'n'.or.yon2(1:1).eq.'N')then
                wien=.false.
        else if(yon2(1:1) .eq.'p'.or.yon2(1:1).eq.'P')then
                wien=.true.
                purge=.false.
        else
                read(yon2,*,err=991,end=991)ww
                wmag=ww
                wien=.true.
                if((wmag .lt. 0).or.(wmag.gt.5))wmag=1
991             continue
        endif
C        read(5,*)ecut
C        ecut=ecut*fmax/100.d0
C        if(ecut.lt.fmax)then
C                write(6,9)'I/sigma ration (3)'
C                read(5,*)sigratio
C        endif
C        write(6,*)'Check ',ecut,fmax
        num=0
        num1=0
        cut=1e-5
        if(.not.purge)cut=-100
        do j=1,n
        eok=.true.
C        if(((err(j)*sigratio).gt.f(j)).and.(err(j).gt.ecut))eok=.false.
        r=h(j)*h(j)*aa+k(j)*k(j)*bb+h(j)*k(j)*ab
        if(r.gt.1e-5)r=sqrt(r)
        ft=f(j)
        e2=err(j)*err(j)*wmag
        s2=max(ft*ft-e2,0.0)
        wfilt=s2/(s2+e2)
        if(rt)then
                wfilt=sqrt(wfilt)
                if(ft.gt.1e-6)ft=sqrt(ft)
        endif
        if(.not.wien)wfilt=1.D0
        rr=0
        if(r.gt.1e-3)rr=1./r
        if((r.le.res).and.(r.gt.resL))then
C           if(ft*wfilt .gt. cut)then
                write(12,1)h(j),k(j),0,ft*wfilt,ang(j),r,ft,wfilt
                num=num+1
C           endif
        else
                write(13,1)h(j),k(j),0,f(j)*wfilt,ang(j),
     1          r,f(j),err(j)
                num1=num1+1
        endif
1       format(3i5,f15.9,f9.1,6f12.3)
        enddo
        write(6,*)'Number of reflections ',num
        write(6,*)'Skipped ',num1
        end

        
