      subroutine weight2(NSET,NRNG,MINPTS,
     1  IPIVOT,IFAIL)
C
C     Calculate scale with simple weighting of any sort
C     Input
C            F          Array of measurements
C            WT         Array of relative weights for each pt
C            NSET       Number of Sets
C            NRNG       Range to scan
C            MINPTS     Minimum number of common pts (2-3)
C            IPIVOT     Reference set (scaled to 1)
C            SCL        Previous scale estimate
C
C     Output
C            SCL        Scale (scl(IPIVOT) unchanged
C            IFAIL      =0 for success
C
C     Temporary
C            AA(NSET,NSET), A(NSET-1,NSET-1), AT(NSET-1,NSET-1)
C
      implicit real*8 (a-h,o-z)
      include 'msizes.h'
      dimension grad(200)
      dimension B(200),G(200),WA(200),WB(200)
      logical found(200)
      dimension SCLT(200)

      do j=1,NSET
              G(J)=0
              do K=1,NSET
                 AA(J,K)=0
              enddo
      enddo
      do j=-Nxmax,Nxmax
          do k=-Nymax,Nymax
              ii=0
              do i=1,NSET
                 if( F(i,j,k).gt.-1)then
                     ii=ii+1
                     found(i)=.true.
                     WA(I)=F(i,J,K)
                     WB(I)=WT(i,j,k)
                 ELSE
                     found(i)=.false.
                 ENDIF
              enddo
              if(ii.ge.minpts)then
                 call matder(found,wa,wb,NSET,grad)
                 DO J1=1,NSET
                     G(J1)=G(J1)+grad(J1)
                     DO J2=1,NSET
                         AA(J1,J2)=AA(J1,J2)+at(j1,j2)
                     ENDDO
                 ENDDO
C              End of loop for spots
               endif
C              End of J,K look
          enddo
      enddo
C
C     Invert the matrix, using IPIVOT as the refernece
      J1=0
      RSCL=1.D0/(Nxmax*Nymax)
      DO J=1,NSET
              IF(J.NE.IPIVOT)THEN
                 J1=J1+1
                 K1=0
                 DO K=1,NSET
                   IF(K.NE.IPIVOT)THEN
                     K1=K1+1
                     A(J1,K1)=AA(J,K)*RSCL
                   ENDIF
                 ENDDO
                 B(J1)=-AA(J,IPIVOT)*RSCL
              ENDIF
      ENDDO
      NP=NSET-1
      call minverse ( A, NP, NSMAX, IFAIL )
      if(ifail .ne. 0)return
C     Relative scaling terms
      DO J=1,NSET-1
              SCLT(J)=0
              DO K=1,NSET-1
                 SCLT(J)=SCLT(J)+A(J,K)*B(K)
              ENDDO
      ENDDO
      J1=0
      DO J=1,NSET
             IF(J .NE. IPIVOT)THEN
C                SCL(J)=1
C             ELSE
                J1=J1+1
                SCL(J)=SCLT(J1)
             ENDIF
C             write(6,*)j,scl(j)
      ENDDO
C
      RETURN
      END
