/*
  mb_debug.h
 */
typedef struct {
  FILE *fp, *gfp, *vfp, *efp, *dump, *fo_log;
  char infile[128], tmpfile[128];
  int eigval_dump_flag, eigvec_dump_flag, sg_dump_flag, betag_dump_flag,
  reflex_dump_flag, reflex_only_flag, vg_dump_flag,
  a_mat_dump_flag, b_mat_dump_flag,
  b_cond_dump_flag, bc_chk_flag, all_int_out_flag,
  covar_dump_flag, alpha_dump_flag, beta_dump_flag, obs_cal_dump_flag,
  ideal_cr_cal_flag, atm_pos_out_flag, 
  vg_sel_chk_flag, process_mon_flag, forecast_flag, wg_xig_list_flag,
  print_bij_flag, chk_data_dump_flag;
} DEBUG_INFO;

/* ----- */

void read_ini_file(void);
/* void close_ini_file(void); */
void dbg_dump_ini_fit(void);
void dbg_dump_ini_sim(void);
void dbg_mon(char *str);

void dbg_atm_pos_out( CRYSTAL_STRCT_DATA *csd, char *infile );
void dbg_print_recom_bij(int n_atom, ATOM *atm, CELL_PAR bv);
void debug_vg_dump(complex **vg, int num_beam);

void dbg_i_crdata_output( CRYSTAL_STRCT_DATA *csd );
void dbg_i_caldata_output( int maxnum_iter, int num_exp_dataset, FIT_EXP_DATASET *fed );
void reflex_dump(
  int ith_expdata, int num_g_exact, int num_g_bethe, HKL reflex[],
  int flag_bs, BEAM_SEARCH_PAR beam_search,
  UVW incidence, R_HKL zolzbase1, CELL_PAR bv
  );
void reflex_dump_csd(
  int ith_expdata, int num_g_exact, int num_g_bethe, HKL reflex[],
  CRYSTAL_STRCT_DATA *csd, BEAM_SEARCH_PAR beam_search,
  UVW incidence, R_HKL zolzbase1, double kvolts, CELL_PAR bv
  );
void exec_time_forecast(long ind);
/*void exec_progress(int *progress_ratio, long ith, long num_iter);*/

void dbg_print_cmat(int flag, char *comment, int n, complex **a);
void dbg_print_cvec(int flag, char *comment, int n, complex *v);
void dbg_print_dmat(int flag, char *comment, int n, double **a);
void dbg_print_dvec(int flag, char *comment, int n, double *v);

/* Dump into *.dbg */
void dbg_dump_init();
void dbg_sel_vg_init( int ne, int nb );
void dbg_sel_vg_pos(int h, int g);
void dbg_sel_vg(
  R_HKL k_xy, int ne, int nb, int n_sel_exact, int n_sel_bethe,
  int *selinfo_nth_reflex
  );
void dbg_dump_term(void);

void message_exit_faliure(void);
void read_eps_ctrl_params( FILE *fi );
void fprintf_eps_ctrl_params( FILE *fo );
