#
# mbutl.mk
# makefile
#

## OBJ extention ##
#EX = o
EX = obj
OBJ = mbutl.$(EX) mbu_intrct.$(EX) \
  atom_bk.$(EX) atomf.$(EX) cg.$(EX) cmatutil.$(EX) \
  complex.$(EX) mb_input.$(EX) data_out.$(EX) eig_mat.$(EX) inv_mat.$(EX) \
  lattice.$(EX) mbfunc.$(EX) rfsearch.$(EX) svd.$(EX) vecmat.$(EX) \
  mbu_output.$(EX) fitting.$(EX) cnstfunc.$(EX) mb_sim.$(EX) e_density.$(EX) \
  ts_scan.$(EX) perturb.$(EX) utils.$(EX) mb_debug.$(EX) strct_f.$(EX) \
  fitfunc.$(EX) mb_mpi.$(EX)

#### For alpha (264), single mode ####
#CFLAG = -O4 -fast -tune ev6 -arch ev6 -c
#CCMP = ccc
#mbutl : $(OBJ)
#	$(CCMP) -o mbutl -O4 -fast -tune ev6 -arch ev6 -lcpml $(OBJ)

#### For alpha (164), single mode ####
#CFLAG = -fast -arch generic -c
#CCMP = ccc
#mbutl : $(OBJ)
#	$(CCMP) -o mbutl -fast -arch generic -lcpml $(OBJ)

#### For win-PC (bcc32, debug trace by td32) ####
#CFLAG = -c -v
#CCMP = bcc32
#mbutl.exe : $(OBJ)
#	$(CCMP) -embutl.exe -v -lm  $(OBJ)

#### For Intel win PC (bcc32) ####
CFLAG = -O2 -c
CCMP = bcc32
mbutl.exe : $(OBJ)
	$(CCMP) -embutl.exe -O2 $(OBJ)

mbu_intrct.$(EX) : mbu_intrct.c
	$(CCMP) $(CFLAG) mbu_intrct.c

atom_bk.$(EX) : atom_bk.c
	$(CCMP) $(CFLAG) atom_bk.c

atomf.$(EX) : atomf.c
	$(CCMP) $(CFLAG) atomf.c

cg.$(EX) : cg.c
	$(CCMP) $(CFLAG) cg.c

cmatutil.$(EX) : cmatutil.c
	$(CCMP) $(CFLAG) cmatutil.c

complex.$(EX) : complex.c
	$(CCMP) $(CFLAG) complex.c

mb_input.$(EX) : mb_input.c
	$(CCMP) $(CFLAG) mb_input.c

data_out.$(EX) : data_out.c
	$(CCMP) $(CFLAG) data_out.c

eig_mat.$(EX) : eig_mat.c
	$(CCMP) $(CFLAG) eig_mat.c

inv_mat.$(EX) : inv_mat.c
	$(CCMP) $(CFLAG) inv_mat.c

lattice.$(EX) : lattice.c
	$(CCMP) $(CFLAG) lattice.c

mbfunc.$(EX) : mbfunc.c
	$(CCMP) $(CFLAG) mbfunc.c

rfsearch.$(EX) : rfsearch.c
	$(CCMP) $(CFLAG) rfsearch.c

svd.$(EX) : svd.c
	$(CCMP) $(CFLAG) svd.c

vecmat.$(EX) : vecmat.c
	$(CCMP) $(CFLAG) vecmat.c

mbu_output.$(EX) : mbu_output.c
	$(CCMP) $(CFLAG) mbu_output.c

mbutl.$(EX) : mbutl.c
	$(CCMP) $(CFLAG) mbutl.c

fitting.$(EX) : fitting.c
	$(CCMP) $(CFLAG) fitting.c

cnstfunc.$(EX) : cnstfunc.c
	$(CCMP) $(CFLAG) cnstfunc.c

mb_sim.$(EX) : mb_sim.c
	$(CCMP) $(CFLAG) mb_sim.c

e_density.$(EX) : e_density.c
	$(CCMP) $(CFLAG) e_density.c

ts_scan.$(EX) : ts_scan.c
	$(CCMP) $(CFLAG) ts_scan.c

perturb.$(EX) : perturb.c
	$(CCMP) $(CFLAG) perturb.c

srf.$(EX) : srf.c
	$(CCMP) $(CFLAG) srf.c

utils.$(EX) : utils.c
	$(CCMP) $(CFLAG) utils.c

mb_debug.$(EX) : mb_debug.c
	$(CCMP) $(CFLAG) mb_debug.c

strct_f.$(EX) : strct_f.c
	$(CCMP) $(CFLAG) strct_f.c

fitfunc.$(EX) : fitfunc.c
	$(CCMP) $(CFLAG) fitfunc.c

mb_mpi.$(EX) : mb_mpi.c
	$(CCMP) $(CFLAG) mb_mpi.c
