// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <math.h>
#include "header.h"
#include "storage.h"
#include "filenames.h"
#include "devices.h"
#include "menudef.h"
#include "globals.h"
#include "PhasegratingRecord.h"
#include "ProjCellRecord.h"
#include "funcdefs.h"
#include "graphics.h"
#define max(x,y) ((x) > (y) ? (x) : (y))
#define fabs(x) 	((x) < 0. ? -(x) : (x))
extern GDevice *OutDevice ;
#define OKAY 15
#define CANCEL 16
COMMAND choose_refl[10] = {{20,600,40,620,"","",set_refl}, 
							{20,560,40,580,"","",set_refl},
							{20,520,40,540,"","",set_refl},
							{20,480,40,500,"","",set_refl},
							{20,440,40,460,"","",set_refl},
							{20,400,40,420,"","",set_refl},
							{20,360,40,380,"","",set_refl},
							{20,320,40,340,"","",set_refl},
							{20,280,40,300,"","",set_refl},
							{20,240,40,260,"","",set_refl}} ;
COMMAND choose_phs = {500,200,520,220,"","",(FPVI)set_phs} ;
COMMAND choose_ampl= {500,600,520,620,"","",(FPVI)set_ampl} ;
COMMAND choose_int = {500,560,520,580,"","",(FPVI)set_int} ;
COMMAND choose_many= {500,400,520,420,"","",(FPVI)set_many}  ;
COMMAND choose_one = {500,360,520,380,"","",(FPVI)set_one};
COMMAND amplit_start = {20,0,420,50,"OKAY",""} ;
COMMAND choose_cancel = {500,0,900,50,"CANCEL",""} ;
COMMAND *amplit_menu_list[] = {&choose_refl[0],&choose_refl[1],&choose_refl[2],
		&choose_refl[3],&choose_refl[4],&choose_refl[5],&choose_refl[6],
		&choose_refl[7],&choose_refl[8],&choose_refl[9],&choose_ampl,
		&choose_int,&choose_many,&choose_one,&choose_phs,&amplit_start,
		&choose_cancel,&null} ;
MENUS amplit_menu[] = {&amplit_menu_list[0],(MENUS)&null} ;
MENUS *oldmenuptr ;
long ihw[10],ikw[10],ilw[10],IW,NW ; 
long ih[10],ik[10],il[10] ;
long INTENSITY,IMANY,PLOTPHS ;
extern short gPrintValues ;
void PlotAmplitudes() {
	float *zplot,*th,zrl,zim,*rp1,*rp2,*amp,
	*phase,ampmax[10],ampmin[10],phsmax[10] ;
	long i,j,iy,n,i0,ndx,ndxi ;
	long k,nbeam,mbeam,nslc,ierr ;
	float tst,ymax,ymaxp,ymaxa,acell,bcell,ccell,volt,slcth,gmax ;
	float xmax,ymin,ymax2,size,two,ymina,yminp ;
	char buffer[132] ;
	char title[80],ihead[80],ixname[80],iyname[80],ident[80],filename[80],
		ihkl[80],igmax[80],ivolt[80],stext[80],islcth[80] ;
	FILE *fp_aout,*fp ;
	GrafPtr tPort ;

	fp_aout=fopen(flname.aout,"r") ;
	if(fp_aout==NULL) {
		// Handle error codes
		ReportFileOpenError(flname.aout) ;
		return ;
	}

	zplot = gWorkSpace ;
	th = zplot+20000 ;
	amp = th+10000 ;
	phase = amp+10000 ;
	fread(title,40*sizeof(char),1,fp_aout) ;
	fread(&acell,sizeof(float),1,fp_aout) ;
	fread(&bcell,sizeof(float),1,fp_aout) ;
	fread(&ccell,sizeof(float),1,fp_aout) ;
	fread(&nbeam,sizeof(long),1,fp_aout) ;
	fread(&mbeam,sizeof(long),1,fp_aout) ;
	fread(&volt,sizeof(float),1,fp_aout) ;
	fread(&NW,sizeof(long),1,fp_aout) ;
	fread(&nslc,sizeof(long),1,fp_aout) ;
	fread(&slcth,sizeof(float),1,fp_aout) ;
	fread(&gmax,sizeof(float),1,fp_aout) ;
	fread(ih,sizeof(long),NW,fp_aout) ;
	fread(ik,sizeof(long),NW,fp_aout) ;
	fread(il,sizeof(long),NW,fp_aout) ;
	i = 2*nslc*NW ;   // Complex data
	fread(zplot,sizeof(float),i,fp_aout) ;

	INTENSITY=TRUE ;
	IMANY=FALSE ;
	PLOTPHS=FALSE ;
	IW = 0 ;

	GetPort(&tPort) ;
	SetPort(gControlWindow) ;
	temder() ;
	oldmenuptr = gCurrentMenu ;
	gCurrentMenu = &amplit_menu[0] ;
	// Turn off whatever highlights that may exist
	for (gItemPtr= (*gCurrentMenu);*gItemPtr!=&null;gItemPtr++) {
		(*gItemPtr)->status = 0 ;
	}
	displ_menu() ;
	HighlightControl(&choose_int) ;
	HighlightControl(&choose_one) ;

	iy = 690 ;
	sprintf(stext,"This is the output file for %s ",title) ;
	temdtx(20,iy,stext) ;
	iy -= 30 ;
	sprintf(stext,"This file contains amplitudes and phases for the beams: ") ;
	temdtx(20,iy,stext) ;
	for(i=0;i<NW;i++) {
		sprintf(stext,"%3d %3d %3d ",ih[i],ik[i],il[i]) ;
		temdtx(choose_refl[i].xl+30,choose_refl[i].yl,stext) ;
	}
	temdtx(choose_int.xl+30,choose_int.yl,"Plot Intensity") ;
	temdtx(choose_ampl.xl+30,choose_ampl.yl,"Plot Amplitude") ;
	temdtx(choose_many.xl+30,choose_many.yl,"Superimpose Plots") ;
	temdtx(choose_one.xl+30,choose_one.yl,"Individual Plots") ;
	temdtx(choose_phs.xl+30,choose_phs.yl,"Plot Phases") ;

	while((i=get_event()) < OKAY)
		( *(*gCurrentButton)->action) (i) ;

	if (i == CANCEL || IW == 0) {
		temder() ;
		gCurrentMenu = oldmenuptr ;  // reset the gCurrentMenu
		displ_var() ;
		displ_menu() ;
		SetPort(tPort) ;
		return ;
	}

	on_highlight() ;
	gCurrentCommand = gCurrentButton ;
	SetWatchCursor() ;
	if (gPrintValues) {
		eraser(0,75,1000,105) ;
		temdtx(10,80,"Print the values to which File -> ") ;
		ReadString(filename,80) ;
		if ((fp = fopen(filename,"w")) == NULL) {
			off_highlight() ;
			CLEAR_DISPLAY ;
			gCurrentMenu = oldmenuptr ;  // reset the gCurrentMenu
			displ_var() ;
			displ_menu() ;
			InitCursor() ;
			UpdateImageScreen() ;
			SetPort(tPort) ;
			ReportFileOpenError(filename) ;
			return ;
		}
		if (gPhsgrtRec->nbeam == 0) {
			SetProjectedCell(&ierr) ;
			SetCalculationDimensions(&gProjCell->a,&gProjCell->b,&gPhsgrtRec->gmax,
			&gPhsgrtRec->nbeam,&gPhsgrtRec->mbeam) ;
		}
		gPhsgrtRec->slcth = gProjCell->c/gPhsgrtRec->nz ;
	}
	if (PLOTPHS) {
		/* adjust the phase as to get a continuous curve */
		two = 2. ;
		for(n=0;n<NW;n++)
			for(j=1;j<nslc;j++) {
				rp1 = zplot + 2*(n*NW+j)  ;	// Pointer to cmplx [n][j] 
				rp2 = rp1 - 2*NW ;         	//  --- [n-1][j]        
				rp1++ ;   					// Imaginary part
				rp2++ ;   					// Imaginary part
				tst = fabs(*rp1-*rp2) ;
				if (tst >= 1.) {
					zim = *rp2 ;
					zim = (zim > 0. ? two : -two) ;
					*rp1 += zim ;
					tst = fabs(*rp1-*rp2) ;
					if (tst > 1.) *rp1 += zim ;
				}
			}
	}

	// set all the output arrays
	for(i=0;i<IW;i++)
		for(j=0;j<NW;j++)
			if (ihw[i]==ih[j] && ikw[i]==ik[j] && ilw[i]==il[j]) {
			ampmax[i] = 0. ;
			phsmax[i] = 0. ;
			ndxi = i*1000 ;
			if (gPrintValues) {
				fprintf(fp,"\nReflection: [%d,%d,%d]",
				ihw[i],ikw[i],ilw[i]) ;
			}
			for(n=0;n<nslc;n++) {
				ndx = ndxi+n ;
				rp1 = zplot + 2*(n*NW+j) ;
				if (PLOTPHS) {
					 *(phase+ndx) = *(rp1+1) ;
					 phsmax[i] = max(phsmax[i],fabs(*(phase+ndx))) ;
				}
				*(amp+ndx) = *rp1 ;
				if (INTENSITY) {
					*(amp+ndx) *= *(amp+ndx) ;
				}
				if (gPrintValues) {
					fprintf(fp,"\nT = %6.2f",(n+1)*gPhsgrtRec->slcth) ;
					if (INTENSITY) 
						fprintf(fp,"\tIntensity: ") ;
					else
						fprintf(fp,"\tAmplitude: ") ;
					fprintf(fp,"%10.6f\t",*(amp+ndx)) ;
					if (PLOTPHS) {
						fprintf(fp,"Phase: %10.6f",*(phase+ndx)) ;
					}
				}
				ampmax[i] = max(ampmax[i],*(amp+ndx)) ;
			}
			if (PLOTPHS) phsmax[i] *= 1.2 ;
			ampmax[i] *= 1.2 ;
	}
	if (gPrintValues) {
		fprintf(fp,"\n") ;
		fclose(fp) ;
		off_highlight() ;
		CLEAR_DISPLAY ;
		gCurrentMenu = oldmenuptr ;  // reset the gCurrentMenu
		displ_var() ;
		displ_menu() ;
		InitCursor() ;
		UpdateImageScreen() ;
		SetPort(tPort) ;
		return ;
	}
	// plot the arrays
	xmax = nslc*slcth  ;

	eushft('!') ;
	sprintf(ident,"%s",title) ;
	sprintf(ivolt,"V = %7.1f kV",volt) ;
	instrct('#') ;
	sprintf(igmax,"G#lh.7max#lxhx = %3.1f !D#eh.5-1#exhx",gmax) ;
	sprintf(islcth,"!CZ = %4.1f !D",slcth) ;

	for(i=0;i<nslc;i++)
		th[i] = (i+1)*slcth ;

	size = 1.5 ;

	switch(OutDevice->type) {
		case WS:
			SetOffscreenPort(gOffscreenPtr) ;
			CLEAR_DISPLAY ;
			break ;
		case FS:
			break ;
		case LP:
			open_ps_file("laserprinter.ps") ;
			LandScape() ;
			break ;
	}
	if (!IMANY) {
		// Individual plots
		for(k=0;k<IW;k++)  {
			sprintf(ihkl,"%d %d %d",ihw[k],ikw[k],ilw[k]) ;
			if (INTENSITY) {
				strcpy(buffer,"INTENSITY") ;
			}
			else {
				strcpy(buffer,"AMPLITUDE") ;
			}
			if (PLOTPHS) {
				physor(0.15,0.55) ;
				area2d(0.65,0.4) ;
				frame() ;
				yname(buffer,size) ;
			}
			else {
				physor(0.15,0.1) ;
				area2d(0.8,0.7) ;
				frame() ;
				strcpy(ixname,"Thickness !D") ;
				messag(0.15,0.89,1.5,0.,ivolt) ;
				messag(0.15,0.86,1.5,0.,igmax) ;
				messag(0.15,0.83,1.5,0.,islcth) ;
				messag(0.18,0.75,2.0,0.,ihkl) ;
			}
			headin(ident,2.0) ;
			ymax = ampmax[k] ;
			if (gScaling.automatic) {
				ymaxa = ymax ;
				ymina = 0. ;
				gScaling.amin = ymina ;
				gScaling.amax = ymaxa ;
			}
			else {
				ymaxa = gScaling.amax ;
				ymina = gScaling.amin ;
			}
			graph2d(0.,xmax,ymina,ymaxa) ;
			curve(th,amp+k*1000,nslc,0) ;
			if (PLOTPHS) {
				physor(0.15,0.10) ;
				area2d(0.65,0.4) ;
				frame() ;
				strcpy(buffer,"PHASE (!B)") ;
				yname(buffer,size)  ;
				strcpy(buffer,"Thickness !D") ;
				xname(buffer,size) ;
				ymax2 = phsmax[k] ;
				ymin = - ymax2 ;
				if (gScaling.automatic) {
					gScaling.pmin = ymin ;
					gScaling.pmax = ymax2 ;
				}
				else {
					ymax2 = gScaling.pmax ;
					ymin = gScaling.pmin ;
				}
				graph2d(0.,xmax,ymin,ymax2) ;
				line(0.,0.,xmax,0.) ;
				curve(th,phase+k*1000,nslc,0) ;
				messag(0.83,0.93,1.5,0.,ivolt) ;
				messag(0.83,0.90,1.5,0.,igmax) ;
				messag(0.83,0.87,1.5,0.,islcth) ;
				messag(0.18,0.45,2.0,0.,ihkl) ;
				messag(0.18,0.90,2.0,0.,ihkl) ;
			}
			if(k != IW-1) {
				if (OutDevice->type == WS) {
					UnSetOffscreenPort(gOffscreenPtr) ;
					SetPort(gControlWindow) ;
					InitCursor() ;
					UpdateImageScreen() ;
					cpage() ;
					SetWatchCursor() ;
					SetOffscreenPort(gOffscreenPtr) ;
					CLEAR_DISPLAY ;
				}
				else {
					cpage() ;
				}
			}
		} 
	}
	else  {   // Several plots together 
		if (INTENSITY)
			strcpy(iyname,"INTENSITY") ;
		else
			strcpy(iyname,"AMPLITUDE") ;

		if (PLOTPHS) {
			physor(0.15,0.55) ;
			area2d(0.65,0.4) ;
			frame() ;
			yname(iyname,size) ;
		}
		else {
			physor(0.15,0.1) ;
			area2d(0.8,0.7) ;
			frame() ;
			strcpy(buffer,"Thickness !D") ;
			xname(buffer,size) ;
			yname(iyname,size) ;
			messag(0.15,0.89,1.5,0.,ivolt) ;
			messag(0.15,0.86,1.5,0.,igmax) ;
			messag(0.15,0.83,1.5,0.,islcth) ;
		}
		ymaxa = 0. ;
		ymaxp = 0. ;
		for(k=0;k<IW;k++) {
			ymaxa = max(ymaxa,ampmax[k]) ;
			ymaxp = max(ymaxp,phsmax[k]) ;
		}
		if (gScaling.automatic) {
			yminp = -ymaxp ;
			ymina = 0. ;
			gScaling.amin = ymina ;
			gScaling.amax = ymaxa ;
			gScaling.pmin = yminp ;
			gScaling.pmax = ymaxp ;
		}
		else {
			ymina = gScaling.amin ;
			ymaxa = gScaling.amax ;
			yminp = gScaling.pmin ;
			ymaxp = gScaling.pmax ;
		}
		graph2d(0.,xmax,ymina,ymaxa) ;
		for(k=0;k<IW;k++) {
			// marker(k) ;
			curve(th,amp+k*1000,nslc,0) ;
		}
		if (PLOTPHS) {
			physor(0.15,0.10) ;
			area2d(0.65,0.4) ;
			frame() ;
			strcpy(buffer,"PHASE (!B)") ;
			yname(buffer,size) ;
			strcpy(buffer,"Thickness !D") ;
			xname(buffer,size) ;
			ymin = -ymaxp ;
			graph2d(0.,xmax,yminp,ymaxp) ;
			line(0.,0.,xmax,0.) ;
			for(k=0;k<IW;k++) {
				// marker(k) ;
				curve(th,phase+k*1000,nslc,0) ;
				sprintf(ihkl,"%d %d %d",ihw[k],ikw[k],ilw[k]) ;
				// lines(ihkl,ipkray,k) ;
			}
			messag(0.83,0.93,1.5,0.,ivolt) ;
			messag(0.83,0.90,1.5,0.,igmax) ;
			messag(0.83,0.87,1.5,0.,islcth) ;
			// legend(ipkray,IW,7.6,4.2) ;
		}
	}
	
	switch(OutDevice->type) {
		case WS:
			UnSetOffscreenPort(gOffscreenPtr) ;
			SetPort(gControlWindow) ;
			break ;
		case FS:
			break ;
		case LP:
			close_ps_file() ;
			break ;
	}
	off_highlight() ;
	CLEAR_DISPLAY ;
	gCurrentMenu = oldmenuptr ;  
	displ_var() ;
	displ_menu() ;
	InitCursor() ;
	UpdateImageScreen() ;
	SetPort(tPort) ;
}

// -------------------------------------------------- 
// Set the reflections to be included in the plotting
// -------------------------------------------------- 
void set_refl(long i) {

	if (i >= NW) return ;   
	ihw[IW] = ih[i] ;
	ikw[IW] = ik[i] ;
	ilw[IW] = il[i] ;
	HighlightControl(&choose_refl[i]) ;
	IW++ ;
}
void set_ampl() {
	if (!INTENSITY) return ;
	INTENSITY = FALSE ;
	eraser(choose_int.xl,choose_int.yl,choose_int.xh,choose_int.yh) ;
	display(&choose_int) ;
	HighlightControl(&choose_ampl) ;
}

void set_int() {
	if (INTENSITY) return ;
	INTENSITY = TRUE ;
	eraser(choose_ampl.xl,choose_ampl.yl,choose_ampl.xh,choose_ampl.yh) ;
	display(&choose_ampl) ;
	HighlightControl(&choose_int) ;
}

void set_many() {
	if (IMANY) return ;
	IMANY = TRUE ;
	eraser(choose_one.xl,choose_one.yl,choose_one.xh,choose_one.yh) ;
	display(&choose_one) ;
	HighlightControl(&choose_many) ;
}

void set_one() {
	if (!IMANY) return ;
	IMANY = FALSE ;
	eraser(choose_many.xl,choose_many.yl,choose_many.xh,choose_many.yh) ;
	display(&choose_many) ;
	HighlightControl(&choose_one) ;
}

void set_phs() {
	PLOTPHS = 1 - PLOTPHS ;
	eraser(choose_phs.xl,choose_phs.yl,choose_phs.xh,choose_phs.yh) ;
	display(&choose_phs) ;
	if (PLOTPHS) {
		HighlightControl(&choose_phs) ;
	}
}

