#ifndef __TAtomRefinementPage_h
#define __TAtomRefinementPage_h
#include "TCrystal.h"
#include "TImage.h"
#include "TPage.h"
#include "CSelection.h"
#include "ProjCellRecord.h"


#define NUM_TOOLS	11

typedef enum { kXPointerTool=0,kXSelectionTool,kXRotateTool, kXQuestionMark,
	 kXMagnifyingGlass, kXRulerTool,kXAngleTool,kXAddTool,kXDeleteTool,kXHandTool,
	 kXSizeAtomTool } KXToolType ;

class	TAtomRefinementPage : public TPage {
	public:
		TAtomRefinementPage(TWindow *window,ProjCellRecord * projCell) ;
		~TAtomRefinementPage() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
		void	Draw() ;
		void	WriteStatus(char *text) { WriteMessage(text) ; } ;
		void	WriteMessage(char *) ;
	
	private:

		TImage		*mExperimentalImage ;
		Rect		mModelRect ;
		Rect		mImageRect ;
		Rect		mActualImageRect ;

		TButton			*mHelp ;

		Boolean		mHasCreatedRefinementList ;
		Boolean		CheckContinueAndDeleteList() ;

		FRect		mImageSelectionRect ;
		FRect		mModelSelectionRect ;
		CSelection	*mImageSelection ;
		CSelection	*mModelSelection ;
		Boolean		mIsInsideActiveRect ;
		Point		mImageCenter ;
		float		mImageMagnification ;
	
		void		DrawInfoWindow() ;
		void		WriteInfo(char *text) ;
		void		DoMouseDownInModel(Point &loc) ;
		void		DoMouseDownInImage(Point &loc) ;
		void		DrawExperimentalImage() ;
		void		UpdateExperimentalImage() ;
		void		DrawImageComparisonRect() ;
		void		DrawModel() ;


		TButton		*mOK ;
		TButton		*mCancel ;
		TButton		*mCompareSelection;
		TButton		*mCompareEntireImage;
		TButton		*mAddSelection;
		TButton		*mAddGroupSelection ;
		TButton		*mAtomsInRect;
		TButton		*mOptimize;
		TButton		*mClear;
		TButton		*mResetView;
		TButton		*mViewModel;

		TPushButton	*mTools[NUM_TOOLS] ;
		KXToolType	mCurrentTool ;

		TStaticText	*mInfo;

		TEditText	*mH;
		TEditText	*mK;
		TEditText	*mL;

		TCheckBox	*mShowMotif;

		TUserRect	*mImageFrame;
		TUserRect	*mModelFrame ;
		TCrystal	*mCrystal ;

		Str256		mMessageText ;
} ;

#endif	// __TAtomRefinementPage_h

