#ifndef __TCompareImagesPage__
#define __TCompareImagesPage__

#include "TPage.h"
#include "CSelection.h"

typedef enum { kComparePointer,kCompareSelection,kCompareMagnify,kCompareHand} 
CompareToolType ;

class TCompareImagesPage : public TPage {
	public:
		TCompareImagesPage(TWindow *window = nil) ;
		~TCompareImagesPage() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
	private:
		void 			DrawExpImageDisplayArea() ;
		void 			DrawStdDevImageDisplayArea() ;
		void			DrawImageComparisonRect() ;
		void			DrawStdDevComparisonRect() ;
		void			DoMouseDownInImage(Point &loc) ;
		void			DrawExperimentalImage() ;
		void			DrawStdDevImage() ;
		void			PositionImages() ;
		void			SizeImages() ;

		TRadioButton	*mCompareEntireImage ;
		TRadioButton	*mCompareSelection ;
		TButton			*mSetNewSelection ;
		TButton			*mResetView ;
		TUserRect		*mExpImageFrame ;
		TUserRect		*mStdDevImageFrame ;
		TRadioButton	*mRealCCC ;
		TRadioButton	*mFTCCC ;
		TRadioButton	*mChiSquare ;
		TRadioButton	*mRMSD ;
		TRadioButton	*mDiffImage ;
		TRadioButton	*mFMAD ;
		TButton			*mOK ;
		TButton			*mCancel ;
		TRadioButton	*mSelectedMethod ;
		
		TButton			*mHelp ;

		TRadioButton	*mExactFTCCC ;
		TRadioButton	*mAmplitudeFTCCC ;
		TCheckBox		*mEstimateShift ;

		TImage			*mExpImage ;
		TImage			*mStdDevImage ;

		TStaticText		*mExpImageName ;
		TStaticText		*mStdDevName ;
		TPushButton		*mArrowButton ;
		TPushButton		*mRectButton ;
		TPushButton		*mMagnifyButton ;
		TPushButton		*mHandButton ;

		CSelection		*mImageSelection ;
		Point			mImageCenter ;
		Point			mStdDevCenter ;
		Rect			mImageRect ;
		Rect			mStdDevRect ;
		Rect			mActualImageRect ;
		Rect			mActualStdDevRect ;
		FRect			mImageSelectionRect ;

		CompareToolType	mCurrentTool ;
		float			mImageMagnification ;
		Boolean			mIsInsideActiveRect ;
} ;

#endif //__TCompareImagesPage__

