// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "TSaveDialog.h"
#include "funcdefs.h"
SaveCode PromptSave(char *prompt) {
	Point pos ;
	short	width,height,x,y ;

	GetGlobalMouse(&pos) ;
	width = 220 ;
	height = 100 ;
	x = pos.x - width + 35 ;
	y = pos.y - height + 15 ;
	TSaveDialog *theDialog = new TSaveDialog(x,y,width,height,prompt) ;
	theDialog->DoModalDialog() ;
	SaveCode theSaveCode = theDialog->GetSaveCode() ;
	delete theDialog ;
	return theSaveCode ;
}

TSaveDialog::TSaveDialog(short xloc,short yloc,short width,
	short height,char *text) : TDialog(xloc,yloc,width,height) {

	TStaticText *theText = new TStaticText(10,10,width-10,height-60,text) ;
	AddObject(theText) ;

	mOKButton = new TButton(width-60,height-35,width-10,height-10,"Save") ;
	AddObject(mOKButton) ;

	mNoSaveButton = new TButton(width-110,height-35,width-70,height-10,"No") ;
	AddObject(mNoSaveButton) ;

	mDefaultButton = mNoSaveButton ;

	mCancelButton = new TButton(10,height-35,70,height-10,"Cancel") ;
	AddObject(mCancelButton) ;
	
}

void	TSaveDialog::DoMouseDownInObject(TObject *obj,Point *pt) {
	if (pt != nil)
		if (!obj->DoMouseDown(pt)) return ;
	if (obj == mOKButton) {
		mDone = true ;
		mSaveCode = kSave ;
	}
	else if (obj == mCancelButton) {
		mDone = true ;
		mSaveCode = kCancelClose ;
	}
	else if (obj == mNoSaveButton) {
		mDone = true ;
		mSaveCode = kNoSave ;
	}
}



