#ifndef __TWindowList__
#define __TWindowList__

#include "TWindow.h"

class TWindow ;
class TWindowEntry {	
	public:
		TWindowEntry() ;
		~TWindowEntry() ;
		friend class TWindowList ;
	private:	
		TWindow			*mWindow ;
		TWindowEntry	*mNextWindowEntry ;
}  ;

class TWindowList {
	public:
		TWindowList() ;
		~TWindowList() ;
		void 	AddWindow(TWindow *theWindow) ;
		void	RemoveWindow(TWindow *theWindow) ;
		short	GetNumberOfWindows(void) { return mNumWindows ; } ;
		TWindow	*GetWindow(long number) ;
		TWindow	*GetWindow(Window theXWindow) ;
	private:
		short	mNumWindows ;
		TWindowEntry	*mWindowEntry ;
	
}  ;

class TPane ;
class TPaneEntry {	
	public:
		TPaneEntry() ;
		~TPaneEntry() ;
		friend class TPaneList ;
	private:	
		TPane		*mPane ;
		TPaneEntry	*mNextPaneEntry ;
}  ;

class TPaneList {
	public:
		TPaneList() ;
		~TPaneList() ;
		void 	AddPane(TPane *thePane) ;
		void	RemovePane(TPane *thePane) ;
		short	GetNumberOfPanes(void) { return mNumPanes ; } ;
		TPane	*GetPane(long number) ;
		TPane	*GetPane(Window theXWindow) ;
	private:
		short	mNumPanes ;
		TPaneEntry	*mPaneEntry ;
	
}  ;

#endif // __TWindowList__

