#ifndef TXForm_H
#define TXForm_H

#include "forms.h"
#include <stdlib.h>
#include "types.h"

typedef struct {
	FL_FORM *mForm;
	void *vdata;
	char *cdata;
	long  ldata;
} XFormRecord ;
class	TGrafPort ;
class	TXForm {

	public:
		TXForm(char *title = nil) ;
		virtual	~TXForm() ;
		virtual	void	Show() ;
		virtual void	Draw() {if (mXForm->mForm != nil) fl_redraw_form(mXForm->mForm) ; } ;
		virtual	void	Update() ;
		virtual	Boolean	DoModal() ;
		virtual	Boolean	RequestClose() { return true ; } ;
		virtual	void	SetFormData(void *data) {} ;
		virtual	void	GetFormData(void *data) {} ;
		virtual	void	DoObject(FL_OBJECT *obj)  ;
		virtual	void	DefineForm() {} ;
		void	SetCancelButton(FL_OBJECT *obj) { mCancelButton = obj ; } ;
		void	SetOKButton(FL_OBJECT *obj) { mOKButton = obj ; } ;
		Boolean	IsValid() { return mIsValid ; } ;
		static	int		CloseWindow(FL_FORM *form,void *data) ;

	protected:
		FL_OBJECT		*mOKButton ;
		FL_OBJECT		*mCancelButton ;
		FL_OBJECT		*mWindowBox ;
		XFormRecord		*mXForm ;
		char			mTitle[256] ;
		Boolean			mIsValid ;
		static	Boolean	DefinedAtClose ;
		long				mPlacement ;
		long				mBorder ;
		TGrafPort		*mGrafPort ;
		
} ;

#endif // TXForm_H

