#ifndef __XDrivers
#define __XDrivers
#include "TWindow.h"

#ifndef topLeft
	#define topLeft(r) (((Point *)&(r))[0])
#endif

#ifndef botRight
	#define botRight(r) (((Point *)&(r))[1])
#endif

typedef enum { kCopy, kXOr, kOr } DrawingMode ;

void DrawPixel(long x,long y) ;
void DrawLine(long x1,long y1,long x2,long y2);
void MoveTo(long ix,long iy);
void LineTo(long ix,long iy) ;
void SetLineWidth(long width) ;
short GetLineWidth();
long	TextHeight() ;
void DrawChar(long x,long y,char c);
void DrawRect(long xlow,long ylow,long xhi,long yhi);
void DrawText(long x,long y,char *text);
void DrawString(char *text) ;
void DrawFilledText(long x,long y,char *text);
void DrawFilledString(char *text) ;
void DrawCross(short x,short y) ;
void DrawImageLine(long x,long y,long n,unsigned char *imageline);
Boolean ReadImageLine(long x,long y,long n,unsigned char *imageline);
Boolean DrawImage(unsigned char *image,long x,long y,long width,long height);
Boolean ReadImage(unsigned char *image,long x,long y,long width,long height);
void DrawRGBImageLine(long x,long y,long n,unsigned char *imageline);
Boolean ReadRGBImageLine(long x,long y,long n,unsigned char *imageline);
Boolean DrawRGBImage(unsigned char *image,long x,long y,long width,long height);
Boolean ReadRGBImage(unsigned char *image,long x,long y,long width,long height);
void RDrawRect(Rect *tRect);
void FrameRect(Rect *tRect);
void FillRect(Rect *tRect);
void InvertRect(Rect *tRect) ;
inline void PaintRect(Rect *rect) {FillRect(rect) ; } ;
void EraseRect(Rect *tRect);
void EraseCircle(short x,short y,short rad);
void ClearDisplay();
void GetMouseDownPosition(long *x,long *y);
void GetPort(GrafPtr *port);
void SetPort(GrafPtr port);
void SetRect(Rect *tRect,short x1,short y1,short x2,short y2);
Boolean PtInRect(Point *pt,Rect *tRect);
void OffsetRect(Rect *tRect,short x,short y);
void InsetRect(Rect *tRect,short x,short y);
void DrawCircle(short x,short y,short rad);
void FillCircle(short x,short y,short rad);
void PaintOval(Rect *rect) ;	// Actually only does a circle
void FrameOval(Rect *rect) ;
void	RGBForeColor(RGBColor *color) ;
void	RGBBackColor(RGBColor *color) ;
unsigned long GetFgColor();
unsigned long GetBkColor();
void SetFgColor(unsigned long value);
void SetBkColor(unsigned long value);
void TextSize(short size);
void TextFace(short face);
void PenSize(short width,short height);
void PenMode(DrawingMode mode) ;
void PenNormal();
void SetWatchCursor();
void InitCursor();
void SetTrackingMode();
void UnSetTrackingMode();
KeySym	GetEventKey(XEvent *theEvent) ;
Boolean Button();
Boolean	ButtonDown() ;
void GetGlobalMouse(Point *where) ;
void GetMouse(Point *where);
long StringWidth(char *text);
void UnionRect(Rect *srcRect1,Rect *srcRect2,Rect *destRect);
void RegionRect(Region rgn,Rect *rect) ;
void RectRgn(Region rgn,Rect *rect) ;
Boolean RectInRgn(Rect *rect,Region rgn) ;
inline	Region	NewRgn() { return XCreateRegion() ; } ;
inline	void	DisposeRgn(Region rgn) { XDestroyRegion(rgn) ; } ;
Boolean RectISectRect(Rect *aRect,Rect *bRect);
Boolean ShiftKeyDown() ;
Boolean OptionKeyDown() ;
void	SetClip(RgnHandle) ;
void	SetClip(Rect &rect) ;
void	GetClip(RgnHandle region) ;
void	FormRGBForeColor(RGBColor *) ;
void	FormRGBBackColor(RGBColor *) ;
void	SetFormFgColor(FL_COLOR) ;
void	SetFormBkColor(FL_COLOR) ;
Boolean	OptionKeyDown() ;
Boolean	ShiftKeyDown() ;
#endif

