// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "ProjCellRecord.h"
#include "funcdefs.h"
#include "storage.h"
/* -------------------------------------------------------------- */
/* Extern a unit cell to cover NX by NY unit cells		  */
/* -------------------------------------------------------------- */
void celext(long *np,long *mp,long nx,long ny,short *ierr) {
	long npold,mpold,jold,iold,jmax,max_image_points,maxpoints  ;
	register long i,j,ndx ;
	float *rp1,*rp2 ;

	if (nx == 1 && ny == 1) return ;    /* No work to be done */

	jmax = *np*(*mp) ;
	maxpoints = jmax*nx*ny ;
	if ((maxpoints + 1) > gMaxArraySize) {
		*ierr = 1 ;
		return ;
	}

	npold = *np ;
	mpold = *mp ;
	*np *= nx ;
	*mp *= ny ;
	rp1 = gWorkSpace ;
	rp2 = gWorkSpace+(*np)*(*mp) ;

	memcpy((char *)rp2,(char *)rp1,sizeof(float)*jmax) ;

	for (j=0,rp1=gWorkSpace;j<*mp;j++) {
		jold = j%mpold ;
		for (i=0;i<*np;i++) {
			iold = i%npold ;
			*rp1++ = *(rp2+jold*npold+iold) ;
		}
	}
}
