// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "storage.h"
#include "funcdefs.h"
extern struct {
                long ipot,icmplx ;
} flag ;

// ---------------------------------------------------------------
// Perform a comlex FFT on the data-array          
// ---------------------------------------------------------------
void cfft(long *np,long *mp) {
 
	float *rp1,*rp2,time ;
	long jmax ;
	register long j ;

	jmax = *np*(*mp) ;

	rp2 = gWorkSpace + jmax - 1 ;
	rp1 = rp2 +jmax ;
	if (!flag.icmplx) {  /* Make it into a complex array */
		for (j=0;j<jmax;j++) {
			*rp1-- = 0. ;
			*rp1-- = *rp2-- ;
		}
	}

	mmfft(gWorkSpace,*np,*mp,&time) ;

	flag.icmplx = 1 ;  /* Set the flag to indicate complex */
}

// ---------------------------------------------------------------
// Perform a comlex Inverse FFT on the data-array          
// ---------------------------------------------------------------
void cfftinv(long *np,long *mp) {
 
	float *rp1,*rp2,fact,time ;
	long jmax ;
	register long j ;

	jmax = *np*(*mp) ;
	fact = 1./jmax ;

	mmffti(gWorkSpace,*np,*mp,&time) ;
	rp1=gWorkSpace ;
	rp2=rp1 ;
	for (j=0;j<jmax;j++) {
		*rp1++ = (*rp2++)*fact ;	// Scale to compensate for factor 
		rp2++ ;     		  		// 1/NM for the forw. transform 
	}
	flag.icmplx = 0 ;
}
