// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h> 
#include "config.h"
#ifndef VMS
        #if HAVE_DIRENT_H
                # include <dirent.h>
                # define NAMLEN(dirent) strlen((dirent)->d_name)
        #else
                # define dirent direct
                # define NAMLEN(dirent) (dirent)->d_namlen
                # if HAVE_SYS_NDIR_H
                        #  include <sys/ndir.h>
                # endif
                # if HAVE_SYS_DIR_H
                        #  include <sys/dir.h>
                # endif
                # if HAVE_NDIR_H
                        #  include <ndir.h>
                # endif
        #endif
#else
	#include <rms.h>
        #include <lib$routines.h>
	char 	foundName[NAM$C_MAXRSS] ;
	extern  long storeFile(struct FAB *fab),errorFile(struct FAB *fab) ;
#endif
#include "funcdefs.h"
#include "header.h"
#include "menudef.h"
#include "menu_index.h"
#include "filenames.h"
#include "PhasegratingRecord.h"
#include "params.h"
#define MAXFILES 200 /* Max. number of file names the prog. can store */
#define NAMELENGTH	32
extern struct CalculationRecord { long status ; } calculation ;


void	ChoosePoolFile(long j) ;

char	gStructureName[256] ;
char	gNameOfPoolFile[256] ;
COMMAND c_files[MAXFILES] ;
FILE 		*filep ;
char 		file_names[MAXFILES][32] ;	// Storage for file names
static	long 	FILENUM_START=0 ;
static	long 	FILENUM_STOP    ;
long				NUM_FILES ;
static	long 	USE ;
static 	long 	PERSONAL=TRUE,FILE_POOL=FALSE,LOC_FLS_READ=FALSE,
                COM_FLS_READ=FALSE,LAY_FLS_READ=FALSE ;
long				FILE_SELECTED = FALSE ;		// True if a structure has been
										// selected */
static	long 	EXCEEDED_FILE_NAMES = FALSE ;		// True if we exceed maximum
													//  number of  
													// ..files the program can 
						 /* handle 'MAXFILES' */
extern 	long 	gCalculationIsChanged,gPGisChanged,gMSisChanged,gIMisChanged,gSymopsAreChanged,gBasisIsChanged ;
extern 	long 	LAYERED ;
extern 	char 	title[],plots[] ;
extern 	COMMAND c_old_fl,c_loc_fls,c_com_fls ;
extern 	COMMAND *m_sel_old_fl[] ;
static	char 	*null_text = "" ;
#ifdef VMS
struct  FAB 	fblock ;
struct  NAM 	nam ;
char    searchName[NAM$C_MAXRSS] ;
char    fabName[NAM$C_MAXRSS] ;
#endif
#define IDY 5
extern  char 	*NcemssDir,*NcemssPool ;

void	SetDirectory() ;
char	gCurrentOpenPath[256] = {'.','\0'} ;

// --------------------------------------------------------------------------
// Routine for setting the durectory in which we work
// --------------------------------------------------------------------------
void	SetDirectory() {
	char	workingDirectory[256] ;
	
	getwd(workingDirectory) ;	
	fprintf(stderr,"\nCurrent working directory = %s",workingDirectory) ;
	char *directoryName = (char *)fl_show_fselector("Set Working Directory (Choose any File in the Dir.)",gCurrentOpenPath,"","") ;
	
	if (directoryName != NULL) {
		strcpy(workingDirectory,directoryName) ;
		fprintf(stderr,"\nTrying to set it to : %s",workingDirectory) ;
		// Find the path excluding the file name				
		char *fs = strrchr(workingDirectory,'/') ;
		if (fs != NULL) *fs = '\0' ;
		fprintf(stderr,"\nCalling chdir with : %s",workingDirectory) ;
		chdir(workingDirectory) ;
		
		// Read it back
		getwd(workingDirectory) ;
		fprintf(stderr,"\nCurrent working directory is %s  ",workingDirectory) ;
		
		// Update the files available to us
		if (PERSONAL) {
			read_fls(0) ;
			displ_files() ;
		}
	}	
}

// --------------------------------------------------------------------------
// Set up routine for reading the names of available structure
// files and switch to the menu displaying the file-names 
// --------------------------------------------------------------------------
void r_sngl_layered(long i) {
    CLEAR_DISPLAY ;
    if (i==0) {
      	if (!LOC_FLS_READ && PERSONAL) 
          	read_fls(i) ;
      	if (!COM_FLS_READ && FILE_POOL) 
          	read_fls(i) ;
      	LAYERED = FALSE ;
      	set_menu(SEL_SNGL_STR) ;
    }
    else {
      	if (!LAY_FLS_READ ) read_fls(i) ;        
      	LAYERED = TRUE ;
      	set_menu(SEL_LAY_STR) ;
    }
    displ_files() ;
    displ_menu() ;
}

// --------------------------------------------------------------------------
// Switching routine that makes the structure names active 
// menu-choices for selection                        
// --------------------------------------------------------------------------
void r_old_fl() {

    if (!FILE_SELECTED) {
      	gCurrentCommand = gCurrentButton ;
      	on_highlight() ;
      	erase_remain_menu() ;
      	change_cursor() ;
      	set_menu(SEL_OLD_FL) ;
      	FILE_SELECTED = TRUE ;
    }
    else {
      	off_highlight() ;
      	reset_cursor() ;
      	erase_self() ;
      	if (LAYERED)
        	set_menu(SEL_LAY_STR) ;
      	else
        	set_menu(SEL_SNGL_STR) ;
      	displ_menu() ;
      	FILE_SELECTED = FALSE ;
    }
  }
#ifdef VMS
// --------------------------------------------------------------------------
/* Routine to select a data file from the displayed files                 */
// --------------------------------------------------------------------------
void set_file(long i) {
    long n,j ;
    char TempFile[80] ;

    // RESET PARAMETERS AND MAKE SURE NOTHING IS LEFT OVER FROM PREV. STRUC
    c_old_fl.status = OFF ;   // Turn off the status of invoking command 
    on_highlight() ;
    (*gCurrentButton)->status = OFF ; // Turn off the status of the file name 
    // initialize the filename
	gStructureName[0] = '\0' ;
    strcpy(gStructureName,&file_names[FILENUM_START+i-1][0]) ;
    for (j=0;j<40;title[j++]=EOS) ;  // Zero the title 
    for (j=0;j<3;plots[j++]=EOS) ;   // Zero the PlotAmplitudes|plotting 
                       // Make sure that the number of image points  
    gPhsgrtRec->nbeam = 0 ;  // ..are not left over from a possible previous 
                       // ..selection of a structure                  
    gPGisChanged = FALSE ;
    gMSisChanged = FALSE ;
    gIMisChanged = FALSE ;
    gSymopsAreChanged = FALSE ;
    gBasisIsChanged = FALSE ;
    gCalculationIsChanged = FALSE ;
    reset_cursor() ;
	if (!LAYERED) {
		if (PERSONAL)
			r_sngle_structure(gStructureName,"old") ;
		else if (FILE_POOL) {
			strcpy(TempFile,NcemssPool) ;          // Create the complete 
			strcat(TempFile,&file_names[FILENUM_START+i-1][0]) ;// ..path to the 
			                                        // ..file   
			r_scan_structure(TempFile) ;           // Check to see whether to use 
			if (USE)  {
				CLEAR_DISPLAY ;
				temdtx(10,400," COPYING ALL RELATED FILES TO YOUR DIRECTORY ") ;
				temdtx(10,350," Please wait................................ ") ;
				copy_files(TempFile) ;          // Copy all associated files  
				                            // ..to home directory  
				r_sngle_structure(gStructureName,"old") ;
				calculation.status = 1 ;	/* Nothing has been done	*/
				SetCalculationState() ;
			}
			else {
				CLEAR_DISPLAY ;
				set_menu(SEL_SNGL_STR) ;
				displ_files() ;
				displ_menu() ;
			}
		}
	}
    else    // Structure is layered  
		r_lay_structure(gStructureName,"old") ;
}

// --------------------------------------------------------------------------
// Copies relevant files to the login directory
// --------------------------------------------------------------------------
void copy_files(char *whichFile) {
	char command[80] ;

	strcpy(command,"copy ") ;
	strcat(command,whichFile) ;
	strcat(command,".* *.*") ;
	dcl(command) ;
}
#else
// --------------------------------------------------------------------------
// Routine to select a data file from the displayed files                 
// --------------------------------------------------------------------------
void set_file(long i) {
	long j ;


	// RESET PARAMETERS AND MAKE SURE NOTHING IS LEFT OVER FROM PREV. STRUC 
	on_highlight() ;
	c_old_fl.status = OFF ;
	(*gCurrentButton)->status = OFF ; // Turn off the status of the file name  
	// initialize the filename
	gStructureName[0] = '\0' ;
	strcpy(gStructureName,&file_names[FILENUM_START+i-1][0]) ;
	for (j=0;j<40;title[j++]=EOS) ;  // Zero the title
	for (j=0;j<3;plots[j++]=EOS) ;   // Zero the PlotAmplitudes|plotting 
	// Make sure that the number of image points   
	gPhsgrtRec->nbeam = 0 ;  // ..are not left over from a possible previous  
	// ..selection of a structure                  
	gPGisChanged = FALSE ;
	gMSisChanged = FALSE ;
	gIMisChanged = FALSE ;
	gSymopsAreChanged = FALSE ;
	gBasisIsChanged = FALSE ;
	gCalculationIsChanged = FALSE ;
	reset_cursor() ;
	if (!LAYERED) {
		if (PERSONAL) {
			r_sngle_structure(gStructureName,"old") ;
		}
		else if (FILE_POOL) {
			ChoosePoolFile(i) ;
		}
	}
	else    /* Structure is layered   */ 
		r_lay_structure(gStructureName,"old") ;
}

// --------------------------------------------------------------------------
// Copies relevant files to the login directory 
// --------------------------------------------------------------------------
void copy_files(char *whichFile) {
	char command[256] ;

	strcpy(command,"cp -f ") ;
	strcat(command,whichFile) ;
	strcat(command,".* ./") ;
	system(command) ;
}

void	ChoosePoolFile(long j) {
	char	fileNameToCopy[256] ;

	strcpy(gNameOfPoolFile,NcemssPool) ;          // Create the complete 
	strcat(gNameOfPoolFile,"/") ;
	strcat(gNameOfPoolFile,&file_names[FILENUM_START+j-1][0]) ;// ..path to the 
	strcpy(fileNameToCopy,gNameOfPoolFile) ;
	strcat(fileNameToCopy,".at") ;

	long stat ;
	FILE *fp ;

  
  
    	set_menu(USE_POOL_FILE) ;

   	fp = fopen(fileNameToCopy,"r") ;
	if (fp == NULL) {
		PutMessage("Failed to upen the file") ;
		return ;
	}
    	stat = read_file(fp) ;
    	fclose(fp) ;
    	if (!stat) {
			return ;
	}
    	CLEAR_DISPLAY ;
    	displ_var() ;             /* display the parameters */
    	displ_menu() ;            /* display the controlmenu */

}

void UsePoolFile() {
	USE = TRUE ;
	FILE_SELECTED = TRUE ;
	fflush(stderr) ;
	CLEAR_DISPLAY ;
	temdtx(10,400," COPYING ALL RELATED FILES TO YOUR DIRECTORY ") ;
	temdtx(10,350," Please wait................................ ") ;
	copy_files(gNameOfPoolFile) ;          /* Copy all associated files   */
				                    /* ..to home directory         */
	r_sngle_structure(gStructureName,"old") ;
	calculation.status = 1 ;	/* Nothing has been done	*/
	SetCalculationState() ;
	
}

void DoNotUsePoolFile() {
	USE = FALSE ;
	FILE_SELECTED = FALSE ;
	CLEAR_DISPLAY ;
	set_menu(SEL_SNGL_STR) ;
	displ_files() ;
	displ_menu() ;
}
#endif

void r_fl_exit() {
	CLEAR_DISPLAY ;
	set_menu(SEL_SNGL_LAY) ;
	displ_menu() ;
}

// --------------------------------------------------------------------------
// Display all the files of type *.at or *.lay in current directory 
// The routine displays one page of file-names; 80 files. There is 
// built in a maximum of 200 file-names into the program           
// --------------------------------------------------------------------------
void displ_files() {
    long i ;

    FILENUM_STOP = FILENUM_START + MIN((NUM_FILES-FILENUM_START),80) ;
    eraser(0,65,1000,718) ;
    if (NUM_FILES != 0) {
        for (i=FILENUM_START;i<FILENUM_STOP;i++)
             temdtx(c_files[i].xl+30,c_files[i].yl+IDY,&file_names[i][0]) ;
    }
    else {
        REVERSE_VIDEO ;
        temdtx(0,70,"THERE ARE NO STRUCTURE FILES IN THIS DIRECTORY") ;
        NORMAL_VIDEO ;
    }
    if (EXCEEDED_FILE_NAMES) {
        REVERSE_VIDEO ;
        temdtx(0,70,
        "THE NUMBER OF FILENAMES EXCEEDS MAXIMUM ALLOCATED - 200 ") ;
        NORMAL_VIDEO ;
        BELL ;
    }
}

// --------------------------------------------------------------------------
// Exit NCEMSS 
// --------------------------------------------------------------------------
void r_exit() {

    exit(0) ;
}

// --------------------------------------------------------------------------
// Previous page of structure names     
// --------------------------------------------------------------------------
void r_prev_page() {

    long i,j ;

    FILENUM_START = MAX((FILENUM_START-80),0) ;
    FILENUM_STOP = FILENUM_START + MIN((NUM_FILES-FILENUM_START),80) ;
    for (i=0,j=FILENUM_START;j<FILENUM_STOP;j++,i++) {
        m_sel_old_fl[i+1] = &c_files[j] ;
        m_sel_old_fl[i+2] = &null ;
    }
    displ_files() ;
}

// --------------------------------------------------------------------------
// Display next page of structure names   
// --------------------------------------------------------------------------
void r_next_page() {

    long i,j ;

    FILENUM_START = (NUM_FILES > FILENUM_STOP ? FILENUM_STOP : FILENUM_START) ;
    FILENUM_STOP = FILENUM_START + MIN((NUM_FILES-FILENUM_START),80) ;
    for (i=0,j=FILENUM_START;j<FILENUM_STOP;j++,i++) {
        m_sel_old_fl[i+1] = &c_files[j] ;
        m_sel_old_fl[i+2] = &null ;
    }
    displ_files() ;
}

// --------------------------------------------------------------------------
// Set up routine for creating a new and unique sructure file
// --------------------------------------------------------------------------
void r_new_fl() {

    do  {
        eraser(0,60,1023,100) ;
        REVERSE_VIDEO ;
        temdtx(0,70,
        "Enter a unique name for your structure  ( C - CANCELS) -> ") ;
        ReadString(gStructureName,32) ;
        NORMAL_VIDEO ;
        eraser(0,60,1023,100) ;
    } while (strlen(gStructureName) == 0) ;
    if (strlen(gStructureName) == 1 && 
		(gStructureName[0] == 'c' || gStructureName[0] == 'C'))
       return ;
    /* Add the new name to the list of structures */
    strcpy(file_names[NUM_FILES],gStructureName) ;
    c_files[NUM_FILES].xl = 20 + (NUM_FILES%4)*250 ;
    c_files[NUM_FILES].xh = c_files[NUM_FILES].xl + 230 ;
    c_files[NUM_FILES].yl = 690 - (long)(NUM_FILES/4)*30 +
                                  (long)(NUM_FILES/80)*600 ;
    c_files[NUM_FILES].yh = c_files[NUM_FILES].yl + 26 ;
    c_files[NUM_FILES].txt = file_names[NUM_FILES] ;
    c_files[NUM_FILES].status = OFF ;
    c_files[NUM_FILES].action = set_file ;
    if (NUM_FILES < 80) {
		m_sel_old_fl[NUM_FILES+1] = &c_files[NUM_FILES] ;
		m_sel_old_fl[NUM_FILES+2] = &null ;
    }  
    NUM_FILES++ ;

    if (!LAYERED) {
		r_sngle_structure(gStructureName,"new") ;
		read_fls(0) ;
    }
    else {
		r_lay_structure(gStructureName,"new") ;
		read_fls(1) ;
    }  
}

// --------------------------------------------------------------------------
// Switching routine do display only local files        
// --------------------------------------------------------------------------
void r_loc_fls() {
	//void on_off(COMMAND *) ;
	if (!PERSONAL) {
		on_highlight() ;
		on_off(&c_com_fls) ;
		PERSONAL = TRUE ;
		FILE_POOL = FALSE ;
		eraser(0,102,1000,725) ;
		if (!LOC_FLS_READ) read_fls(0) ;
		displ_files() ;
	}
} 

// --------------------------------------------------------------------------
// Switching routine do display files in the file-pool 
// --------------------------------------------------------------------------
void r_com_fls() {

	if (!FILE_POOL) {
		on_highlight() ;
		on_off(&c_loc_fls) ;
		PERSONAL = FALSE ;
		FILE_POOL = TRUE ;
		eraser(0,102,1000,725) ;
		if (!COM_FLS_READ) read_fls(0) ;
		displ_files() ;
	}
}
 
void r_lay_fls() {}

// --------------------------------------------------------------------------
// Routine to display the atom-file in the FILE_POOL and prompt for
// ..subsequent use                                             
// --------------------------------------------------------------------------
void r_scan_structure(char *structname) {
    long i,stat ;
    FILE *fp ;

    gNumInputParameters = NUM_INPUT_PARAMETERS ;               /* set the no. of parameters              */
                               /* This is the number of variables to be  */
                               /* ..displayed with the poolmenu          */
    /* Set up the filename for the file to be scanned */
    /* ..,but first initialize */
    for (i=0;i<NAMELENGTH;flname.pin[i++]=' ') 
        ;
    strcpy(flname.pin,structname) ; strcat(flname.pin,".at") ;
  
  
    set_menu(USE_POOL_FILE) ;
  
    fp = fopen(flname.pin,"r") ;
    stat = read_file(fp) ;
    fclose(fp) ;
    if (!stat) {
		return ;
	}
    CLEAR_DISPLAY ;
    displ_var() ;             /* display the parameters */
    displ_menu() ;            /* display the controlmenu */
    (*(*gCurrentButton)->action)(get_event()) ;
}

// --------------------------------------------------------------------------
// We are going to use this file  
// --------------------------------------------------------------------------
void r_use_file() {
    USE = TRUE ;
    FILE_SELECTED = TRUE ;
}  


// --------------------------------------------------------------------------
// We are not going to use this file  
// --------------------------------------------------------------------------
void r_nouse_file() {
    USE = FALSE ;
    FILE_SELECTED = FALSE ;
}  

char dir_file[80] ;
#ifndef VMS
// --------------------------------------------------------------------------
// Get the appropriate filenames from the current directory
// --------------------------------------------------------------------------
void read_fls(long k) {
    char extension[10],*cp ;
    DIR *dirp ;
    struct dirent *dp ;
    long i ;

    if (k==0) {   // Single structures : extension  .at
		if (PERSONAL) {
        	strcpy(dir_file,".") ;
        	LOC_FLS_READ = TRUE ;
        	COM_FLS_READ = FALSE ;
        	LAY_FLS_READ = FALSE ;
        }
		else if (FILE_POOL) {
			strcpy(dir_file,NcemssPool) ;
			strcat(dir_file,"/") ;
			COM_FLS_READ = TRUE ;
			LOC_FLS_READ = FALSE ;
			LAY_FLS_READ = FALSE ;
		}
		strcpy(extension,".at") ;
    }
    else {     // Layered structures, externsion .lay 
		strcpy(dir_file,".") ;
		strcpy(extension,".lay") ;
		LAY_FLS_READ = TRUE ;
		LOC_FLS_READ = FALSE ;
		COM_FLS_READ = FALSE ;
    }
    NUM_FILES = 0 ;
    FILENUM_START = 0 ;
    EXCEEDED_FILE_NAMES = FALSE ;
    // Get the filenames 
    // First open the directory 
	if ((dirp = opendir(dir_file)) == NULL) {
		eraser(0,0,110,140) ;
		temdtx(0,115,"Cannot open the requested directory..") ;
		return ;
    }
	while((dp = readdir(dirp)) != NULL) {
		if ((cp = strchr(dp->d_name,'.')) != NULL) {
			// Check for the right extension 
			if (strcmp(cp,extension) == 0) {
				// Valid filename 
				// Copy the filename, but do not include ext 
				for(i=0,cp=dp->d_name; *cp != '.';
						file_names[NUM_FILES][i++] = *cp++)
					;
				file_names[NUM_FILES][i] = EOS ;
				c_files[NUM_FILES].xl = 20 + (NUM_FILES%4)*250 ;
				c_files[NUM_FILES].xh = c_files[NUM_FILES].xl + 230 ;
				c_files[NUM_FILES].yl = 690 - 
					(long)(NUM_FILES/4)*30 + 
					(long)(NUM_FILES/80)*600 ;
				c_files[NUM_FILES].yh = c_files[NUM_FILES].yl + 26 ;
				c_files[NUM_FILES].action = set_file ;
				c_files[NUM_FILES].txt = file_names[NUM_FILES] ;
				c_files[NUM_FILES].help_msg = null_text ;
				if (NUM_FILES < 80) {
					m_sel_old_fl[NUM_FILES+1] = &c_files[NUM_FILES] ;
					m_sel_old_fl[NUM_FILES+2] = &null ;
				}
				NUM_FILES++ ;
				if (NUM_FILES > MAXFILES) {
					EXCEEDED_FILE_NAMES = TRUE ;
					closedir(dirp) ;
					return ;
				}
			}
		}
	}
    closedir(dirp) ;
}
#else
long storeFile(struct FAB *fab) ;
long errorFile(struct FAB *fab) ;
// --------------------------------------------------------------------------
// Search the appropriate directory for the files of the	
// specified type. The directories are either the current
// default directory or the translation of the logical name	
// ncemss$pool The file-type is either '*.at' or '*.lay'
// depending on whether we are using single or layered	
// structures at the moment.			
// --------------------------------------------------------------------------
void read_fls(long k) {
    char FileSpec[255] ;

    if (k==0)  { /* Single structures : extension  .at */
		if (PERSONAL) {
			strcpy(FileSpec,"") ;	/* Do not need the specification of a */
					/* directory. Use current default     */
			LOC_FLS_READ = TRUE ;
			COM_FLS_READ = FALSE ;
			LAY_FLS_READ = FALSE ;
		}
		else if (FILE_POOL) {
			strcpy(FileSpec,NcemssPool) ;
			COM_FLS_READ = TRUE ;
			LOC_FLS_READ = FALSE ;
			LAY_FLS_READ = FALSE ;
		}
		strcat(FileSpec,"*.at") ;
    }
    else   {   /* Layered structures, externsion .lay  */
      	strcpy(FileSpec,"") ;		/* Again only use current directory */
      	strcat(FileSpec,"*.lay") ;
      	LAY_FLS_READ = TRUE ;
      	LOC_FLS_READ = FALSE ;
      	COM_FLS_READ = FALSE ;
    }
    ScanDirectory(FileSpec) ;
}

// --------------------------------------------------------------------------
// Do the actual call to scan the directory. The routine 	
// storeFile gets called every time we actually find a file of 
// the specified type					
// --------------------------------------------------------------------------
void ScanDirectory(char *filename) {

    long	context,i ;


    fblock   = cc$rms_fab ;	/* Set default values in the FAB */
    nam      = cc$rms_nam ;

    /* Make sure that we zero all the information in the file names */
    for (i=0;i<NAM$C_MAXRSS;i++) {
		searchName[i] = EOS ;
		fabName[i]    = EOS ;
		foundName[i]  = EOS ;
    }
    fblock.fab$l_nam = &nam ;
    nam.nam$l_esa = searchName ;
    nam.nam$l_rsa = foundName ;
    nam.nam$b_rsl = sizeof(foundName) ;
    nam.nam$b_rss = sizeof(foundName) ;
    nam.nam$b_ess = sizeof(searchName) ;

    strcpy(searchName,filename) ;
    strcpy(fabName,searchName) ;
    fblock.fab$l_fna = fabName ;
    fblock.fab$b_fns = sizeof(fabName) ;
  

    NUM_FILES = 0 ;
    FILENUM_START = 0 ;
    EXCEEDED_FILE_NAMES = FALSE ;

    context = 0 ;
    lib$file_scan(&fblock,storeFile,errorFile,&context) ;
    lib$file_scan_end(&fblock,&context) ;
}

long storeFile(struct FAB *fab) {
	long len ;
	char tfilename[256],sfilename[256] ;
	char *nameStartP,*nameEndP,*cp ;

	// ---------------------------------------------------------
	// The returned string contains the device specification and
	// directory specifications as well. We will jump over these 
	// in order to get to the actual filename	
	// --------------------------------------------------------- 

	cp = (char *)(fab->fab$l_nam)->nam$l_rsa ;
	len = (fab->fab$l_nam)->nam$b_rsl ;
	*(cp+len) = EOS ;
	strcpy(tfilename,cp) ;
	nameStartP = strchr(tfilename,']') ;

	if ((nameStartP = strchr(tfilename,']')) == (char *)0) {
		// The ']' character does not exist in the filename. 
		// Look for the '>' character		
		if ((nameStartP = strchr(tfilename,'>')) == (char *)0) {
			printf("Failed to find ']' or '>' in the name !\n") ;
			return(0) ;
		}
	}
	nameStartP++ ;
	nameEndP   = strchr(nameStartP,'.') ;
	*nameEndP   = EOS ;

	// Copy the filename into the array of filenames and set up the 
	// associated COMMANDS to go with the files.
	strcpy(&file_names[NUM_FILES][0],nameStartP) ;
	c_files[NUM_FILES].xl = 20 + (NUM_FILES%4)*250 ;
	c_files[NUM_FILES].xh = c_files[NUM_FILES].xl + 230 ;
	c_files[NUM_FILES].yl = 690 - (long)(NUM_FILES/4)*30 + 
	                        (long)(NUM_FILES/80)*600 ;
	c_files[NUM_FILES].yh = c_files[NUM_FILES].yl + 26 ;
	c_files[NUM_FILES].txt = &file_names[NUM_FILES][0] ;
	c_files[NUM_FILES].action = set_file ;
	c_files[NUM_FILES].help_msg = null_text ;
	if (NUM_FILES < 80) {
		m_sel_old_fl[NUM_FILES+1] = &c_files[NUM_FILES] ;
		m_sel_old_fl[NUM_FILES+2] = &null ;
	}
	NUM_FILES++ ;
	if (NUM_FILES > MAXFILES) {
		EXCEEDED_FILE_NAMES = TRUE ;
		return(0) ;
	}
	return(1) ;
}

long errorFile(struct FAB *fab) {
	return(1) ;
}
#endif
