// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "atoms.h"
extern long gNumBasisAtoms ;
extern char stext[],name[],*chemsymb[] ;
float irrat_fract[4] = {1./3.,2./3.,1./6.,5./6.} ;
// --------------------------------------------------------------------------
// Prompts for atomtype and coordinates and is called from create_file 
// --------------------------------------------------------------------------
void get_atoms() {

    long i,iz,j,err ;
    
    for (j=0;j<gNumBasisAtoms;j++) {
		eraser(0,0,1020,80) ;
		sprintf(stext," Enter for atom No. %d in the Basis",j+1) ;
		temdtx(0,50,stext) ;
		err = FALSE ;
		tryagain :
		eraser(0,0,1020,40) ;
		if (!err)
			temdtx(0,10," Atomic Symbol -> ") ;
		else
			temdtx(0,10," Illegal entry for chemical symbol !  REENTER !!") ;
		ReadString(name,3) ; 
		if((iz=atomno(name))!=-1) {
			(basis+j)->no.val.iv = iz ;
			(basis+j)->name.val.cv = chemsymb[iz-1] ;
			err = FALSE ;
		}
		else {
			err = TRUE ;
			goto tryagain ;
		}
		eraser(0,0,1020,40) ;
		temdtx(0,10," Relative x y z -coordinates -> ") ;
		(basis+j)->xc.val.fv = get_float(0.) ;
		(basis+j)->yc.val.fv = get_float(0.) ;
		(basis+j)->zc.val.fv = get_float(0.) ;
		for (i=0;i<4;i++) {
			if (fabs((basis+j)->xc.val.fv - irrat_fract[i]) < 0.001)
				(basis+j)->xc.val.fv = irrat_fract[i] ;
			if (fabs((basis+j)->yc.val.fv - irrat_fract[i]) < 0.001)
				(basis+j)->yc.val.fv = irrat_fract[i] ;
			if (fabs((basis+j)->zc.val.fv - irrat_fract[i]) < 0.001)
				(basis+j)->zc.val.fv = irrat_fract[i] ;
		}
		eraser(0,0,1020,40) ;
		temdtx(0,10," Debye Waller factor -> ");
		(basis+j)->dw.val.fv = get_float(0.5) ;
		eraser(0,0,1020,40) ;
		temdtx(0,10," Occupancy factor -> ");
		(basis+j)->occ.val.fv = get_float(1.) ;
	}
    eraser(0,0,1020,80) ;
}

