// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "funcdefs.h"
#include "files.h"
#include "storage.h"
#include "filenames.h"
#include "errors.h"
#include "phsgr.h"
#include "nucell.h"
extern 	struct { long ipot,icmplx ; } flag ;
extern 	struct { long num_pot,num_wf,num_image ; } whichOne ;
void getim(long *np,long *mp) {
	long 	jmax,ierr ;

	if (gPhsgrtRec->nbeam == 0.) {
		SetProjectedCell(&ierr) ;
		SetCalculationDimensions(&gProjCell->a,&gProjCell->b,&gPhsgrtRec->gmax,&gPhsgrtRec->nbeam,
			&gPhsgrtRec->mbeam) ;
	}
	*np = gPhsgrtRec->nbeam ;
	*mp = gPhsgrtRec->mbeam ;
	jmax = *np*(*mp) ;
	if (!open_input_file(flname.iout)) {
		gIOError = ERR_OP ;
		return ;
	}
	else {
		flag.ipot = 0 ;
		flag.icmplx = 0 ;
		erase_message() ;
		write_message("Reading Input File...") ;
		if (!read_input_file(whichOne.num_image,(char *)gWorkSpace,jmax)) {
			gIOError = ERR_RD ;
			close_input_file() ;
			erase_message() ;
			return ;
		}
	}
	close_input_file() ;
	erase_message() ;
}
