// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include "funcdefs.h"
#include "header.h"
#include "menudef.h"
#include "devices.h"
#include "storage.h"
#include "ProjCellRecord.h"
#include "globals.h"
#include "atoms.h"
extern long LAYERED ;
struct { 
	long xoffset,yoffset ; 
	float fracta,fractb ; 
} clip = {0,0,1.,1.} ;
extern short gPrintValues ;
extern char stext[],gFileName[] ;
extern struct {
	long AtomOverlay;
	long intensity ;
} OverLay ;
extern struct {
               long ipot ;
               long icmplx ;
              } flag ;
/* Define the intensity patterns, total of 17 patterns */
short intens[] = {0xffff,0x7fff,0x7ffb,0x7ff6,0x6ff6,
                  0x6f76,0x4f76,0x4e76,0x4e72,0x4e62,
                  0x0e62,0x0e60,0x0660,0x0640,0x0600,
                  0x0400,0x0000} ;
extern long DSPLY_X_LOC,DSPLY_Y_LOC ;
extern long TITLING,ERASE,MONTAGE ;

void hafton(long *np,long *mp) {
	long ndx,j,i,ix,iy,nmax,mmax,x_left_crner,y_left_crner,xlow,ylow ;
	long *ierr,maxn,maxm,dummy=0,mode,lns_left,size,LpOffset=20 ;
	char *dstpt,*srcpt,*srcpt1,*dstpt1,offset ;
	short  *psi,mask,shift,k,int_ndx,dshift ;
	float xl,yl,xh,yh ;
	extern float CNTRST,RANGE,BRITE ;
	extern long NUM_ACELL,NUM_BCELL ;
	float *buffer ;
	long ndx4,width,height,imode=0,opcode=0,i41=1 ;
	float top=255.,bot=0. ;
	unsigned long saveInt ;
	FILE *fp ;

	clip.xoffset = 0 ;
	clip.yoffset = 0 ;
	clip.fracta = 1. ;
	clip.fractb = 1. ;

	/* straighten the unit cell for display */
	AdjustGamma(np,mp,NUM_ACELL,NUM_BCELL) ;

	/* Adjust the number of plotting points in the 2 directions */
	AdjustSampling(np,mp,NUM_ACELL,NUM_BCELL) ;

	/* clip the image if necessary */
	if (!gPrintValues) {
		maxn = OutDevice->xres/OutDevice->pixpoint ;
		maxm = OutDevice->yres/OutDevice->pixpoint ;
		if (*np>maxn || *mp>maxm) ClipImage(np,mp,&maxn,&maxm) ;
	}

	nmax = *np ;
	mmax = *mp ;
	/* set the contrast */
	if (!gPrintValues) {
		contrst(np,mp,&CNTRST,&RANGE,&BRITE) ;
	}
	else {
		sprintf(stext,"%dby%d",nmax,mmax) ;
		strcat(gFileName,stext) ;
		if( (fp = fopen(gFileName,"w")) != NULL) {
			buffer = gWorkSpace+nmax*(mmax-1) ;
			for (j=0;j<mmax;j++) {
				fwrite(buffer,nmax*sizeof(float),1,fp) ;
				buffer -= nmax ;
			}
			/* If we wanted to write out the data to a floating point
			TIFF File, we could execute the next call. The 1 indicates
			that we will flip the image to get the correct orientation

			WriteImageDataToTiff(gFileName,gWorkSpace,nmax,mmax,1) ;
			*/
			fclose(fp) ;
			return ;
		}
		else {
			eraser(0,0,1023,32) ;
			temdtx(0,10,"Unable to open the output file") ;
			return ;
		}
	}

	switch(OutDevice->type) {
		case WS:
			/* Shuffle the array to get the last row to be the first */
			/* and also convert into bytes instead of floating point */
			/* values as it is right now                             */
			srcpt = (char *)(gWorkSpace+nmax*(mmax-1)) ;  
			/* Last line in input   */
			dstpt = (char *)(gWorkSpace+nmax*mmax) ; 
			/* First line in output */
			for (lns_left = mmax; lns_left > 0; lns_left--) {
				/* Convert a row to bytes and move to destination */
				packfb((float *)srcpt,&nmax) ; 
				/* Move the row to the output row */
				srcpt1 = srcpt ;
				dstpt1 = dstpt ;
				for (i = 0; i < nmax; *dstpt1++ = *srcpt1++,i++) 
			   		;
				srcpt -= 4*nmax ;  /* Update the source-pointer      */
				dstpt += nmax ;    /* Update the destination pointer */
			}
			ws_image((char *)(gWorkSpace+nmax*mmax),nmax,mmax) ;
			break ;
		case LP:
		case FS:
			if (DSPLY_X_LOC < 0 && DSPLY_Y_LOC < 0) {
				ix = (OutDevice->xres - nmax)/2 ;
				iy = (OutDevice->yres - mmax)/2 ;
			}
			else {
				ix = DSPLY_X_LOC ;
				iy = DSPLY_Y_LOC ;
				if (ix < LpOffset || iy < LpOffset) {
					ix += LpOffset ;
					iy += LpOffset ;
				}
			}
			xlow = ix ;
			ylow = iy ;
			width = *np ;
			height = *mp ;
			lns_left = *mp ;
			if (ERASE && !MONTAGE) {
				stemder(&opcode) ;
			}
			for (buffer=gWorkSpace+(*mp-1)*width ; lns_left > 0 ; ) {
				packfb(buffer,&width) ;
				stemdro((char *)buffer,&i41,&width,&i41,&imode,&ix,&iy,
						&bot,&top) ;
				buffer -= width ;
				iy ++ ;
				lns_left-- ;
			}
			iy += 4 ;
			if (TITLING) titles(np,ix,iy) ;
			if (OverLay.AtomOverlay  && !LAYERED) {
				saveInt = GetFgColor() ;
				SetFgColor(gColors[OverLay.intensity].pixel) ;
				OverLayAtoms(xlow,ylow,width,height) ;
				SetFgColor(saveInt) ;
			}
			break ;
	}
}

void ws_image(char *out,long nmax,long mmax) {
	extern long MONTAGE ;
	long width,height,bits_pixel ;
	long xlow,ylow,xhi,yhi ;
	unsigned long saveInt,GetFgColor() ;

	width = OutDevice->pixpoint*nmax ;
	height = OutDevice->pixpoint*mmax ;

	/* FInd the position of the upper left corner of the image (xlow,ylow) */
	/* relative to the coordinate system (0,0) lower left corner	   */
	/* First we do it with coordinate system up top			   */
	if (DSPLY_X_LOC == -1 && DSPLY_Y_LOC == -1) {
		xlow = (OutDevice->xres - nmax)/2. ;
		ylow = (OutDevice->yres - mmax)/2. ;
	}
	else {
		xlow = DSPLY_X_LOC ;  
		ylow = DSPLY_Y_LOC ;
	}
	/* ylow = OutDevice->yres - ylow - 1 ; */
	DrawImage((unsigned char *)out,xlow,ylow,width,height) ;
	if (TITLING) {  /* Add titles */
		titles(&width,xlow,ylow+height+14) ; 
		/* titles(&width,xlow,OutDevice->yres-(ylow+height+14)) ; */
	}
	if (OverLay.AtomOverlay  && !LAYERED) {
		saveInt = GetFgColor() ;
		SetFgColor(gColors[OverLay.intensity].pixel) ;
		OverLayAtoms((long)xlow,(long)ylow,width,height) ;
		SetFgColor(saveInt) ;
	}
}

void OverLayAtoms(long xlow,long ylow,long width,long height) {
	/* ----------------------------------------------------	*/
	/* Mark the atoms with some kind of symbol, maybe cross 	*/
	/* or a circle. The size could be according to the 		*/
	/* current covalent radius					*/
	/* ----------------------------------------------------	*/
	extern	long NUM_ACELL,NUM_BCELL ;
	long	radius,xpos,ypos,ndx,n,m,i,x1,x2,y1,y2 ;
	float	rr,x,y,ppa,ppb,SideX,SideY,xf,yf ;
	long	colorIndex ;

	/* Number of points per Angstrom */
	ppa = width/(gProjCell->a*clip.fracta*NUM_ACELL) ;
	ppb = height/(gProjCell->b*clip.fractb*gProjCell->siga*NUM_BCELL) ;        

	SideX = gProjCell->a*NUM_ACELL ;
	SideY = gProjCell->b*NUM_BCELL ;
	xlow += clip.xoffset ;
	ylow += clip.yoffset ;
	/* Loop over all the atoms within view	*/


	for (n=0;n<=NUM_ACELL;n++)	/* Loop over the number of cells in the x-dir.*/
		for(m=0;m<=NUM_BCELL;m++)	/* Loop over all the cells in the y-direction */
			for(i=0;i<gProjCell->natom;i++) { /* Loop over all the atoms  */
				x = (gProjCell->x[i]+n)*gProjCell->a ; /* Absolute x-pos in Angstrom */
				y = (gProjCell->y[i]+m)*gProjCell->b ; /* Absolute y-pos	"	*/
				if (x <= SideX && y <= SideY) { /* Is it within the area	*/
					x = x + y*gProjCell->csga ;/* In terms of rect. units	*/
					y = y*gProjCell->siga ;
					xf = x*ppa ;		/* Pixels from corner of image  */
					xpos = near(xf) ;	/* (nearest) pixel from corner  */
					yf = y*ppb ;		/* Pixels from corner of image  */
					ypos = near(yf) ;	/* (nearest) pixel from corner  */
					if (xpos < 0) xpos += width ;	/* Shift into the image	*/
					xpos += xlow ;			/* X-pos on the screen	*/
					ypos = ylow+height-1-ypos ; /* Y-pos on the screen	*/

					ndx = gProjCell->atno[i]-1 ;
					rr = 0.25*covrad[ndx] ; /* Radius in A * 0.25	*/
					rr = rr/(gProjCell->a*NUM_ACELL) ;	 /* Rel. rad. of width	*/
					radius = near(rr*width) ;		 /* Radius in pixels	*/
					if (radius < 1) radius = 1 ;

					//x1 = xpos - radius ;
					//x2 = xpos + radius ;
					//y1 = ypos - radius ;
					//y2 = ypos + radius ;
					colorIndex = gProjCell->atno[i] % 39 ;
					SetFgColor(gColors[gNumGrays-1+colorIndex].pixel) ;
					FillCircle(xpos,ypos,radius) ;
					SetFgColor(gBlackPixel) ;
					DrawCircle(xpos,ypos,radius) ;
				}
			}
}
