// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
extern GDevice *OutDevice ;
extern long SCALED,HISTOGRAM ;
extern float RANGE ;
extern FPV funcpntrs[] ;
extern MENUS cmndptrs[] ;
extern long no_cmnd ;

// -------------------------------------------------------------------
// Set-up routine for computing the histogram. If neccessary scales
// the image into the proper graylevels                          
// -------------------------------------------------------------------
void histog(long *np,long *mp) {

    long ierr ;
    if (!SCALED) {
		RANGE = OutDevice->range ;
		ScaleImageIntensities(np,mp,&RANGE,&ierr) ;
		SCALED = TRUE ;
	}
}

// -------------------------------------------------------------------
// Set-up routine for computing the histogram of an image. Invoked by 
//  the "HISTOG" command in the "DISPLAY" menu             
// -------------------------------------------------------------------
void r_hist() {

    eraser(0,0,1020,32) ;
    cmndptrs[no_cmnd] = gCurrentButton ;
    funcpntrs[no_cmnd++] = (FPV)histog ;
    on_highlight() ;
    HISTOGRAM = TRUE ;

}

// -------------------------------------------------------------------
// histogram equalization calling routine. Calls the 
// routine HISTEQ                                      
// -------------------------------------------------------------------
void histeq_c(long *np,long *mp) {

    long ierr ;
    if (!SCALED) {
		RANGE = OutDevice->range ;
		ScaleImageIntensities(np,mp,&RANGE,&ierr) ;
		SCALED = TRUE ;
	}
    histeq(np,mp) ;
}

// -------------------------------------------------------------------
// Set-up routine for histogr. equalization. Invoked by the 
//  "HISTEQ" command in the DISPLAY menu    
// -------------------------------------------------------------------
void r_histeq() {

    eraser(0,0,1020,32) ;
    cmndptrs[no_cmnd] = gCurrentButton ;
    funcpntrs[no_cmnd++] = (FPV)histeq_c ;
    on_highlight() ;
}

