// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "storage.h"
#include "errors.h"
extern MENUS cmndptrs[],ptr_add_cells ;
extern FPV funcpntrs[] ;
extern long NUM_ACELL,NUM_BCELL,no_cmnd,EXIT_WAVEF ;
extern struct {
                long ipot ;
                long icmplx ;
              } flag ;
// ------------------------------------------------------------------
// Set-up routine for adding unit cells in the a and b-direction 
// ------------------------------------------------------------------
void r_add_unit_cells() {

	eraser(0,0,1020,32) ;
	cmndptrs[no_cmnd] = gCurrentButton ;
	ptr_add_cells = gCurrentButton ;
	funcpntrs[no_cmnd++] = (FPV)add_unit_cells ;
	on_highlight() ;
	REVERSE_VIDEO ;
	temdtx(0,10," Enter the # of cells in the x and y direction ! ") ;
	NUM_ACELL = get_int(1) ;
	NUM_BCELL = get_int(1) ;
	NORMAL_VIDEO ;
	eraser(0,0,1020,32) ;
}

void add_unit_cells(long *np,long *mp) {
    long i,j ;
    float *rl_part,*cmplx_part ;

    // If we are looking at the exit wave function, we need to 
    // take the modulus squared of the function to get the image.
    //
    if (EXIT_WAVEF && flag.icmplx) {
		j = *np**mp ;   // number of image points
		rl_part = gWorkSpace ;
		cmplx_part = rl_part+1 ;
		for (i=0;i<j;i++) {
			*(gWorkSpace+i) = *rl_part**rl_part+*cmplx_part**cmplx_part ;
			rl_part += 2 ;
			cmplx_part += 2 ;
		}
		flag.icmplx = FALSE ;
	}
	celext(np,mp,NUM_ACELL,NUM_BCELL,&gSizeError) ;
} 

