// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <math.h>
#include "menudef.h"
#include "params.h"
#include "PhasegratingRecord.h"
void set_nz() ;
/*********************************************************************/
/* Function to set the number of slices to divide the unit cell into */
/* The slice number nz is a function of the maximum reciprocal       */
/*  lattice vector, wavelength and lattice parameters                */
/*********************************************************************/
void set_nz() {

    float wavel,gmax,dz,volt ;
    long u,v,w,nz ;
    float fact ;
    double alpha,beta,gamma,pi,a,b,c,csal,csbe,csga ;
    pi = 3.141596254 ;
  
    fact = 1. ;
    gmax = gInputParameter[8].fv ;
    a = gInputParameter[2].fv ;
    b = gInputParameter[3].fv ;
    c = gInputParameter[4].fv ;
    alpha = pi*gInputParameter[5].fv/180. ;
    beta = pi*gInputParameter[6].fv/180. ;
    gamma = pi*gInputParameter[7].fv/180. ;
    csal = cos(alpha) ;
    csbe = cos(beta) ;
    csga = cos(gamma) ;
    u = gPhsgrtRec->iuvw[0] ;
    v = gPhsgrtRec->iuvw[1] ;
    w = gPhsgrtRec->iuvw[2] ;
    dz = sqrt(u*u*a*a+v*v*b*b+w*w*c*c+2.*u*v*a*b*csga+2.*u*w*a*c*csbe+
              2.*v*w*b*c*csal) ;
    volt = gInputParameter[18].fv ;
    wavel = 1.2263652e-7/sqrt((volt+9.785025e-4*volt*volt)*1000.) ;
    wavel = wavel*1.0e+8 ;
    nz = fact*dz*wavel*gmax*gmax + 1 ;
    if (nz!=gInputParameter[11].iv) {
		gInputParameter[11].iv = nz ;
    }
}
