#include "funcdefs.h"
#include "menudef.h"
#include "devices.h"
#define CONTROL_MENUS 0
#define IMAGES 1
#define EOS '\0'
/* ---------------------------------------------------------- 	*/
/*    Plots a line on either the Workstation, Framestore or   	*/
/*    or the LaserPrinter					  					*/
/* ---------------------------------------------------------- 	*/
void stemdln(long x1,long y1,long x2,long y2) {
	long ix1,iy1,ix2,iy2 ;    
	switch(OutDevice->type) {
		case WS :
			DrawLine(x1,y1,x2,y2) ;
			break ;
		case FS:
			iy1 = y1 ;
			iy2 = y2 ;
			ix1 = x1 ;
			ix2 = x2 ;
			semdln(&ix1,&iy1,&ix2,&iy2) ;
			break ;
		case LP:
			gDrawLine(x1,y1,x2,y2) ;
			break ;
	}
}

/* -------------------------------------------------------	*/
/*    Plots a point on either the CRT or the FRAMEBUFFER	*/
/* -------------------------------------------------------	*/
void stemdpt(long x1,long y1) {
	long iy1 ;    
    
	switch(OutDevice->type) {
		case WS:
			DrawPixel(x1,y1) ;
			break ;
		case FS:
			semdln(&x1,&iy1,&x1,&iy1) ;
			break ;
		case LP:
			gDrawLine(x1,y1,x1,y1) ;
			break ;
	}
}

// -------------------------------------------------------
// subroutine to display a string of text at x,y in pdc 
// -------------------------------------------------------
void stemdtx(long *x,long *y,long *itext,long *len) {
    long ix,iy,i ;    
    char text[80] ;
    long nchar,char_height=7,char_width=8 ;

    for (i=0;i<*len;i++)
	text[i] = itext[i] ;

    text[*len] = EOS ;
    switch(OutDevice->type) {
    	case WS:
        	nchar = strlen(text) ;
        	ix = *x - StringWidth(text)/2 ;
        	iy = *y ;
        	iy = iy - char_height/2 ;
        	DrawText(ix,iy,text) ;
    		break ;
    	case FS:
         	nchar = 0 ;
         	iy = *y ;
         	ix = *x + (nchar-1)*3+3 ;
         	semdtx(itext,&nchar,&ix,&iy) ;
    		break ;
    	case LP:
			nchar = strlen(text) ;
			ix = *x - nchar*char_width/2 ;
			iy = *y ;
			iy += 3 ;
			gDrawText(ix,iy,text) ;
    		break ;
       }
}

/*---------------------------------------------------*/
/* Fill a rectangle with solid pattern               */
/*---------------------------------------------------*/
void stemfil(long x1,long y1,long x2,long y2) {
    long ix1,iy1,ix2,iy2 ;    
  
    switch(OutDevice->type) {
    	case WS:
        	temfil(x1,y1,x2,y2) ;
    		break ;
    	case FS:
			ix1 = x1 ;
			ix2 = x2 ;
			iy1 = y1 ;
			iy2 = y2 ;
			semfil(&ix1,&iy1,&ix2,&iy2) ;
			break ;
    	case LP:
    		break ;
    }
}

/*---------------------------------------------------*/
/* Get the current cursor-location on the display    */
/*---------------------------------------------------*/
void stemdxw(long *x,long *y) {
    switch(OutDevice->type) {
    	case WS:
        	temdxw(x,y) ;
        	*y = OutDevice->yres-1-*y ;
    		break ;
    	case FS:
       		semdxw(x,y) ;
    		break ;
    	case LP:
    		break ;
    }
}

/*-------------------------------------------------------------*/
/* Write a row of data on the display at starting at ix,iy     */
/*-------------------------------------------------------------*/
void stemdro(char *a,long *i,long *j,long *k,long *mode,long *ix,long *iy,float *bot,float *top) {
    long ix1,iy1 ;    

    ix1 = *ix ;
    switch(OutDevice->type) {
    	case WS:    		
			iy1 = *iy ;
			DrawImageLine(ix1,iy1,*j,(unsigned char *)a) ;
			break ;
    	case FS:
      		semdro((float *)a,i,j,k,mode,&ix1,&iy1,bot,top) ;
    		break ;
    	case LP:
			iy1 = *iy ;
			if (*j > 0) {
				gDrawImageLine(ix1,iy1,*j,(unsigned char *)a) ;
			}
			break ;
    }
}

/*-----------------------------------------------------------------*/
/* Read rite a row of data on the display at starting at ix,iy     */
/*------------------------------------------------------------------*/
void stemdri(char *a,long *j,long *mode,long *ix,long *iy,float *bot,float *top) {
    switch(OutDevice->type) {
    	case WS:
		ReadImageLine(*ix,*iy,*j,(unsigned char *)a) ;
    		break ;
    	case FS:
      		semdri((float *)a,j,mode,ix,iy,bot,top) ;
    		break ;
    	case LP:
    		break ;
    }
}

/*-----------------------------*/
/* Erase the current display   */
/*-----------------------------*/
void stemder(long *opcode) {
    switch(OutDevice->type) {
    	case WS:
        	clr_display() ;
    		break ;
    	case FS:
        	semder(opcode) ;
    		break ;
    	case LP:
		break ;
    }
}
