#include <string.h>
#include <stdio.h>
#include "menudef.h"
#define IDY 5
#include "PhasegratingRecord.h"
#include "MslicRecord.h"
#include "displ.h"
#include "layers.h"
#include "params.h"
extern long LAYERED ;
extern char stext[] ;
void eraser(long,long,long,long) ;
void temdtx(long,long,char *) ;

// ------------------------------------------------------------------------	
// rewrite the field corresponding to a changed parameter in the input 
// data                                                              
// ------------------------------------------------------------------------	
void write_par(long i) {

	long j ;
	char stemp[80] ;

	eraser((*gCurrentButton)->xl,(*gCurrentButton)->yl-4,(*gCurrentButton)->xh,(*gCurrentButton)->yh) ;

	sprintf(stext,"%s",(*gCurrentButton)->txt) ;
	switch(i) {
		case 0 : /* Title of the structure */
			sprintf(stemp,"%s",gInputParameter[i].cv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 1 : /* Spacegroup number */
			sprintf(stemp,"%3d",gInputParameter[i].iv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 2 : /* Length of the A - axis */
		case 3 : /* Length of the B - axis */
		case 4 : /* Length of the C - axis */
		case 5 : /* ALPHA in degrees       */
		case 6 : /* BETA in degrees        */
		case 7 : /* GAMMA in degrees       */
		case 8 : /* GMAX in rec. Angstr.   */
			sprintf(stemp,"%8.2f",gInputParameter[i].fv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 9 : /* Zone - axis            */
			sprintf(stemp,"%d %d %d",gPhsgrtRec->iuvw[0],
			gPhsgrtRec->iuvw[1],gPhsgrtRec->iuvw[2]) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 10: 
			if (!LAYERED) {
				/* Number of symmetry operators   */
				sprintf(stemp,"%3d",gInputParameter[i].iv) ;
				strcat(stext,stemp) ;
				temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			}
			else {
				/* Number of different Layers in the structure */
				sprintf(stext,"Numb. of Different Layers :  %d",
				gLayerRec.num_pg) ;
				temdtx(parameter[i].xl,parameter[i].yl+IDY,stext) ;
			}
			break ;
		case 11: 
			if (!LAYERED) {
				/* Number of slices per unit cell */
				sprintf(stemp,"%3d",gInputParameter[i].iv) ;
				strcat(stext,stemp) ;
				temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			}
			else {
				sprintf(stext,"Tot. Numb. of Slices :  %d",
				gLayerRec.num_slc) ;
				temdtx(parameter[i].xl,parameter[i].yl+IDY,stext) ;
			}
			break ;
		case 12: /* Number of atoms in the basis   */
		case 13: /* Number of different atoms      */
			sprintf(stemp,"%3d",gInputParameter[i].iv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 14: /* Microscope name */
			sprintf(stemp,"%s",gInputParameter[i].cv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 15: /* Spherical abberation in mm    */
		case 16: /* Spread of defocus in Angstr.  */
		case 17: /* Divergence half-angle in mrad */
		case 18: /* Microscope voltage in kV      */
		case 19: /* Center of the Laue circle (H) */
		case 20: /* Center of the Laue circle (K) */
			sprintf(stemp,"%8.2f",gInputParameter[i].fv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 21: /* Foil thickness (possibly thru-thickness series) */
			if (gMsliceRec.tts)
				sprintf(stemp,"%.0f(%.0f)%.0f",gMsliceRec.t1,gMsliceRec.dt,gMsliceRec.t2) ;
			else
				sprintf(stemp,"%8.2f",gInputParameter[i].fv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 22: /* Amplitudes output YES/NO                        */
			sprintf(stemp,"%s",gInputParameter[i].cv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			if (gMsliceRec.iplot== 1) {
				temdtx(520,450,"The indices are :     h    k    l") ;
				for(j=0;j<gMsliceRec.nw;j++) {
					sprintf(stext,"%3d %3d %3d",
						gMsliceRec.ihw[j],gMsliceRec.ikw[j],gMsliceRec.ilw[j]);
					temdtx(664,420-j*24,stext) ;
				}
			}
			break ;
		case 23: /* Objective lens defocus (possibly thru def. ser. */
			if (gDisplayRec.tfs)
				sprintf(stemp,"%.0f(%.0f)%.0f",gDisplayRec.f1,gDisplayRec.df,gDisplayRec.f2) ;
			else
				sprintf(stemp,"%8.2f",gInputParameter[i].fv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
		case 24: /* Objective lens aperture in rec. Angstr.  */
		case 25: /* Center of the objective lens apert. (H)  */
		case 26: /* Center of the objective lens apert. (K)  */
		case 27: /* Center of the optic axis in units of H   */
		case 28: /* Center of the optic axis in units of K   */
			sprintf(stemp,"%8.2f",gInputParameter[i].fv) ;
			strcat(stext,stemp) ;
			temdtx((*gCurrentButton)->xl,(*gCurrentButton)->yl+IDY,stext) ;
			break ;
	}
}

