/*
 *  TPeaksControlWindow.cc
 *  xcode_edm
 *
 *  Created by Roar Kilaas on Wed Oct 13 2004.

// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
 *
 */

#include "TPeaksControlWindow.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <time.h>
#include "TFile.h"
#include "numbers.h"

#define hand_width 20
#define hand_height 20
static unsigned char hand_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xe9, 0x00, 0x30, 0x99, 0x00,
   0x48, 0x99, 0x04, 0x48, 0x99, 0x06, 0x88, 0x99, 0x05, 0x10, 0x99, 0x05,
   0x28, 0x00, 0x04, 0x34, 0x00, 0x04, 0x62, 0x00, 0x04, 0x42, 0x00, 0x04,
   0x04, 0x00, 0x04, 0x04, 0x00, 0x02, 0x08, 0x00, 0x02, 0x08, 0x00, 0x02,
   0x10, 0x00, 0x01, 0x10, 0x00, 0x01, 0xe0, 0xff, 0x01, 0x00, 0x00, 0x00};
#define zoom_width 20
#define zoom_height 20
static unsigned char zoom_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0xe0, 0x01, 0x00, 0x10, 0x02, 0x00, 0x08, 0x04, 0x00, 0x08, 0x08, 0x00,
   0x08, 0x08, 0x00, 0x08, 0x08, 0x00, 0x10, 0x04, 0x00, 0x20, 0x06, 0x00,
   0xc0, 0x0d, 0x00, 0x00, 0x18, 0x00, 0x00, 0x30, 0x00, 0x00, 0x60, 0x00,
   0x00, 0xc0, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
#define pointer_width 20
#define pointer_height 20
static unsigned char pointer_bits[] = {
   0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x30, 0x00, 0x00, 0x70, 0x00, 0x00,
   0xf0, 0x00, 0x00, 0xf0, 0x01, 0x00, 0xf0, 0x03, 0x00, 0xf0, 0x07, 0x00,
   0xf0, 0x0f, 0x00, 0xf0, 0x1f, 0x00, 0xf0, 0x03, 0x00, 0xb0, 0x03, 0x00,
   0x10, 0x07, 0x00, 0x00, 0x07, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x0e, 0x00,
   0x00, 0x1c, 0x00, 0x00, 0x1c, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00};
#define ruler_width 20
#define ruler_height 20
static unsigned char ruler_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x02, 0x04, 0x00, 0x02,
   0x24, 0x49, 0x02, 0x24, 0x49, 0x02, 0xfc, 0xff, 0x03, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
#include "TImage.h"
#include "TWindowList.h"
#include "globals.h"
#include "XDrivers.h"
#include "DMMenuCommands.h"
#include "TDMApplicationWindow.h"
#include "graphics.h"
#include "ToolConstants.h"

void	PutMessage(char *) ;
	
extern	TPushButton	*GetCurrentTool() ;
extern	void	SetCurrentTool(TPushButton	*) ;
extern	Cursor	gZoomCursor ;
extern	Cursor	gHandCursor ;
extern  Cursor	gRulerCursor ;
extern	Cursor	gSelectionCursor ;
extern	Cursor	gSpotCursor ;
extern	Cursor	gSpotMaskCursor ;
extern	Cursor	gLatticeMaskCursor ;
extern	Cursor	gWedgeMaskCursor ;
extern	Cursor	gCircleMaskCursor ;
extern	Cursor	gLineMaskCursor ;
extern	Cursor	gRulerCursor ;
extern	Cursor	gApertureCursor ;

extern  TDMApplicationWindow *gTheControlWindow ;
extern	char	*gPlaneGroupSymbols[] ;

extern	void	SetTargetWindow(TWindow *window) ;
extern  TWindow *GetTargetWindow() ;
extern	void	SendApplicationCommand(TCommand command) ; 
extern	void	AddWindow(TWindow *window) ; 
extern	char	*FS98_PATH ;
extern	char	*EDMBinDir ;
extern	short	gImageDepth ;
//Flag as to whether we are operating on a unique image or not -- needs to be implimented
extern	bool	UseUnique ;

void	RemoveFile(char *filename) { unlink(filename) ; } ;
void	RemoveCommunicationFiles() ;
void	RemoveCommunicationFiles() {
	RemoveFile(".edm_1") ;
	RemoveFile(".edm_2") ;
	RemoveFile(".edm_3") ;
}

void	wait(long milliseconds) {
	struct timespec rqtp ;
	struct timespec rmtp ;
	rqtp.tv_sec = 0 ;
	rqtp.tv_nsec = (long)(milliseconds*1.0e+6) ;
	nanosleep(&rqtp,&rmtp) ;
}

TAtomPeak::TAtomPeak() {
	// set the new fields for backwards compatibility
	strcpy(symbol,"") ;
	index = 1 ;
	peak = 1.0 ;
	baseIndex = 0 ;
	usage = kUsePeak ;
}

TAtomPeak::TAtomPeak(TAtomPeak &s) {
	name = s.name ;
	strcpy(symbol,s.symbol) ;
	tag = s.tag ;
	type = s.type ;
	no = s.no ;
	index = s.index ;
	baseIndex = s.baseIndex ;
	usage = s.usage ;
	xc = s.xc ;
	yc = s.yc ;
	zc = s.zc ;
	peak = s.peak ;
	dw = s.dw ;
	occ = s.occ ;
	rad = s.rad ;
	color = s.color ;
	state = s.state ;
	groupnumber = s.groupnumber ;
	refine = s.refine ;	
}

TAtomPeak&
TAtomPeak::operator=(const TAtomPeak& s) {
	name = s.name ;
	strcpy(symbol,s.symbol) ;
	tag = s.tag ;
	type = s.type ;
	no = s.no ;
	index = s.index ;
	baseIndex = s.baseIndex ;
	usage = s.usage ;
	xc = s.xc ;
	yc = s.yc ;
	zc = s.zc ;
	peak = s.peak ;
	dw = s.dw ;
	occ = s.occ ;
	rad = s.rad ;
	color = s.color ;
	state = s.state ;
	groupnumber = s.groupnumber ;
	refine = s.refine ;
	
	return *this ;
}

TAtomPeakEntry::TAtomPeakEntry() {
	mNextAtomEntry = nil ;
	mAtomPeak = nil ;
}

TAtomPeakEntry::~TAtomPeakEntry() {
	mNextAtomEntry = nil ;
	if (mAtomPeak != nil)
		delete mAtomPeak ;
}


TAtomPeakList::TAtomPeakList() {
	mNumAtomPeaks = 0 ;
	mAtomPeakEntry = nil ;
	mLastEntry = mAtomPeakEntry ;
}

TAtomPeakList::~TAtomPeakList() {
	TAtomPeakEntry *entry ;
	TAtomPeakEntry *nextEntry ;
	
	// For every object entry
	entry = mAtomPeakEntry ;
	while(entry != nil) {
		nextEntry = entry->mNextAtomEntry ;
		delete entry ;
		entry = nextEntry ;
		mNumAtomPeaks-- ;
	} ;
}

void TAtomPeakList::AddAtomPeak(TAtomPeak *theAtomPeak) {
	
	TAtomPeakEntry *aNewEntry = new TAtomPeakEntry ;
	aNewEntry->mAtomPeak = theAtomPeak ;
	aNewEntry->mNextAtomEntry = nil ;
	
	// Add to the end of the list
	if (mAtomPeakEntry == nil) {
		mAtomPeakEntry = aNewEntry ;
	}
	else {
		mLastEntry->mNextAtomEntry = aNewEntry ;
	}
	mLastEntry = aNewEntry ;
	mNumAtomPeaks++ ;
}


void TAtomPeakList::RemoveAtomPeak(short num) {
	TAtomPeakEntry* entry;
	TAtomPeakEntry* last;
	int i ;
	
	last = nil;
	//short numToRemove = mNumAtomPeaks - num - 1 ;
	short numToRemove = num ;
	for (i = 0,entry = mAtomPeakEntry ;entry != nil; entry = entry->mNextAtomEntry,i++) {
		if ( i == numToRemove ) {			
			// is the current atom the one to be removed?
			// yes, remove it
			// if first item in list, just set first
				if ( last == nil )				
					mAtomPeakEntry = entry->mNextAtomEntry;
				else
					last->mNextAtomEntry = entry->mNextAtomEntry ;
				
			// Check to see if this is the last entry 
			if (mLastEntry == entry) {
				mLastEntry = last ;
			}
			
			// free the TAtomEntry
				delete entry ;
				mNumAtomPeaks-- ;
				
			// we're done; no need to continue onto the next object
				return;
		}
		else						// no, go onto the next object in the list
			last = entry;
	}
}

TAtomPeak *TAtomPeakList::GetAtomPeak(int number) {
	TAtomPeakEntry* entry;
	int i,numToReturn ;
	
	if (number >= mNumAtomPeaks || number < 0)
		return nil ;
	
	//numToReturn = 	mNumAtomPeaks - number - 1 ;	// Because of the sequence of entries
	numToReturn = number ;
	for (i = 0,entry = mAtomPeakEntry ;entry != nil; entry = entry->mNextAtomEntry,i++) {
		if (i == numToReturn) {
			return entry->mAtomPeak ;
		}
	}
	return nil ;
}


TPeakDisplayList::TPeakDisplayList(Rect	*theListRect) 
	: TList(theListRect,sizeof(TAtomPeak)) {
		mHasColLabels = true ;
}

void 	TPeakDisplayList::ClickCell(ListCellT &inCell) {
	TAtomPeak	theAtomPeak,*thePeak ;
	//Point		where ;
	TPeaksControlWindow *theWindow = (TPeaksControlWindow *)GetParentWindow() ;
	short	width = mCanvasRect.right-mCanvasRect.left ;
	short	colPos = width - 30 ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		if (mSelectedCell.row != inCell.row) {
			mSelectedCell = inCell ;
		}
		else {
			if (mCellClickPos.x > colPos) {
				// Get the atom associated with this position and display parameters
				FetchCellData(inCell,&theAtomPeak) ;
				if (theAtomPeak.usage == kUsePeak)
					theAtomPeak.usage = kTestPeak ;
				else if (theAtomPeak.usage == kTestPeak)
					theAtomPeak.usage = kDoNotUsePeak ;
				else if (theAtomPeak.usage == kDoNotUsePeak)
					theAtomPeak.usage = kUsePeak ;
				SetCellData(inCell,&theAtomPeak) ;
			}
			else if (mCellClickPos.x > 34 && mCellClickPos.x < 64) {
				short	numAtomTypes = theWindow->mAtomTypes->GetNumberOfAtomPeaks() ;
				if (numAtomTypes > 1) {
					// Cycle through the possible atom types
					FetchCellData(inCell,&theAtomPeak) ;
					theAtomPeak.type++ ;
					if (theAtomPeak.type > numAtomTypes) theAtomPeak.type = 1 ;
					thePeak = theWindow->mAtomTypes->GetAtomPeak(theAtomPeak.type-1) ;
					sprintf(theAtomPeak.symbol,"%s%d",thePeak->symbol,inCell.row) ;
					SetCellData(inCell,&theAtomPeak) ;
				}
			}
		}
		theWindow->mRemoveAtomPeak->Enable() ;
	}
	else {
		theWindow->mRemoveAtomPeak->Disable() ;
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void 	TPeakDisplayList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	TAtomPeak	theAtomPeak ;
	short	width = (mCanvasRect.right-mCanvasRect.left -8 - 80)/3 ;
	short	x = cellFrame.left + 60 + 3*width + 8 ;
	short	y = (cellFrame.top+cellFrame.bottom)/2 ;
	
	TextSize(0);
	FetchCellData(inCell,&theAtomPeak) ;

	MoveTo(cellFrame.left + 4, cellFrame.bottom - 4);
	sprintf(str,"%d",theAtomPeak.type) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 30 + 4, cellFrame.bottom - 4);
	sprintf(str,"%s",theAtomPeak.symbol) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 60 + 4, cellFrame.bottom - 4);
	sprintf(str,"%f",theAtomPeak.peak) ;
	DrawString(str) ;
	
	MoveTo(cellFrame.left + 60 + width + 4, cellFrame.bottom - 4);
	sprintf(str,"%f",theAtomPeak.xc) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 60 + 2*width + 4, cellFrame.bottom - 4);
	sprintf(str,"%f",theAtomPeak.yc) ;
	DrawString(str) ;

	switch(theAtomPeak.usage) {
		case kUsePeak:
			MoveTo(x - 4,y-2) ;
			LineTo(x,y+2) ;					
			LineTo(x + 4,y-6) ;
			break ;
		case kTestPeak:
			MoveTo(x, cellFrame.bottom - 4);
			sprintf(str,"?") ;
			DrawString(str) ;
			break ;
		case kDoNotUsePeak:
			MoveTo(x, cellFrame.bottom - 4);
			sprintf(str,"-") ;
			DrawString(str) ;
			break ;
	}
	
}

void 	TPeakDisplayList::DrawColLabel(short colNumber) {
	short	width = (mCanvasRect.right-mCanvasRect.left - 80)/3 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	MoveTo(cellFrame.left + 4, cellFrame.bottom - 4);
	DrawString("Type") ;

	MoveTo(cellFrame.left + 30 + 4, cellFrame.bottom - 4);
	DrawString("Symb") ;
	
	MoveTo(cellFrame.left + 60 + 4 + 10, cellFrame.bottom - 4);
	DrawString("Int") ;

	MoveTo(cellFrame.left + 60 + width + 4 + 10, cellFrame.bottom - 4);
	DrawString("X") ;

	MoveTo(cellFrame.left + 60 + 2*width + 4 + 10, cellFrame.bottom - 4);
	DrawString("Y") ;

	MoveTo(cellFrame.left + 60 + 3*width-4, cellFrame.bottom - 4);
	DrawString("Use") ;

}


TPeakLogList::TPeakLogList(Rect	*theListRect) 
	: TList(theListRect,256) {
}

void 	TPeakLogList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
		
	TextSize(0);
	FetchCellData(inCell,str) ;

	MoveTo(cellFrame.left + 4, cellFrame.bottom - 4);
	DrawString(str) ;
}

TBondList::TBondList(Rect	*theListRect) 
	: TList(theListRect,sizeof(BondRecord)) {
		mHasColLabels = true ;
}

void	TBondList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	BondRecord   theBondRec ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/4 ;
	
	TextSize(0);
	FetchCellData(inCell,&theBondRec) ;

	MoveTo(cellFrame.left + 8, cellFrame.bottom - 4);
	sprintf(str,"%2d  %s",inCell.row,theBondRec.atom1) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 4 + width , cellFrame.bottom - 4);
	DrawString(" - ") ;

	MoveTo(cellFrame.left + 8 + width + 10, cellFrame.bottom - 4);
	sprintf(str,"%s",theBondRec.atom2) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 14 + 2*width , cellFrame.bottom - 4);
	sprintf(str,"%.3f",theBondRec.distance) ;
	DrawString(str) ;
}

void	TBondList::ClickCell(ListCellT &inCell) {
	BondRecord   theBondRec ;
	TConstraintsDialog *theConstraintsDialog = (TConstraintsDialog *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		mSelectedCell = inCell ;
		// Get the atom associated with this position and display parameters
		FetchCellData(inCell,&theBondRec) ;
		theConstraintsDialog->ShowBond(theBondRec) ;
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void	TBondList::DrawColLabel(short colNumber) {
	//short	width = (mCanvasRect.right-mCanvasRect.left)/6 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 12, cellFrame.bottom - 4);
	DrawString("Atom  - Atom     Distance") ;
}



TBumpingList::TBumpingList(Rect	*theListRect) 
	: TList(theListRect,sizeof(BondRecord)) {
		mHasColLabels = true ;
}

void	TBumpingList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	BondRecord   theBondRec ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/4 ;
	
	TextSize(0);
	FetchCellData(inCell,&theBondRec) ;

	MoveTo(cellFrame.left + 8, cellFrame.bottom - 4);
	sprintf(str,"%2d  %s",inCell.row,theBondRec.atom1) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 4 + width , cellFrame.bottom - 4);
	DrawString(" - ") ;

	MoveTo(cellFrame.left + 8 + width + 10, cellFrame.bottom - 4);
	sprintf(str,"%s",theBondRec.atom2) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 8 + 2*width , cellFrame.bottom - 4);
	sprintf(str,"%.3f",theBondRec.distance) ;
	DrawString(str) ;
}

void	TBumpingList::ClickCell(ListCellT &inCell) {
	BondRecord   theBondRec ;
	TConstraintsDialog *theConstraintsDialog = (TConstraintsDialog *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		if (mSelectedCell.row != inCell.row) {
			mSelectedCell = inCell ;
			// Get the atom associated with this position and display parameters
			FetchCellData(inCell,&theBondRec) ;
			theConstraintsDialog->ShowBumping(theBondRec) ;
		}
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void	TBumpingList::DrawColLabel(short colNumber) {
	//short	width = (mCanvasRect.right-mCanvasRect.left)/6 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 12, cellFrame.bottom - 4);
	DrawString("Atom  - Atom     Distance") ;
}


TStochiometryList::TStochiometryList(Rect	*theListRect) 
	: TList(theListRect,sizeof(StochiometryRecord)) {
		mHasColLabels = true ;
}

void	TStochiometryList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	StochiometryRecord   theStochiometryRecord ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/3 ;
	
	TextSize(0);
	FetchCellData(inCell,&theStochiometryRecord) ;

	MoveTo(cellFrame.left + 8, cellFrame.bottom - 4);
	sprintf(str,"%2d %s",inCell.row,theStochiometryRecord.atom) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 16 + width , cellFrame.bottom - 4);
	sprintf(str,"%.2f",theStochiometryRecord.valence) ;
	DrawString(str) ;

}

void	TStochiometryList::ClickCell(ListCellT &inCell) {
	StochiometryRecord   theStochiometryRecord ;
	TConstraintsDialog *theConstraintsDialog = (TConstraintsDialog *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		mSelectedCell = inCell ;
		// Get the atom associated with this position and display parameters
		FetchCellData(inCell,&theStochiometryRecord) ;
		theConstraintsDialog->ShowStochiometry(theStochiometryRecord) ;
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void	TStochiometryList::DrawColLabel(short colNumber) {
	//short	width = (mCanvasRect.right-mCanvasRect.left)/6 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 12, cellFrame.bottom - 4);
	DrawString("Atom     Valence") ;
}


TCoordinationList::TCoordinationList(Rect	*theListRect) 
	: TList(theListRect,sizeof(CoordinationRecord)) {
		mHasColLabels = true ;
}

void	TCoordinationList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	CoordinationRecord   theCoordinationRecord ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/3 ;
	
	TextSize(0);
	FetchCellData(inCell,&theCoordinationRecord) ;

	MoveTo(cellFrame.left + 8, cellFrame.bottom - 4);
	sprintf(str,"%2d %s",inCell.row,theCoordinationRecord.atom) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 8 + width , cellFrame.bottom - 4);
	sprintf(str,"%d",(int) theCoordinationRecord.minNeighbors) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 8 + 2*width , cellFrame.bottom - 4);
	sprintf(str,"%d",(int) theCoordinationRecord.maxNeighbors) ;
	DrawString(str) ;
}

void	TCoordinationList::ClickCell(ListCellT &inCell) {
	CoordinationRecord   theCoordinationRecord ;
	TConstraintsDialog *theConstraintsDialog = (TConstraintsDialog *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		mSelectedCell = inCell ;
		// Get the atom associated with this position and display parameters
		FetchCellData(inCell,&theCoordinationRecord) ;
		theConstraintsDialog->ShowCoordination(theCoordinationRecord) ;
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void	TCoordinationList::DrawColLabel(short colNumber) {
	//short	width = (mCanvasRect.right-mCanvasRect.left)/6 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 12, cellFrame.bottom - 4);
	DrawString("Atom    Min      Max") ;
}


TCellContentList::TCellContentList(Rect	*theListRect) 
	: TList(theListRect,sizeof(CellContentRecord)) {
		mHasColLabels = true ;
}

void	TCellContentList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	CellContentRecord   theCellContentRecord ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/3 ;
	
	TextSize(0);
	FetchCellData(inCell,&theCellContentRecord) ;

	MoveTo(cellFrame.left + 8, cellFrame.bottom - 4);
	sprintf(str,"%2d %s",inCell.row,theCellContentRecord.atom) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 8 + width , cellFrame.bottom - 4);
	sprintf(str,"%d",(int) theCellContentRecord.minNumber) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 8 + 2*width , cellFrame.bottom - 4);
	sprintf(str,"%d",(int) theCellContentRecord.maxNumber) ;
	DrawString(str) ;
}

void	TCellContentList::ClickCell(ListCellT &inCell) {
	CellContentRecord   theCellContentRecord ;
	TConstraintsDialog *theConstraintsDialog = (TConstraintsDialog *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		mSelectedCell = inCell ;
		// Get the atom associated with this position and display parameters
		FetchCellData(inCell,&theCellContentRecord) ;
		theConstraintsDialog->ShowCellContent(theCellContentRecord) ;
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void	TCellContentList::DrawColLabel(short colNumber) {
	//short	width = (mCanvasRect.right-mCanvasRect.left)/6 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 12, cellFrame.bottom - 4);
	DrawString("Atom    Min      Max") ;
}

TPeakSolution&
TPeakSolution::operator=(const TPeakSolution& s) {
	mSolutionNumber = s.mSolutionNumber ;
	mRValue = s.mRValue ;
	mIsCurrent = s.mIsCurrent ;
	mAtomPeakList = s.mAtomPeakList ;	
	return *this ;
}

TPeakSolutionList::TPeakSolutionList(Rect	*theListRect) 
	: TList(theListRect,sizeof(TPeakSolution)) {
		mHasColLabels = true ;
		mSelectedSolution = 1 ;
}

void	TPeakSolutionList::Sort() {
	// Wee need to sort all the entries based on the r-factor
	long gap ;
	register long i,j ;
	register TPeakSolution tempSolution ;
	
	TPeakSolution *theSolutions = new TPeakSolution[mRows] ;
	
	// Get all the solutions
	ListCellT inCell ;
	inCell.col = 1 ;
	
	short	numSolutions = mRows ;
	
	for(i = 0 ; i < numSolutions; i++) {
		inCell.row = i+1 ; 
		FetchCellData(inCell,&theSolutions[i]) ;
	}
	// Sort on increasing r-values
	
	for (gap=numSolutions/2;gap>0;gap/=2)
		for(i=gap;i<numSolutions;i++)
			for(j=i-gap;j>=0;j-=gap)
				{
					if (theSolutions[j].mRValue <= theSolutions[j+gap].mRValue)
						break ;
					tempSolution = theSolutions[j] ;
					theSolutions[j] = theSolutions[j+gap] ;
					theSolutions[j+gap] = tempSolution ;
			  	}
				
	// Set solution numbers according to the sequence and set is current to the first
	RemoveAllRows() ;
	for(i=0; i < numSolutions; i++) {
		theSolutions[i].mIsCurrent = false ; 
		if (i == 0) theSolutions[i].mIsCurrent = true ;
		theSolutions[i].mSolutionNumber = i+1 ;
		AddRow(&theSolutions[i]) ;
	}
	
	delete[] theSolutions ;
}

void 	TPeakSolutionList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	TPeakSolution   thePeakSolution ;
	short	width = (mCanvasRect.right-mCanvasRect.left)/4 ;
	
	TextSize(0);
	FetchCellData(inCell,&thePeakSolution) ;
	
	if (thePeakSolution.mIsCurrent) {
		MoveTo(cellFrame.left+width/2 - 4,(cellFrame.top+cellFrame.bottom)/2-2) ;
		LineTo(cellFrame.left+width/2,(cellFrame.top+cellFrame.bottom)/2+2) ;					
		LineTo(cellFrame.left+width/2 + 4,(cellFrame.top+cellFrame.bottom)/2-6) ;					
	} 

	MoveTo(cellFrame.left + width + 20, cellFrame.bottom - 4);
	sprintf(str,"%d",thePeakSolution.mSolutionNumber) ;
	DrawString(str) ;

	MoveTo(cellFrame.left + 2*width + 12, cellFrame.bottom - 4);
	sprintf(str,"%d",thePeakSolution.mAtomPeakList->GetNumberOfAtomPeaks()) ;
	DrawString(str) ;
		
	MoveTo(cellFrame.left + 3*width + 4, cellFrame.bottom - 4);
	sprintf(str,"%f",thePeakSolution.mRValue) ;
	DrawString(str) ;	
}


void TPeakSolutionList::ClickCell(
	ListCellT &inCell) 
{
	TPeakSolution   thePeakSolution ;
	TPeaksControlWindow *thePeaksControlWindow = (TPeaksControlWindow *)GetParentWindow() ;
	if (inCell.row > 0 && inCell.row <= mRows) {
		if (mSelectedCell.row != inCell.row) {
			mSelectedCell = inCell ;
			// Get the atoms associated with this solution and put them in the atom list
			FetchCellData(inCell,&thePeakSolution) ;
			thePeaksControlWindow->UpdateAtomList(thePeakSolution.mAtomPeakList) ;
		}
		else {	
			short	width = (mCanvasRect.right-mCanvasRect.left)/3 ;
			if (mCellClickPos.x < width) {
				if (mSelectedSolution != inCell.row) {
					// Deselect the current solution
					ListCellT selectedCell = inCell ;
					selectedCell.row = mSelectedSolution ;
					FetchCellData(selectedCell,&thePeakSolution) ;
					thePeakSolution.mIsCurrent = false ;
					SetCellData(selectedCell,&thePeakSolution) ;
					mSelectedSolution = inCell.row ;
					// Set this solution as current
					FetchCellData(inCell,&thePeakSolution) ;
					thePeakSolution.mIsCurrent = true ;
					SetCellData(inCell,&thePeakSolution) ;
					thePeaksControlWindow->SetSelectedSolutionAsCurrent(mSelectedSolution) ;
				}
			}
		}
	}
	else {
		mSelectedCell.row = mSelectedCell.col = 0 ;
	}
	Refresh() ;
}

void 	TPeakSolutionList::DrawColLabel(short colNumber) {
	short	width = (mCanvasRect.right-mCanvasRect.left)/4 ;
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);
	
	MoveTo(cellFrame.left + 4, cellFrame.bottom - 4);
	DrawString("Set as Current") ;

	MoveTo(cellFrame.left + width + 4, cellFrame.bottom - 4);
	DrawString("Solution #") ;

	MoveTo(cellFrame.left + 2*width + 4, cellFrame.bottom - 4);
	DrawString("# Atoms") ;

	MoveTo(cellFrame.left + 3*width + 4, cellFrame.bottom - 4);
	DrawString("FOM") ;
}

THKLDisplayList::THKLDisplayList(Rect	*theListRect) 
	: TList(theListRect,sizeof(PeakHKLRecord)) {
		mHasColLabels = true ;
}

void 	THKLDisplayList::DrawCellValue(ListCellT &inCell,Rect &cellFrame) {
	char str[256] ;
	PeakHKLRecord	thePeakHKLRecord ;
	short	width ;
	
	TextSize(0);
	FetchCellData(inCell,&thePeakHKLRecord) ;


	switch(mHKLDisplayMode) {
		case kHKLDisplayExperimentalDP:
			width = (mCanvasRect.right-mCanvasRect.left -8)/4 ;
			MoveTo(cellFrame.left + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			sprintf(str,"%4d %4d %4d",(int) thePeakHKLRecord.h,(int) thePeakHKLRecord.k,(int) thePeakHKLRecord.l) ;
			DrawString(str) ;
			
			MoveTo(cellFrame.left + width + (width-StringWidth("Measured"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.expVal) ;
			DrawString(str) ;

			MoveTo(cellFrame.left + 2*width + (width-StringWidth("Error"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.error) ;
			DrawString(str) ;
			break ;
		case kHKLkDisplayCalculatedDP:
			width = (mCanvasRect.right-mCanvasRect.left -8)/4 ;
			MoveTo(cellFrame.left + 4 + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			sprintf(str,"%4d %4d %4d",(int) thePeakHKLRecord.h,(int) thePeakHKLRecord.k,(int) thePeakHKLRecord.l) ;
			DrawString(str) ;
			
			MoveTo(cellFrame.left + width + (width-StringWidth("Calculated"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.calcVal) ;
			DrawString(str) ;
			break ;
		case kHKLDisplayFourierFit:
			width = (mCanvasRect.right-mCanvasRect.left -8)/4 ;
			MoveTo(cellFrame.left + 4 + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			sprintf(str,"%4d %4d %4d",(int) thePeakHKLRecord.h,(int) thePeakHKLRecord.k,(int) thePeakHKLRecord.l) ;
			DrawString(str) ;

			MoveTo(cellFrame.left + width + (width-StringWidth("Calculated"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.calcVal) ;
			DrawString(str) ;
			
			MoveTo(cellFrame.left + 2*width + (width-StringWidth("Measured"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.expVal) ;
			DrawString(str) ;

			MoveTo(cellFrame.left + 3*width + 4 + (width-StringWidth("Difference"))/2, cellFrame.bottom - 4);
			sprintf(str,"%f",thePeakHKLRecord.error) ;
			DrawString(str) ;
	}
}

void 	THKLDisplayList::DrawColLabel(short colNumber) {
	
	Rect	cellFrame;
	
	if (mHasRowLabels)
		SetRect(&cellFrame,colNumber*mColWidth,0,(colNumber+1)*mColWidth,mRowHeight) ;
	else
		SetRect(&cellFrame,(colNumber-1)*mColWidth,0,colNumber*mColWidth,mRowHeight) ;
		
	if (colNumber != 0) 
		::OffsetRect(&cellFrame,near(mListOrigin.x),0) ;
	InsetRect(&cellFrame,1,1) ;
	SetFgColor(gGrayPixel) ;
	PaintRect(&cellFrame) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(cellFrame.left,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.top) ;
	SetFgColor(gBlackPixel) ;
	MoveTo(cellFrame.right,cellFrame.top) ;
	LineTo(cellFrame.right,cellFrame.bottom) ;
	LineTo(cellFrame.left,cellFrame.bottom) ;
	InsetRect(&cellFrame,-1,-1) ;
	TextSize(0);

	short	width ;
	switch(mHKLDisplayMode) {
		case kHKLDisplayExperimentalDP:
			width = (mCanvasRect.right-mCanvasRect.left - 8)/4 ;

			MoveTo(cellFrame.left + 4 + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			DrawString("  h  k  l ") ;
			
			MoveTo(cellFrame.left + width + 4 + (width-StringWidth("Measured"))/2, cellFrame.bottom - 4);
			DrawString("Measured") ;

			MoveTo(cellFrame.left + 2*width + 4 + (width-StringWidth("Error"))/2, cellFrame.bottom - 4);
			DrawString("Error") ;
			break ;
		case kHKLkDisplayCalculatedDP:
			width = (mCanvasRect.right-mCanvasRect.left - 8)/4 ;

			MoveTo(cellFrame.left + 4 + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			DrawString("  h  k  l ") ;
			
			MoveTo(cellFrame.left + width + 4 + (width-StringWidth("Calculated"))/2, cellFrame.bottom - 4);
			DrawString("Calculated") ;
			break ;
		case kHKLDisplayFourierFit:
			width = (mCanvasRect.right-mCanvasRect.left - 8)/4 ;

			MoveTo(cellFrame.left + 4 + (width-StringWidth("  h  k  l "))/2, cellFrame.bottom - 4);
			DrawString("  h  k  l ") ;

			MoveTo(cellFrame.left + width + 4 + (width-StringWidth("Calculated"))/2, cellFrame.bottom - 4);
			DrawString("Calculated") ;
			
			MoveTo(cellFrame.left + 2*width + 4 + (width-StringWidth("Measured"))/2, cellFrame.bottom - 4);
			DrawString("Measured") ;

			MoveTo(cellFrame.left + 3*width + 4 + (width-StringWidth("Difference"))/2, cellFrame.bottom - 4);
			DrawString("Difference") ;
	}

}

TConstraintsDialog::TConstraintsDialog(TAtomPeakList *atomList,TConstraints *theConstraints) 
	: TDialog(140,50,656,480,"Chemical Constraints") {
	
	Rect	theRect,theRect1,theRect2 ;
	//TStaticText	*theText ;
	char	text[256] ;
	long	i,j ;
	TAtomPeak   *thePeak ;
	TGroupBox	*theBondBox,*theBumpingBox,*theStochiometryBox,*theCoordinationBox,*theCellContentBox ;
	
	long	width = mPortRect.right - mPortRect.left ;
	long	height = mPortRect.bottom - mPortRect.top ;
	
	// Set Bonding constraints
	SetRect(&theRect,10,10,10+310,10+height/2-40) ;
	theBondBox = new TGroupBox(&theRect,"Bond Constraint") ;
	AddObject(theBondBox) ;
	SetRect(&theRect1,theRect.left+10,theRect.top+10,theRect.left+10+60,theRect.top+10+80) ;
	mBondAtom1 = new TList(&theRect1) ;
	AddObject(mBondAtom1) ;
	theRect1 = mBondAtom1->GetRect() ;
	
	OffsetRect(&theRect1,theRect1.right-theRect1.left+20,0) ;
	mBondAtom2 = new TList(&theRect1) ;
	AddObject(mBondAtom2) ;
	
	for(i = 0 ; i < atomList->GetNumberOfAtomPeaks(); i++) {
		thePeak = atomList->GetAtomPeak(i) ;
		mBondAtom1->AddRow(thePeak->symbol) ;
		mBondAtom2->AddRow(thePeak->symbol) ;
	}

	
	theRect = mBondAtom1->GetRect() ;
	theRect1 = mBondAtom2->GetRect() ;
	theRect2 = theBondBox->GetRect() ;
	theRect.top = theRect.bottom+10 ;
	theRect.right = theRect1.right ;
	theRect.bottom = theRect2.bottom-10 ;
	mBondList = new TBondList(&theRect) ;
	AddObject(mBondList) ;
	
	if (theConstraints->mBonds != nil) {
		for(j = 0 ; j < theConstraints->mBonds->mNumBonds; j++) {
			mBondList->AddRow(theConstraints->mBonds->mBondRec+j) ;
		}
	}
	
	theRect1.right = theRect2.right -10 ;
	theRect1.left = theRect1.right-40 ;
	theRect1.top = theRect2.top+10 ;
	theRect1.bottom = theRect1.top + 20 ;
	mBondDistance = new TEditText(&theRect1,"Bond distance [A]  ","2.000") ;

	theRect = mBondAtom2->GetRect() ;
	OffsetRect(&theRect1,0,30) ;
	theRect1.left = theRect.right+10 ;
	theRect1.bottom = theRect1.top+24 ;
	theRect1.right = (theRect1.right + theRect1.left)/2 - 4 ;
	mAddBond = new TButton(&theRect1,"Add") ;
	AddObject(mAddBond) ;
	
	if (atomList->GetNumberOfAtomPeaks() > 0) {
		mBondAtom1->SelectRow(1) ;
		mBondAtom2->SelectRow(1) ;
	}
	else {
		mAddBond->Disable() ;
	}
	
	OffsetRect(&theRect1,theRect1.right - theRect1.left + 8,0) ;
	mModifyBond = new TButton(&theRect1,"Modify") ;
	AddObject(mModifyBond) ;
	mModifyBond->Disable() ;

	theRect1 = mAddBond->GetRect() ;
	OffsetRect(&theRect1,0,30) ;
	mDeleteBond = new TButton(&theRect1,"Delete") ;
	AddObject(mDeleteBond) ;
	mDeleteBond->Disable() ;
	
	theRect = mBondDistance->GetRect() ;
	OffsetRect(&theRect,0,90) ;
	mBondWeight = new TEditText(&theRect,"Weight  ","1.0") ;
	
	theRect = mBondWeight->GetRect() ;
	OffsetRect(&theRect,-(theRect.right-theRect.left),30) ;
	theRect.right += 20 ;
	mBondActive = new TCheckBox(&theRect,"Active",false) ;
	AddObject(mBondActive) ;

	if (theConstraints->mBonds != nil) {
		sprintf(text,"%.2f",theConstraints->mBonds->mWeight) ;
		mBondWeight->SetEditText(text) ;
		sprintf(text,"%.3f",theConstraints->mBonds->mBondRec->distance) ;
		mBondDistance->SetEditText(text) ;
		mBondActive->SetState(theConstraints->mBonds->mActive) ;
	}

	// Set Bumping Constraints
	theRect = theBondBox->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+10) ;
	theBumpingBox = new TGroupBox(&theRect,"Bumping Constraint") ;
	AddObject(theBumpingBox) ;
	SetRect(&theRect1,theRect.left+10,theRect.top+10,theRect.left+10+60,theRect.top+10+80) ;
	mBumpingAtom1 = new TList(&theRect1) ;
	AddObject(mBumpingAtom1) ;
	theRect1 = mBumpingAtom1->GetRect() ;
	
	OffsetRect(&theRect1,theRect1.right-theRect1.left+20,0) ;
	mBumpingAtom2 = new TList(&theRect1) ;
	AddObject(mBumpingAtom2) ;
	
	for(i = 0 ; i < atomList->GetNumberOfAtomPeaks(); i++) {
		thePeak = atomList->GetAtomPeak(i) ;
		mBumpingAtom1->AddRow(thePeak->symbol) ;
		mBumpingAtom2->AddRow(thePeak->symbol) ;
	}

	
	theRect = mBumpingAtom1->GetRect() ;
	theRect1 = mBumpingAtom2->GetRect() ;
	theRect2 = theBumpingBox->GetRect() ;
	theRect.top = theRect.bottom+10 ;
	theRect.right = theRect1.right ;
	theRect.bottom = theRect2.bottom-10 ;
	mBumpingList = new TBumpingList(&theRect) ;
	AddObject(mBumpingList) ;
	
	if (theConstraints->mBumpingBonds != nil) {
		for(j = 0 ; j < theConstraints->mBumpingBonds->mNumBonds; j++) {
			mBumpingList->AddRow(theConstraints->mBumpingBonds->mBondRec+j) ;
		}
	}
	
	theRect1.right = theRect2.right -10 ;
	theRect1.left = theRect1.right-40 ;
	theRect1.top = theRect2.top+10 ;
	theRect1.bottom = theRect1.top + 20 ;
	mBumpingDistance = new TEditText(&theRect1,"Bumping distance [A]  ","2.0") ;

	theRect = mBumpingAtom2->GetRect() ;
	OffsetRect(&theRect1,0,30) ;
	theRect1.left = theRect.right+10 ;
	theRect1.bottom = theRect1.top+24 ;
	theRect1.right = (theRect1.right + theRect1.left)/2 - 4 ;
	mAddBumping = new TButton(&theRect1,"Add") ;
	AddObject(mAddBumping) ;
	
	if (atomList->GetNumberOfAtomPeaks() > 0) {
		mBumpingAtom1->SelectRow(1) ;
		mBumpingAtom2->SelectRow(1) ;
	}
	else {
		mAddBumping->Disable() ;
	}
	
	OffsetRect(&theRect1,theRect1.right - theRect1.left + 8,0) ;
	mModifyBumping = new TButton(&theRect1,"Modify") ;
	AddObject(mModifyBumping) ;
	mModifyBumping->Disable() ;

	theRect1 = mAddBumping->GetRect() ;
	OffsetRect(&theRect1,0,30) ;
	mDeleteBumping = new TButton(&theRect1,"Delete") ;
	AddObject(mDeleteBumping) ;
	mDeleteBumping->Disable() ;
	
	theRect = mBumpingDistance->GetRect() ;
	OffsetRect(&theRect,0,90) ;
	mBumpingWeight = new TEditText(&theRect,"Weight  ","1.0") ;
	
	theRect = mBumpingWeight->GetRect() ;
	OffsetRect(&theRect,-(theRect.right-theRect.left),30) ;
	theRect.right += 20 ;
	mBumpingActive = new TCheckBox(&theRect,"Active",false) ;
	AddObject(mBumpingActive) ;

	if (theConstraints->mBumpingBonds != nil) {
		sprintf(text,"%.2f",theConstraints->mBumpingBonds->mWeight) ;
		mBumpingWeight->SetEditText(text) ;
		sprintf(text,"%.3f",theConstraints->mBumpingBonds->mBondRec->distance) ;
		mBumpingDistance->SetEditText(text) ;
		mBumpingActive->SetState(theConstraints->mBumpingBonds->mActive) ;
	}


	// Stochiometry
	theRect = theBondBox->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	theRect.bottom = theRect.top + height/3 - 30 ;
	theStochiometryBox = new TGroupBox(&theRect,"Stochiometry") ;
	AddObject(theStochiometryBox) ;
	SetRect(&theRect1,theRect.left+10,theRect.top+10,theRect.left+10+60,theRect.top+10+90) ;
	mStochiometryAtom = new TList(&theRect1) ;
	AddObject(mStochiometryAtom) ;
	theRect1 = mStochiometryAtom->GetRect() ;
	
	OffsetRect(&theRect1,theRect1.right-theRect1.left+10,0) ;
	theRect1.right = (theRect.left + 2*theRect.right)/3 ;
	mStochiometryList = new TStochiometryList(&theRect1) ;
	AddObject(mStochiometryList) ;
	
	theRect = theStochiometryBox->GetRect() ;
	theRect1.right = theRect.right-10 ;
	theRect1.left = theRect1.right - 40 ;
	theRect1.top = theRect.top + 10 ;
	theRect1.bottom = theRect1.top + 20 ;
	mStochiometryValence = new TEditText(&theRect1,"Valence ","1.0") ;
	OffsetRect(&theRect1,0,30) ;
	mStochiometryBase = new TEditText(&theRect1,"Base ","0.0") ;
	
	for(i = 0 ; i < atomList->GetNumberOfAtomPeaks(); i++) {
		thePeak = atomList->GetAtomPeak(i) ;
		mStochiometryAtom->AddRow(thePeak->symbol) ;
	}

	if (theConstraints->mStochiometry != nil) {
		for(j = 0 ; j < theConstraints->mStochiometry->mNumConstraints; j++) {
			mStochiometryList->AddRow(theConstraints->mStochiometry->mStochiometryRecord+j) ;
		}
	}

	theRect = mStochiometryAtom->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+6) ;
	theRect.bottom = theRect.top + 20 ;
	mAddStochiometry = new TButton(&theRect,"Add") ;
	AddObject(mAddStochiometry) ;
	
	if (atomList->GetNumberOfAtomPeaks() > 0) {
		mStochiometryAtom->SelectRow(1) ;
	}
	else {
		mAddStochiometry->Disable() ;
	}
	
	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mModifyStochiometry = new TButton(&theRect,"Modify") ;
	AddObject(mModifyStochiometry) ;
	mModifyStochiometry->Disable() ;

	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mDeleteStochiometry = new TButton(&theRect,"Delete") ;
	AddObject(mDeleteStochiometry) ;
	mDeleteStochiometry->Disable() ;
	
	theRect1 = mStochiometryBase->GetRect() ;
	theRect2 = mAddStochiometry->GetRect() ;
	SetRect(&theRect,theRect1.left,theRect2.top-24,theRect1.right,theRect2.bottom-24) ;
	mStochiometryWeight = new TEditText(&theRect,"Weight  ","1.0") ;
	
	theRect1 = mDeleteStochiometry->GetRect() ;
	theRect2 = mStochiometryList->GetRect() ;
	SetRect(&theRect,theRect2.right+10,theRect1.top,theRect2.right+100,theRect1.bottom) ;
	mStochiometryActive = new TCheckBox(&theRect,"Active",false) ;
	AddObject(mStochiometryActive) ;

	if (theConstraints->mStochiometry != nil) {
		sprintf(text,"%.2f",theConstraints->mStochiometry->mWeight) ;
		mStochiometryWeight->SetEditText(text) ;
		sprintf(text,"%.2f",theConstraints->mStochiometry->mBase) ;
		mStochiometryBase->SetEditText(text) ;
		mStochiometryActive->SetState(theConstraints->mStochiometry->mActive) ;
	}

	
	// Co-ordination
	theRect = theStochiometryBox->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+10) ;
	theCoordinationBox = new TGroupBox(&theRect,"Co-ordination") ;
	AddObject(theCoordinationBox) ;

	SetRect(&theRect1,theRect.left+10,theRect.top+10,theRect.left+10+60,theRect.top+10+90) ;
	mCoordinationAtom = new TList(&theRect1) ;
	AddObject(mCoordinationAtom) ;
	theRect1 = mCoordinationAtom->GetRect() ;
	
	OffsetRect(&theRect1,theRect1.right-theRect1.left+10,0) ;
	theRect1.right = (theRect.left + 2*theRect.right)/3 ;
	mCoordinationList = new TCoordinationList(&theRect1) ;
	AddObject(mCoordinationList) ;
	
	theRect = theCoordinationBox->GetRect() ;
	theRect1.right = theRect.right-10 ;
	theRect1.left = theRect1.right - 40 ;
	theRect1.top = theRect.top + 10 ;
	theRect1.bottom = theRect1.top + 20 ;
	mCoordinationMin = new TEditText(&theRect1,"Minimum ","1") ;
	OffsetRect(&theRect1,0,30) ;
	mCoordinationMax = new TEditText(&theRect1,"Maximum ","1") ;
	
	for(i = 0 ; i < atomList->GetNumberOfAtomPeaks(); i++) {
		thePeak = atomList->GetAtomPeak(i) ;
		mCoordinationAtom->AddRow(thePeak->symbol) ;
	}

	if (theConstraints->mCoordination != nil) {
		for(j = 0 ; j < theConstraints->mCoordination->mNumConstraints; j++) {
			mCoordinationList->AddRow(theConstraints->mCoordination->mCoordinationRecord+j) ;
		}
	}

	theRect = mCoordinationAtom->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+6) ;
	theRect.bottom = theRect.top + 20 ;
	mAddCoordination = new TButton(&theRect,"Add") ;
	AddObject(mAddCoordination) ;
	
	if (atomList->GetNumberOfAtomPeaks() > 0) {
		mCoordinationAtom->SelectRow(1) ;
	}
	else {
		mAddCoordination->Disable() ;
	}
	
	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mModifyCoordination = new TButton(&theRect,"Modify") ;
	AddObject(mModifyCoordination) ;
	mModifyCoordination->Disable() ;

	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mDeleteCoordination = new TButton(&theRect,"Delete") ;
	AddObject(mDeleteCoordination) ;
	mDeleteCoordination->Disable() ;
	
	theRect1 = mCoordinationMax->GetRect() ;
	theRect2 = mAddCoordination->GetRect() ;
	SetRect(&theRect,theRect1.left,theRect2.top-24,theRect1.right,theRect2.bottom-24) ;
	mCoordinationWeight = new TEditText(&theRect,"Weight  ","1.0") ;
	
	theRect1 = mDeleteCoordination->GetRect() ;
	theRect2 = mCoordinationList->GetRect() ;
	SetRect(&theRect,theRect2.right+10,theRect1.top,theRect2.right+100,theRect1.bottom) ;
	mCoordinationActive = new TCheckBox(&theRect,"Active",false) ;
	AddObject(mCoordinationActive) ;

	if (theConstraints->mCoordination != nil) {
		sprintf(text,"%.2f",theConstraints->mCoordination->mWeight) ;
		mCoordinationWeight->SetEditText(text) ;
		mCoordinationActive->SetState(theConstraints->mCoordination->mActive) ;
	}

	
	// CellContent
	theRect = theCoordinationBox->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+10) ;
	theCellContentBox = new TGroupBox(&theRect,"Cell Content") ;
	AddObject(theCellContentBox) ;

	SetRect(&theRect1,theRect.left+10,theRect.top+10,theRect.left+10+60,theRect.top+10+90) ;
	mCellContentAtom = new TList(&theRect1) ;
	AddObject(mCellContentAtom) ;
	theRect1 = mCellContentAtom->GetRect() ;
	
	OffsetRect(&theRect1,theRect1.right-theRect1.left+10,0) ;
	theRect1.right = (theRect.left + 2*theRect.right)/3 ;
	mCellContentList = new TCellContentList(&theRect1) ;
	AddObject(mCellContentList) ;
	
	theRect = theCellContentBox->GetRect() ;
	theRect1.right = theRect.right-10 ;
	theRect1.left = theRect1.right - 40 ;
	theRect1.top = theRect.top + 10 ;
	theRect1.bottom = theRect1.top + 20 ;
	mCellContentMin = new TEditText(&theRect1,"Minimum ","1") ;
	OffsetRect(&theRect1,0,30) ;
	mCellContentMax = new TEditText(&theRect1,"Maximum ","1") ;
	
	for(i = 0 ; i < atomList->GetNumberOfAtomPeaks(); i++) {
		thePeak = atomList->GetAtomPeak(i) ;
		mCellContentAtom->AddRow(thePeak->symbol) ;
	}

	if (theConstraints->mCellContent != nil) {
		for(j = 0 ; j < theConstraints->mCellContent->mNumConstraints; j++) {
			mCellContentList->AddRow(theConstraints->mCellContent->mCellContentRecord+j) ;
		}
	}

	theRect = mCellContentAtom->GetRect() ;
	OffsetRect(&theRect,0,theRect.bottom-theRect.top+6) ;
	theRect.bottom = theRect.top + 20 ;
	mAddCellContent = new TButton(&theRect,"Add") ;
	AddObject(mAddCellContent) ;
	
	if (atomList->GetNumberOfAtomPeaks() > 0) {
		mCellContentAtom->SelectRow(1) ;
	}
	else {
		mAddCellContent->Disable() ;
	}
	
	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mModifyCellContent = new TButton(&theRect,"Modify") ;
	AddObject(mModifyCellContent) ;
	mModifyCellContent->Disable() ;

	OffsetRect(&theRect,theRect.right - theRect.left + 8,0) ;
	mDeleteCellContent = new TButton(&theRect,"Delete") ;
	AddObject(mDeleteCellContent) ;
	mDeleteCellContent->Disable() ;
	
	theRect1 = mCellContentMax->GetRect() ;
	theRect2 = mAddCellContent->GetRect() ;
	SetRect(&theRect,theRect1.left,theRect2.top-24,theRect1.right,theRect2.bottom-24) ;
	mCellContentWeight = new TEditText(&theRect,"Weight  ","1.0") ;
	
	theRect1 = mDeleteCellContent->GetRect() ;
	theRect2 = mCellContentList->GetRect() ;
	SetRect(&theRect,theRect2.right+10,theRect1.top,theRect2.right+100,theRect1.bottom) ;
	mCellContentActive = new TCheckBox(&theRect,"Active",false) ;
	AddObject(mCellContentActive) ;

	if (theConstraints->mCellContent != nil) {
		sprintf(text,"%.2f",theConstraints->mCellContent->mWeight) ;
		mCellContentWeight->SetEditText(text) ;
		mCellContentActive->SetState(theConstraints->mCellContent->mActive) ;
	}
		
	
	AddTextEditObject(mCellContentWeight) ;
	AddTextEditObject(mCellContentMax) ;
	AddTextEditObject(mCellContentMin) ;
	
	AddTextEditObject(mCoordinationWeight) ;
	AddTextEditObject(mCoordinationMax) ;
	AddTextEditObject(mCoordinationMin) ;	

	AddTextEditObject(mStochiometryWeight) ;
	AddTextEditObject(mStochiometryBase) ;
	AddTextEditObject(mStochiometryValence) ;

	AddTextEditObject(mBumpingWeight) ;
	AddTextEditObject(mBumpingDistance) ;

	AddTextEditObject(mBondWeight) ;
	AddTextEditObject(mBondDistance) ;
	
	mOKButton = new TButton(width-16-70,height-16-20,width-16,height-16,"Set") ;
	AddObject(mOKButton) ;
	theRect = mOKButton->GetRect() ;
	OffsetRect(&theRect,-(theRect.right-theRect.left+10),0) ;
	mCancelButton = new TButton(&theRect,"Cancel") ;
	AddObject(mCancelButton) ;
	SetDefaultButton(mOKButton) ;
	
}

void	TConstraintsDialog::DoMouseDownInObject(TObject *obj,Point *pt) {
	char	text[256] ;
	BondRecord   theBondRec ;
	StochiometryRecord   theStochiometryRec ;
	CoordinationRecord   theCoordinationRec ;
	CellContentRecord   theContentRec ;
	//short	theSelectedRow ;
	ListCellT	theCell ;
	
	theCell.col = 1 ;
	if (pt != nil)
		if (!obj->DoMouseDown(pt)) return ;
	if (obj == mOKButton) {
		mDone = true ;
		mDialogReturnCode = kDialogOK ;
	}
	else if (obj == mCancelButton) {
		mDone = true ;
		mDialogReturnCode = kDialogCancel ;
	}
	else if (obj == mBondAtom1) {
		if (HasFirstBondSelection() && HasSecondBondSelection()) 
			EnableAddBond() ;
		else
			DisableAddBond() ;
	}
	else if (obj == mBondAtom2) {
		if (HasFirstBondSelection() && HasSecondBondSelection()) 
			EnableAddBond() ;
		else
			DisableAddBond() ;
	}
	else if (obj == mBondList) {
		if (mBondList->GetSelectedRow() > 0) {
			EnableModifyBond() ;
			EnableDeleteBond() ;
		}
		else {
			DisableModifyBond() ;
			DisableDeleteBond() ;
		}
	}
	else if (obj == mAddBond) {
		// Add a row based on the information in the atom fields
		if (HasFirstBondSelection() && HasSecondBondSelection()) {
			theCell = mBondAtom1->GetSelectedCell() ;
			mBondAtom1->FetchCellData(theCell,text) ;
			strcpy(theBondRec.atom1,text) ;
			theCell = mBondAtom2->GetSelectedCell() ;
			mBondAtom2->FetchCellData(theCell,text) ;
			strcpy(theBondRec.atom2,text) ;
			mBondDistance->GetEditText(text) ;
			theBondRec.distance = atof(text) ;
			mBondList->AddRow(&theBondRec) ;
			mBondActive->SetState(true) ;
		}
	}
	else if (obj == mDeleteBond) {
		// Delete selected row
		if (mBondList->HasSelection()) {
			theCell = mBondList->GetSelectedCell() ;
			mBondList->RemoveRow(theCell.row) ;
			if (theCell.row <= mBondList->GetNumberOfListItems()) {
				mBondList->ClickCell(theCell) ;
			}
			if (mBondList->GetSelectedRow() == 0) {
				DisableModifyBond() ;
				DisableDeleteBond() ;
				mBondActive->SetState(false) ;
			}
		}
	}
	else if (obj == mModifyBond) {
		// Modify a row based on the information in the atom fields
		// Add a row based on the information in the atom fields
		theCell = mBondList->GetSelectedCell() ;
		if (theCell.row <= mBondList->GetNumberOfListItems()) {
			mBondList->FetchCellData(theCell,&theBondRec) ;
			mBondDistance->GetEditText(text) ;
			theBondRec.distance = atof(text);
			mBondList->SetCellData(theCell,&theBondRec) ;
			mBondList->Refresh() ;
		}
	}
	// Bumping
	else if (obj == mBumpingAtom1) {
		if (HasFirstBumpingSelection() && HasSecondBumpingSelection()) 
			EnableAddBumping() ;
		else
			DisableAddBumping() ;
	}
	else if (obj == mBumpingAtom2) {
		if (HasFirstBumpingSelection() && HasSecondBumpingSelection()) 
			EnableAddBumping() ;
		else
			DisableAddBumping() ;
	}
	else if (obj == mBumpingList) {
		if (mBumpingList->GetSelectedRow() > 0) {
			EnableModifyBumping() ;
			EnableDeleteBumping() ;
		}
		else {
			DisableModifyBumping() ;
			DisableDeleteBumping() ;
		}
	}
	else if (obj == mAddBumping) {
		// Add a row based on the information in the atom fields
		if (HasFirstBumpingSelection() && HasSecondBumpingSelection()) {
			theCell = mBumpingAtom1->GetSelectedCell() ;
			mBumpingAtom1->FetchCellData(theCell,text) ;
			strcpy(theBondRec.atom1,text) ;
			theCell = mBumpingAtom2->GetSelectedCell() ;
			mBumpingAtom2->FetchCellData(theCell,text) ;
			strcpy(theBondRec.atom2,text) ;
			mBumpingDistance->GetEditText(text) ;
			theBondRec.distance = atof(text) ;
			mBumpingList->AddRow(&theBondRec) ;
			mBumpingActive->SetState(true) ;
		}
	}
	else if (obj == mDeleteBumping) {
		// Delete selected row
		if (mBumpingList->HasSelection()) {
			theCell = mBumpingList->GetSelectedCell() ;
			mBumpingList->RemoveRow(theCell.row) ;
			if (theCell.row <= mBumpingList->GetNumberOfListItems()) {
				mBumpingList->ClickCell(theCell) ;
			}
			if (mBumpingList->GetSelectedRow() == 0) {
				DisableModifyBumping() ;
				DisableDeleteBumping() ;
				mBumpingActive->SetState(false) ;
			}
		}
	}
	else if (obj == mModifyBumping) {
		// Modify a row based on the information in the atom fields
		// Add a row based on the information in the atom fields
		theCell = mBumpingList->GetSelectedCell() ;
		if (theCell.row <= mBumpingList->GetNumberOfListItems()) {
			mBumpingList->FetchCellData(theCell,&theBondRec) ;
			mBumpingDistance->GetEditText(text) ;
			theBondRec.distance = atof(text);
			mBumpingList->SetCellData(theCell,&theBondRec) ;
			mBumpingList->Refresh() ;
		}
	}
	// Stochiometry
	else if (obj == mStochiometryAtom) {
		if (HasStochiometrySelection()) 
			EnableAddStochiometry() ;
		else
			DisableAddStochiometry() ;
	}
	else if (obj == mStochiometryList) {
		if (mStochiometryList->GetSelectedRow() > 0) {
			EnableModifyStochiometry() ;
			EnableDeleteStochiometry() ;
		}
		else {
			DisableModifyStochiometry() ;
			DisableDeleteStochiometry() ;
		}
	}
	else if (obj == mAddStochiometry) {
		// Add a row based on the information in the atom fields
		if (HasStochiometrySelection()) {
			theCell = mStochiometryAtom->GetSelectedCell() ;
			mStochiometryAtom->FetchCellData(theCell,text) ;
			strcpy(theStochiometryRec.atom,text) ;
			mStochiometryValence->GetEditText(text) ;
			theStochiometryRec.valence = atof(text) ;
			mStochiometryList->AddRow(&theStochiometryRec) ;
			mStochiometryActive->SetState(true) ;
		}
	}
	else if (obj == mDeleteStochiometry) {
		// Delete selected row
		if (mStochiometryList->HasSelection()) {
			theCell = mStochiometryList->GetSelectedCell() ;
			mStochiometryList->RemoveRow(theCell.row) ;
			if (theCell.row <= mStochiometryList->GetNumberOfListItems()) {
				mStochiometryList->ClickCell(theCell) ;
			}
			if (mStochiometryList->GetSelectedRow() == 0) {
				DisableModifyStochiometry() ;
				DisableDeleteStochiometry() ;
				mStochiometryActive->SetState(false) ;
			}
		}
	}
	else if (obj == mModifyStochiometry) {
		// Modify a row based on the information in the atom fields
		// Add a row based on the information in the atom fields
		theCell = mStochiometryList->GetSelectedCell() ;
		if (theCell.row <= mStochiometryList->GetNumberOfListItems()) {
			mStochiometryList->FetchCellData(theCell,&theStochiometryRec) ;
			mStochiometryValence->GetEditText(text) ;
			theStochiometryRec.valence = atof(text) ;
			mStochiometryList->SetCellData(theCell,&theStochiometryRec) ;
			mStochiometryList->Refresh() ;
		}
	}
	// Coordination
	else if (obj == mCoordinationAtom) {
		if (HasCoordinationSelection()) 
			EnableAddCoordination() ;
		else
			DisableAddCoordination() ;
	}
	else if (obj == mCoordinationList) {
		if (mCoordinationList->GetSelectedRow() > 0) {
			EnableModifyCoordination() ;
			EnableDeleteCoordination() ;
		}
		else {
			DisableModifyCoordination() ;
			DisableDeleteCoordination() ;
		}
	}
	else if (obj == mAddCoordination) {
		// Add a row based on the information in the atom fields
		if (HasCoordinationSelection()) {
			theCell = mCoordinationAtom->GetSelectedCell() ;
			mCoordinationAtom->FetchCellData(theCell,text) ;
			strcpy(theCoordinationRec.atom,text) ;
			mCoordinationMin->GetEditText(text) ;
			theCoordinationRec.minNeighbors = atoi(text) ;
			mCoordinationMax->GetEditText(text) ;
			theCoordinationRec.maxNeighbors = atoi(text) ;
			mCoordinationList->AddRow(&theCoordinationRec) ;
			mCoordinationActive->SetState(true) ;
		}
	}
	else if (obj == mDeleteCoordination) {
		// Delete selected row
		if (mCoordinationList->HasSelection()) {
			theCell = mCoordinationList->GetSelectedCell() ;
			mCoordinationList->RemoveRow(theCell.row) ;
			if (theCell.row <= mCoordinationList->GetNumberOfListItems()) {
				mCoordinationList->ClickCell(theCell) ;
			}
			if (mCoordinationList->GetSelectedRow() == 0) {
				DisableModifyCoordination() ;
				DisableDeleteCoordination() ;
				mCoordinationActive->SetState(false) ;
			}
		}
	}
	else if (obj == mModifyCoordination) {
		// Modify a row based on the information in the atom fields
		// Add a row based on the information in the atom fields
		theCell = mCoordinationList->GetSelectedCell() ;
		if (theCell.row <= mCoordinationList->GetNumberOfListItems()) {
			mCoordinationList->FetchCellData(theCell,&theCoordinationRec) ;
			mCoordinationMin->GetEditText(text) ;
			theCoordinationRec.minNeighbors = atoi(text) ;
			mCoordinationMax->GetEditText(text) ;
			theCoordinationRec.maxNeighbors = atoi(text) ;
			mCoordinationList->SetCellData(theCell,&theCoordinationRec) ;
			mCoordinationList->Refresh() ;
		}
	}
	// Content
	else if (obj == mCellContentAtom) {
		if (HasContentSelection()) 
			EnableAddCellContent() ;
		else
			DisableAddCellContent() ;
	}
	else if (obj == mCellContentList) {
		if (mCellContentList->GetSelectedRow() > 0) {
			EnableModifyCellContent() ;
			EnableDeleteCellContent() ;
		}
		else {
			DisableModifyCellContent() ;
			DisableDeleteCellContent() ;
		}
	}
	else if (obj == mAddCellContent) {
		// Add a row based on the information in the atom fields
		if (HasContentSelection()) {
			theCell = mCellContentAtom->GetSelectedCell() ;
			mCellContentAtom->FetchCellData(theCell,text) ;
			strcpy(theContentRec.atom,text) ;
			mCellContentMin->GetEditText(text) ;
			theContentRec.minNumber = atoi(text) ;
			mCellContentMax->GetEditText(text) ;
			theContentRec.maxNumber = atoi(text) ;
			mCellContentList->AddRow(&theContentRec) ;
			mCellContentActive->SetState(true) ;
		}
	}
	else if (obj == mDeleteCellContent) {
		// Delete selected row
		if (mCellContentList->HasSelection()) {
			theCell = mCellContentList->GetSelectedCell() ;
			mCellContentList->RemoveRow(theCell.row) ;
			if (theCell.row <= mCellContentList->GetNumberOfListItems()) {
				mCellContentList->ClickCell(theCell) ;
			}
			if (mCellContentList->GetSelectedRow() == 0) {
				DisableModifyCellContent() ;
				DisableDeleteCellContent() ;
				mCellContentActive->SetState(false) ;
			}
		}
	}
	else if (obj == mModifyCellContent) {
		// Modify a row based on the information in the atom fields
		// Add a row based on the information in the atom fields
		theCell = mCellContentList->GetSelectedCell() ;
		if (theCell.row <= mCellContentList->GetNumberOfListItems()) {
			mCellContentList->FetchCellData(theCell,&theContentRec) ;
			mCellContentMin->GetEditText(text) ;
			theContentRec.minNumber = atoi(text) ;
			mCellContentMax->GetEditText(text) ;
			theContentRec.maxNumber = atoi(text) ;
			mCellContentList->SetCellData(theCell,&theContentRec) ;
			mCellContentList->Refresh() ;
		}
	}

}

void	TConstraintsDialog::ShowBond(BondRecord &theBondRec) {
	char	text[256] ;
	sprintf(text,"%.3f",theBondRec.distance) ;
	mBondDistance->SetEditText(text) ;
}

void	TConstraintsDialog::ShowBumping(BondRecord &theBondRec) {
	char	text[256] ;
	sprintf(text,"%.3f",theBondRec.distance) ;
	mBumpingDistance->SetEditText(text) ;
}

void	TConstraintsDialog::ShowStochiometry(StochiometryRecord &theStochiometryRecord) {
	char	text[256] ;
	sprintf(text,"%.2f",theStochiometryRecord.valence) ;
	mStochiometryValence->SetEditText(text) ;
	
}

void	TConstraintsDialog::ShowCellContent(CellContentRecord &theCellContentRecord) {
	char	text[256] ;
	sprintf(text,"%d",(int) theCellContentRecord.minNumber) ;
	mCellContentMin->SetEditText(text) ;
	
	sprintf(text,"%d",(int) theCellContentRecord.maxNumber) ;
	mCellContentMax->SetEditText(text) ;
}

void	TConstraintsDialog::ShowCoordination(CoordinationRecord &theCoordinationRecord) {
	char	text[256] ;
	sprintf(text,"%d",(int) theCoordinationRecord.minNeighbors) ;
	mCoordinationMin->SetEditText(text) ;
	
	sprintf(text,"%d",(int) theCoordinationRecord.maxNeighbors) ;
	mCoordinationMax->SetEditText(text) ;
}

void	TConstraintsDialog::GetConstraints(TConstraints *theConstraints) {
	short	numBonds,numConstraints,i ;
	char	text[256] ;
	ListCellT theCell ;
	theCell.col = 1 ;
	BondRecord	theBondRecord ;
	StochiometryRecord theStochiometryRecord ;
	CoordinationRecord theCoordinationRecord ;
	CellContentRecord theCellContentRecord ;

		
	// Bonding 
	numBonds = mBondList->GetNumberOfListItems() ;
	if (theConstraints->mBonds != nil) delete theConstraints->mBonds ;
	theConstraints->mBonds = nil ;
	if (numBonds > 0) {
		theConstraints->mBonds = new TBonds(numBonds) ;
		mBondWeight->GetEditText(text) ;
		theConstraints->mBonds->mWeight = atof(text) ;
		theConstraints->mBonds->mActive = mBondActive->GetState() ;
		for(i = 0 ; i < numBonds; i++) {
			theCell.row = i+1 ;
			mBondList->FetchCellData(theCell,&theBondRecord) ;
			theConstraints->mBonds->mBondRec[i] = theBondRecord ;
		}
	}
	
	// Bumping
	numBonds = mBumpingList->GetNumberOfListItems() ;
	if (theConstraints->mBumpingBonds != nil) delete theConstraints->mBumpingBonds ;
	theConstraints->mBumpingBonds = nil ;
	if (numBonds > 0) {
		theConstraints->mBumpingBonds = new TBonds(numBonds) ;
		mBumpingWeight->GetEditText(text) ;
		theConstraints->mBumpingBonds->mWeight = atof(text) ;
		theConstraints->mBumpingBonds->mActive = mBumpingActive->GetState() ;
		for(i = 0 ; i < numBonds; i++) {
			theCell.row = i+1 ;
			mBumpingList->FetchCellData(theCell,&theBondRecord) ;
			theConstraints->mBumpingBonds->mBondRec[i] = theBondRecord ;
		}
	}

	// Stochiometry
	numConstraints = mStochiometryList->GetNumberOfListItems() ;
	if (theConstraints->mStochiometry != nil) delete theConstraints->mStochiometry ;
	theConstraints->mStochiometry = nil ;
	if (numConstraints > 0) {
		theConstraints->mStochiometry = new TStochiometry(numConstraints) ;
		mStochiometryWeight->GetEditText(text) ;
		theConstraints->mStochiometry->mWeight = atof(text) ;
		theConstraints->mStochiometry->mActive = mStochiometryActive->GetState() ;
		mStochiometryBase->GetEditText(text) ;
		theConstraints->mStochiometry->mBase = atof(text) ;
		for(i = 0 ; i < numConstraints; i++) {
			theCell.row = i+1 ;
			mStochiometryList->FetchCellData(theCell,&theStochiometryRecord) ;
			theConstraints->mStochiometry->mStochiometryRecord[i] = theStochiometryRecord ;
		}
	}

	// Coordination
	numConstraints = mCoordinationList->GetNumberOfListItems() ;
	if (theConstraints->mCoordination != nil) delete theConstraints->mCoordination ;
	theConstraints->mCoordination = nil ;
	if (numConstraints > 0) {
		theConstraints->mCoordination = new TCoordination(numConstraints) ;
		mCoordinationWeight->GetEditText(text) ;
		theConstraints->mCoordination->mWeight = atof(text) ;
		theConstraints->mCoordination->mActive = mCoordinationActive->GetState() ;
		for(i = 0 ; i < numConstraints; i++) {
			theCell.row = i+1 ;
			mCoordinationList->FetchCellData(theCell,&theCoordinationRecord) ;
			theConstraints->mCoordination->mCoordinationRecord[i] = theCoordinationRecord ;
		}
	}

	// CellContent
	numConstraints = mCellContentList->GetNumberOfListItems() ;
	if (theConstraints->mCellContent != nil) delete theConstraints->mCellContent ;
	theConstraints->mCellContent = nil ;
	if (numConstraints > 0) {
		theConstraints->mCellContent = new TCellContent(numConstraints) ;
		mCellContentWeight->GetEditText(text) ;
		theConstraints->mCellContent->mWeight = atof(text) ;
		theConstraints->mCellContent->mActive = mCellContentActive->GetState() ;
		for(i = 0 ; i < numConstraints; i++) {
			theCell.row = i+1 ;
			mCellContentList->FetchCellData(theCell,&theCellContentRecord) ;
			theConstraints->mCellContent->mCellContentRecord[i] = theCellContentRecord ;
		}
	}
	
} 


TPeaksControlWindow::TPeaksControlWindow( FS98ControlRecord &theFS98ControlRecord,TImage *image,short whichImage) 
		: TWindow(240,0,820,740,gImageDepth,"Refine Solution",false,false) {
	short   i ;
	short	x,y ;
	char	text[256] ;
	
	Rect	theRect,theRect1,theRect2 ;
	
	mFS98ControlRecord = theFS98ControlRecord ;

	mBkColor = gGrayPixel ;
	XSetBackground(gDisplay,mGC,mBkColor) ;
		
	mObjectList = new TObjectList() ;
	mGMax = 1.5 ;
	mDiskRadius = 0.025 ;
	

	x = 10 ;
	y = 10 ;
	
	mLogDiagnosticOutput = false ;
	
	mImageNum = whichImage ;
	
	mImageMap = new TImage(*image) ;
	mCurrentImage = mImageMap ;
	mCurrentModel = nil ;
	mCurrentMap = nil ;
	mDifferenceMap = nil ;
	mExpDP = nil ;
	mCurrentDP = nil ;
	mSplitDP = nil ;
	mGaussian = nil ;
	
	mMapWidth = mImageMap->Width() ;
	mMapHeight = mImageMap->Height() ;
	
	mHKLCalculatedFileType = kRFIT ;
		
	mImageFrame = new TUserRect(x,y,x+512,y+512) ;
	mImageFrame->Enable() ;
	AddObject(mImageFrame) ;
	mImageRect = theRect = mImageFrame->GetRect() ;

	TGroupBox   *theGroupBox ;
	theGroupBox = new TGroupBox(theRect.right+10,theRect.bottom-120,820-10,theRect.bottom,"Display Modes") ;
	AddObject(theGroupBox) ;
	theRect = theGroupBox->GetRect() ;

	mShowGeneticSolutionMap = new TRadioButton(theRect.left+10,theRect.top+10,theRect.left+140,theRect.top+30,
		"Show Genetic Solution",1) ;
	AddObject(mShowGeneticSolutionMap) ;
	theRect = mShowGeneticSolutionMap->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	mShowCurrentModel =  new TRadioButton(&theRect,"Show Current Model",0) ;
	AddObject(mShowCurrentModel) ;
	OffsetRect(&theRect,0,20) ;
	mShowCurrentMap =  new TRadioButton(&theRect,"Show Current Map",0) ;
	AddObject(mShowCurrentMap) ;
	OffsetRect(&theRect,0,20) ;
	mShowDifferenceMap =  new TRadioButton(&theRect,"Show Difference Map",0) ;
	AddObject(mShowDifferenceMap) ;

	theRect = mShowGeneticSolutionMap->GetRect() ;
	OffsetRect(&theRect,130,0) ;
	theRect.right = (theGroupBox->GetRect()).right - 4 ;
	mShowExperimentalDP =  new TRadioButton(&theRect,"Show Experimental DP",0) ;
	AddObject(mShowExperimentalDP) ;
	OffsetRect(&theRect,0,20) ;
	mShowCalculatedDP =  new TRadioButton(&theRect,"Show Calculated DP",0) ;
	AddObject(mShowCalculatedDP) ;
	OffsetRect(&theRect,0,20) ;
	mShowFourierFit =  new TRadioButton(&theRect,"Show Fourier Fit",0) ;
	AddObject(mShowFourierFit) ;

	mSelectedDisplay = mShowGeneticSolutionMap ;
	mDisplayMode = kPeakDisplayGeneticMap ;
	
	theRect = mShowFourierFit->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	theRect.right = theRect.left+40 ;
	mFFTGmaxApply = new TButton(&theRect,"Change") ;
	AddObject(mFFTGmaxApply) ;
	
	OffsetRect(&theRect,42,0) ;
	theRect.right -= 8 ;

	sprintf(text,"%.2f",mGMax) ;
	mFFTGmax = new TEditText(&theRect,"GMax[1/A]",text) ;
	mFFTGmax->SetLabelPosition(kLabelOutsideRight) ;
	AddTextEditObject(mFFTGmax) ;
	
	theRect = mFFTGmaxApply->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	mFFTDiskRadiusApply = new TButton(&theRect,"Change") ;
	AddObject(mFFTDiskRadiusApply) ;
	
	OffsetRect(&theRect,42,0) ;
	theRect.right -= 8 ;

	sprintf(text,"%.3f",mDiskRadius) ;
	mFFTDiskRadius = new TEditText(&theRect,"Rad.[1/A]",text) ;
	mFFTDiskRadius->SetLabelPosition(kLabelOutsideRight) ;
	AddTextEditObject(mFFTDiskRadius) ;
	
	
	theRect = mShowDifferenceMap->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	mOverlayAtoms = new TCheckBox(&theRect,"Overlay Atom Peaks",0) ;
	AddObject(mOverlayAtoms) ;


	theRect = theGroupBox->GetRect() ;
	SetRect(&mListRect,mImageRect.right+10,mImageRect.top,820-10,theRect.top-210) ;	
	mPeakDisplayList = new TPeakDisplayList(&mListRect) ;
	AddObject(mPeakDisplayList) ;

	mDifferencePeakDisplayList = new TPeakDisplayList(&mListRect) ;
	mDifferencePeakDisplayList->SetVisible(false) ;
	AddObject(mDifferencePeakDisplayList) ;

	mHKLDisplayList = new THKLDisplayList(&mListRect) ;
	mHKLDisplayList->SetVisible(false) ;
	AddObject(mHKLDisplayList) ;

	theRect = mPeakDisplayList->GetRect() ;
	SetRect(&mSolutionRect,theRect.left,theRect.bottom+10,theRect.right,theRect.bottom+100) ;	
	mSolutionList = new TPeakSolutionList(&mSolutionRect) ;
	AddObject(mSolutionList) ;
	mNumSolutions = 1 ;

	theRect = mSolutionRect ;
	
	strcpy(mMessageText,"") ;
	mInfo = new TStaticText(theRect.left,theRect.bottom+6,theRect.right,theRect.bottom+6+20,mMessageText);
 	AddObject(mInfo) ;

	theRect = mInfo->GetRect() ;
	OffsetRect(&theRect,0,24) ;

	theRect.right = theRect.left +(theRect.right-theRect.left)/2 ;
	mShowCurrentPeakList = new TRadioButton(&theRect,"Show Solution Peaks",true);
 	AddObject(mShowCurrentPeakList) ;
	
	theRect = mShowCurrentPeakList->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left,0) ;
	mShowCurrentDifferenceList = new TRadioButton(&theRect,"Show Difference Peaks",false);
 	AddObject(mShowCurrentDifferenceList) ;

	theRect = mShowCurrentPeakList->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	mUseAtomList = new TCheckBox(&theRect,"Use Atom List",false) ;
 	AddObject(mUseAtomList) ;

	theRect = mShowCurrentDifferenceList->GetRect() ;
	OffsetRect(&theRect,0,20) ;
	mAcceptBestSolution = new TCheckBox(&theRect,"Accept Best Combination",false) ;
 	AddObject(mAcceptBestSolution) ;
	mAcceptBestSolution->Disable() ;

	theRect = mUseAtomList->GetRect() ;	
	theRect.top = theRect.bottom+4 ;
	theRect.right = theRect.left+24 ;
	theRect.bottom = theRect.top+24 ;
	mAddAtomPeak = new TPushButton(&theRect,nil,kPeakAddTool,"+") ;
	AddObject(mAddAtomPeak) ;
	
	OffsetRect(&theRect,30,0) ;
	mRemoveAtomPeak = new TPushButton(&theRect,nil,kPeakRemoveTool,"-") ;
	mRemoveAtomPeak->Disable() ;
	AddObject(mRemoveAtomPeak) ;
	
	OffsetRect(&theRect,28,0) ;
	theRect.right = theRect.left+54 ;
	mTestPeaks = new TButton(&theRect,"Test Peaks") ;
	AddObject(mTestPeaks) ;

	TIcon	*icon ;

	OffsetRect(&theRect,60,0) ;
	theRect.right = theRect.left+24 ;
	icon = new TIcon(pointer_width,pointer_height,pointer_bits,mXWindow) ;
	mPointerTool = new TPushButton(&theRect,icon,kPeakPointer) ;
	mPointerTool->SetState(1) ;
	mCurrentTool = mPointerTool ;
	AddObject(mPointerTool) ;

	OffsetRect(&theRect,30,0) ;
	icon = new TIcon(zoom_width,zoom_height,zoom_bits,mXWindow) ;
	mZoomTool = new TPushButton(&theRect,icon,kPeakZoom) ;
	AddObject(mZoomTool) ;

	OffsetRect(&theRect,30,0) ;
	icon = new TIcon(hand_width,hand_height,hand_bits,mXWindow) ;
	mHandTool = new TPushButton(&theRect,icon,kPeakHand) ;
	AddObject(mHandTool) ;

	OffsetRect(&theRect,30,0) ;
	icon = new TIcon(ruler_width,ruler_height,ruler_bits,mXWindow) ;
	mRulerTool = new TPushButton(&theRect,icon,kPeakRuler) ;
	AddObject(mRulerTool) ;
	
	OffsetRect(&theRect,30,0) ;
	theRect.right = theGroupBox->GetRect().right ;
	mResetView = new TButton(&theRect,"Reset") ;
	AddObject(mResetView) ;
	
	theRect = theGroupBox->GetRect() ;
	theGroupBox = new TGroupBox(mImageRect.left,mImageRect.bottom+20,820-10,740-10,"Peak/Refinement Control") ;
	AddObject(theGroupBox) ;
	theRect = theGroupBox->GetRect() ;
	
	short buttonHeight = 22 ;
	short buttonShift = 25 ; 
	short distanceFromBorder = 10 ;
	
	theRect.bottom = theRect.top+20 ;
	theRect.right = theRect.left+40 ;
	//LDM squeeze
	theRect.right = theRect.right-4 ;
	OffsetRect(&theRect,70,distanceFromBorder) ;
	mPeakThreshold = new TEditText(&theRect,"Peak cutoff","0.1") ;
	AddTextEditObject(mPeakThreshold) ;
	InsetRect(&theRect,-10,0) ;
	OffsetRect(&theRect,60,0) ;
	
	theRect.bottom = theRect.top+buttonHeight ;
	mChangeThreshold = new TButton(&theRect,"Change") ;
	AddObject(mChangeThreshold) ;

	theRect = theGroupBox->GetRect() ;
	theRect1 = mChangeThreshold->GetRect() ;
	theRect.bottom = theRect.top+buttonHeight ;
	OffsetRect(&theRect,10,distanceFromBorder+buttonShift) ;
	theRect.right = theRect1.right ;
	// 'C' command
	mCreateModelFromPeaks = new TButton(&theRect,"Create/Update Atomic Model") ;
	AddObject(mCreateModelFromPeaks) ;

	theRect = mCreateModelFromPeaks->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	// 'S' command
	mUpdateCurrentMap = new TButton(&theRect,"Create/Save Current Map") ;
	AddObject(mUpdateCurrentMap) ;

	theRect = mCreateModelFromPeaks->GetRect() ;
	OffsetRect(&theRect,(theRect.right-theRect.left)+10,-buttonShift) ;
	// LDM Test
	// theRect.right -= 40 ;
	theRect.right -= 52 ;
	// 'A' command
	mCommandUpdateAtoms = new TButton(&theRect,"Find Peaks") ;
	AddObject(mCommandUpdateAtoms) ;

	theRect = mCommandUpdateAtoms->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandListAtoms = new TButton(&theRect,"List Atoms") ;
	AddObject(mCommandListAtoms) ;

	theRect = mCommandListAtoms->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandEntropy = new TButton(&theRect,"Iterate (Entropy)") ;
	AddObject(mCommandEntropy) ;

	theRect = mCommandUpdateAtoms->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	mCommandPositive = new TButton(&theRect,"Iterate (Positivity)") ;
	AddObject(mCommandPositive) ;

	theRect = mCommandPositive->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandRefine = new TButton(&theRect,"Refine Positions") ;
	AddObject(mCommandRefine) ;

	theRect = mCommandRefine->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandOccupancy = new TButton(&theRect,"Search Occupancy") ;
	AddObject(mCommandOccupancy) ;

	theRect = mCommandPositive->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	mCommandFix = new TButton(&theRect,"Atom Project") ;
	AddObject(mCommandFix) ;

	theRect = mCommandFix->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandSEED = new TButton(&theRect,"Seed Refine") ;
	AddObject(mCommandSEED) ;

	theRect = mCommandSEED->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandDiffMap = new TButton(&theRect,"Difference Search") ;
	AddObject(mCommandDiffMap) ;

	theRect = mCommandFix->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	mCommandDiffProj = new TButton(&theRect,"Difference Project") ;
	AddObject(mCommandDiffProj) ;

	theRect = mCommandDiffProj->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	// '1' command
	mCommandDiffMapOne = new TButton(&theRect,"Difference Map") ;
	AddObject(mCommandDiffMapOne) ;

	theRect = mCommandDiffMapOne->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandTrim = new TButton(&theRect,"Trim Seeds") ;
	AddObject(mCommandTrim) ;

	theRect = mCommandDiffProj->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	mCommandSettoModel = new TButton(&theRect,"Set to Model") ;
	AddObject(mCommandSettoModel) ;	

	theRect = mCommandSettoModel->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandPurgeSeeds = new TButton(&theRect,"Purge Seeds") ;
	AddObject(mCommandPurgeSeeds) ;

	theRect = mCommandPurgeSeeds->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	mCommandReadAtoms = new TButton(&theRect,"Read Atoms") ;
	AddObject(mCommandReadAtoms) ;

    theRect = mCommandTrim->GetRect() ;
	OffsetRect(&theRect,0,buttonShift) ;
	theRect.right = theRect.left + 65 ;
	mOptionRobust = new TCheckBox(&theRect,"Robust",false) ;
	AddObject(mOptionRobust) ;

	theRect = mOptionRobust->GetRect() ;
	OffsetRect(&theRect,(theRect.right-theRect.left)+12,0) ;
	mOptionErrors = new TCheckBox(&theRect,"Errors",false) ;
	AddObject(mOptionErrors) ;

	theRect = mOptionErrors->GetRect() ;
	OffsetRect(&theRect,(theRect.right-theRect.left)+12,0) ;
	mOptionICons = new TCheckBox(&theRect,"Conserve",true) ;
	AddObject(mOptionICons) ;

	theRect = mOptionRobust->GetRect() ;
	OffsetRect(&theRect,0,buttonShift-6) ;
	theRect.right = theRect.left + 65 ;
	mShowLog = new TCheckBox(&theRect,"Diagnostics",mLogDiagnosticOutput) ;
	AddObject(mShowLog) ;

	OffsetRect(&theRect,0,buttonShift-6) ;
	theRect.right = theRect.left + 65 ;
	mOptionDWRef = new TCheckBox(&theRect,"DW",mLogDiagnosticOutput) ;
	AddObject(mOptionDWRef) ;

	theRect = mShowLog->GetRect() ;
	OffsetRect(&theRect,(theRect.right-theRect.left)+12,0) ;
	mOptionUseFHKL = new TCheckBox(&theRect,"Use F's",false) ;
	AddObject(mOptionUseFHKL) ;

	OffsetRect(&theRect,0,buttonShift-6) ;
	theRect.right = theRect.left + 65 ;
	mOptionUcmin = new TCheckBox(&theRect,"Praxis",mLogDiagnosticOutput) ;
	AddObject(mOptionUcmin) ;
	//mOptionUcmin->Disable();

	theRect = mOptionUseFHKL->GetRect() ;
	OffsetRect(&theRect,(theRect.right-theRect.left)+12,0) ;
	mOptionMultiplicity = new TCheckBox(&theRect,"Multiplic",true) ;
	AddObject(mOptionMultiplicity) ;

	OffsetRect(&theRect,0,buttonShift-6) ;
	theRect.right = theRect.left + 65 ;
	mOptionTwin = new TCheckBox(&theRect,"Twin",mLogDiagnosticOutput) ;
	AddObject(mOptionTwin) ;
	//mOptionUnused->Disable();


	//theRect = mShowLog->GetRect() ;
	//theRect.right = theRect.left + 114 ;
	//OffsetRect(&theRect,0,buttonShift-4) ;
	//mCommandShowCurrentSettings = new TButton(&theRect,"Current Settings") ;
	//AddObject(mCommandShowCurrentSettings) ;
	
	theRect = theGroupBox->GetRect() ;
    mQuit = new TButton(mCommandTrim->GetRect().left,theRect.bottom-24-14,mCommandTrim->GetRect().right,theRect.bottom-14,"Stop Peaks") ;
	AddObject(mQuit) ;
	mQuit->Disable() ;

	theRect = mQuit->GetRect() ;
	OffsetRect(&theRect,-(theRect.right-theRect.left+10),0) ;
	mCommandShowCurrentSettings = new TButton(&theRect,"Current Settings") ;
	AddObject(mCommandShowCurrentSettings) ;

	theRect = mQuit->GetRect() ;
	OffsetRect(&theRect,theRect.right-theRect.left+10,0) ;
	mCommandCyclePeaks = new TButton(&theRect,"Cycle") ;
	AddObject(mCommandCyclePeaks) ;

	theRect1 = mUpdateCurrentMap->GetRect() ;   // Left button
	theRect2 = mCommandOccupancy->GetRect() ;   // Right button
	SetRect(&mListRect,theRect1.left,theRect1.bottom+10,theRect2.right,theRect.bottom) ;	
	mLogList = new TPeakLogList(&mListRect) ;
	AddObject(mLogList) ;

	theRect = mCommandDiffMap->GetRect() ;
	OffsetRect(&theRect,0,buttonShift+5) ;
	mCommandSetConstraints = new TButton(&theRect,"Set Constraints...") ;
	AddObject(mCommandSetConstraints) ;

	OffsetRect(&theRect,0,buttonShift+3) ;
	mBabinet = new TButton(&theRect,"Babinet the Map") ;
	AddObject(mBabinet) ;

	// Set the plane group index
	for(i=0; gPlaneGroupSymbols[i] != nil; i++) {
		if (strcmp(mFS98ControlRecord.symm,gPlaneGroupSymbols[i]) == 0) {
			mPlaneGroupIndex = i ;
			break ;
		}
	}
	
	mScaleFactor = 0 ;
	mAtomPeakList = nil ;
	mDifferencePeakList = nil ;
	mAtomTypes = nil ;
	
	mConstraints = new TConstraints ;

	SetCommander((TWindow *)gTheControlWindow) ;		
	AddWindow(this) ;

	// Run the shell script to execute the refinement
	// Clean up all communication files
	RemoveCommunicationFiles() ;
	
	// Report that we may be busy for a short while
	SetPort(this) ;
	DrawText((mImageRect.left+mImageRect.right)/2-StringWidth("Processing...")/2,
		(mImageRect.top+mImageRect.bottom)/2,"Processing...") ;
	
	// This would be a relevant starting structure
	mPeaksIsRunning = true ;	// Assume on startup
	SendPeaksCommand(kPeakStartup) ;
	SendPeaksCommand(kPeakSave) ;
	SendPeaksCommand(kPeakAtoms) ;

	// Get the types of atoms that we have
	ReadAtomTypes() ;

	SendPeaksCommand(kPeakList) ;
	// We return when peaks has started up and executed the initial taks
	
	mCalcAmplitude = nil ;
	mCalcDifference = nil ;
	mCalcH = nil ;
	mCalcK = nil ;
	mCalcL = nil ;
	
	mAmplitude = nil ;
	mAmplitudeError = nil ;
	mPhase = nil ;
	mH = nil ;
	mK = nil ;
	mL = nil ;
	
	// We also should have a list of atom peaks in .edm_3
	SetAtomList() ;
	ReadHKLDataSet() ;
	CreateDisplayAtoms() ;

	mNumCalculatedReflections = 0 ;	// We don't have any at the start
	
	PeakHKLRecord hklData ;
	for(i=0; i < mNumReflections; i++) {
		hklData.h = mH[i] ;
		hklData.k = mK[i] ;
		hklData.l = mL[i] ;
		hklData.expVal = mAmplitude[i] ;
		hklData.calcVal = 0.0 ;
		hklData.error = 0.0  ;	// For Now
		mHKLDisplayList->AddRow(&hklData) ;
	}

	
	mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
	mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
	mImageMagnification = 1.0 ;

	mQuit->Enable() ;

}

void	TPeaksControlWindow::RestartPeaks() {
	mScaleFactor = 0 ;

	if (mCurrentModel != nil) delete mCurrentModel ;
	if (mCurrentMap != nil) delete mCurrentMap ;
	if (mDifferenceMap != nil) delete mDifferenceMap ;
	if (mExpDP != nil) delete mExpDP ;
	if (mCurrentDP != nil) delete mCurrentDP ;
	if (mSplitDP != nil) delete mSplitDP ;
	if (mGaussian != nil) delete mGaussian ;
	if (mCalcAmplitude != nil) delete mCalcAmplitude ;
	if (mCalcDifference != nil) delete mCalcDifference ;
	if (mCalcH != nil) delete mCalcH ;
	if (mCalcK != nil) delete mCalcK ;
	if (mCalcL != nil) delete mCalcL ;
	
	if (mAmplitude != nil) delete mAmplitude ;
	if (mAmplitudeError != nil) delete mAmplitudeError ;
	if (mPhase != nil) delete mPhase ;
	if (mH != nil) delete mH ;
	if (mK != nil) delete mK ;
	if (mL != nil) delete mL ;
	if (mAtomPeakList != nil) delete mAtomPeakList ;
	if (mDifferencePeakList != nil) delete mDifferencePeakList ;
	if (mAtomTypes != nil) delete mAtomTypes ;
	//LDM: Comment, it would be nice to keep the constraints
	if (mConstraints != nil) 
		delete mConstraints ;
		
	mSolutionList->RemoveAllRows() ;

	// Run the shell script to execute the refinement
	// Clean up all communication files
	RemoveCommunicationFiles() ;

	mCurrentImage = mImageMap ;
	mCurrentMap = nil ;
	mCurrentModel = nil ;
	mDifferenceMap = nil ;
	mExpDP = nil ;
	mCurrentDP = nil ;
	mSplitDP = nil ;
	mGaussian = nil ;
	mAtomPeakList = nil ;
	mDifferencePeakList = nil ;
	mAtomTypes = nil ;
	mConstraints = new TConstraints ;
	
	// Report that we may be busy for a short while
	SetPort(this) ;
	DrawText((mImageRect.left+mImageRect.right)/2-StringWidth("Processing...")/2,
		(mImageRect.top+mImageRect.bottom)/2,"Processing...") ;

	mSelectedDisplay->SetState(0) ;
	mSelectedDisplay = mShowGeneticSolutionMap ;
	mSelectedDisplay->SetState(true) ;
	mDisplayMode = kPeakDisplayGeneticMap ;

	
	// This would be a relevant starting structure
	SendPeaksCommand(kPeakStartup) ;
	SendPeaksCommand(kPeakSave) ;
	SendPeaksCommand(kPeakAtoms) ;
	SendPeaksCommand(kPeakList) ;
	// We return when peaks has started up and executed the initial taks
	
	mCalcAmplitude = nil ;
	mCalcDifference = nil ;
	mCalcH = nil ;
	mCalcK = nil ;
	mCalcL = nil ;
	
	mAmplitude = nil ;
	mAmplitudeError = nil ;
	mPhase = nil ;
	mH = nil ;
	mK = nil ;
	mL = nil ;

	mSolutionList->RemoveAllRows() ;
	mHKLDisplayList->RemoveAllRows() ;
	mDifferencePeakDisplayList->RemoveAllRows() ;
	
	// We also should have a list of atom peaks in .edm_3
	SetAtomList() ;
	ReadHKLDataSet() ;
	CreateDisplayAtoms() ;
	
	mNumCalculatedReflections = 0 ;	// We don't have any at the start
	
	PeakHKLRecord hklData ;
	for(int i=0; i < mNumReflections; i++) {
		hklData.h = mH[i] ;
		hklData.k = mK[i] ;
		hklData.l = mL[i] ;
		hklData.expVal = mAmplitude[i] ;
		hklData.calcVal = 0.0 ;
		hklData.error = 0.0  ;	// For Now
		mHKLDisplayList->AddRow(&hklData) ;
	}

	DisplayMap() ;

	ReadAtomTypes() ;
	
	mPeaksIsRunning = true ;
}

void	TPeaksControlWindow::SetOccupancySolutions() {
	char	inputLine[256],s1[256],s2[256],s3[256] ;
	//long	numSolutions ;
	
	// We are getting all our data from 'search.lst'
	// Set up the display list based on the calculated data from peaks
	// Remove all entries from the list
	mSolutionList->RemoveAllRows() ;

	FILE *fp = fopen("search.lst","r") ;
	if (fp == NULL) return ;
	
	// Now read the r-values
	TPeakSolution   thePeakSolution ;
	TAtomPeak		*theAtomPeak ;
	//TAtomPeakList   *currentAtomList ;

	short	i = 0 ;
	bool	doneReadingAAtoms ;

	mSolutionList->mSelectedSolution = 1 ;

	while (ReadLine(inputLine,256,fp) != NULL) {
		if (strncmp(inputLine,"REM",strlen("REM")) == 0) {
			newatom:
			i = 0 ;
			// start of new solution
			sscanf(inputLine,"%s %s %hd %s %f",s1,s2,&thePeakSolution.mSolutionNumber,s3,&thePeakSolution.mRValue) ;
			thePeakSolution.mAtomPeakList = new TAtomPeakList() ;
			doneReadingAAtoms = false ;
			while (!doneReadingAAtoms) {
				if (ReadLine(inputLine,256,fp) == NULL) {
					doneReadingAAtoms = true ;
					mSolutionList->AddRow(&thePeakSolution) ;
					goto finshedReadingAtoms ;
				}
				if ( !doneReadingAAtoms && strncmp(inputLine,"REM",strlen("REM")) != 0) {
					// This is an atom
					theAtomPeak = new TAtomPeak ;
					sscanf(inputLine,"%s %hd %f %f %f %f %f",theAtomPeak->symbol,&theAtomPeak->type,&theAtomPeak->xc,&theAtomPeak->yc,&theAtomPeak->zc,&theAtomPeak->peak,&theAtomPeak->dw) ;
					theAtomPeak->baseIndex = -1 ;
					theAtomPeak->index = i ;
					theAtomPeak->xc = one(theAtomPeak->xc) ;
					theAtomPeak->yc = one(theAtomPeak->yc) ;
					thePeakSolution.mAtomPeakList->AddAtomPeak(theAtomPeak) ;
					i++ ;
				}
				else {
					doneReadingAAtoms = true ;
					mSolutionList->AddRow(&thePeakSolution) ;
					goto newatom ;
				}
			}
		}
	}
	
finshedReadingAtoms: ;

	fclose(fp) ;
	mSolutionList->Sort() ;
	
	
	// Get the first atom list
	ListCellT inCell ;
	inCell.row = 1 ; inCell.col = 1 ;
	mSolutionList->FetchCellData(inCell,&thePeakSolution) ;

	mSolutionList->SelectRow(1) ;
	UpdateAtomList(thePeakSolution.mAtomPeakList) ;
	mSolutionList->Refresh() ;
}

void	TPeaksControlWindow::UpdateAtomList(TAtomPeakList *theAtomList) {
	mPeakDisplayList->RemoveAllRows() ;
	TAtomPeak *theAtomPeak ;
	for(int i = 0; i < theAtomList->GetNumberOfAtomPeaks() ; i++) {
		theAtomPeak = theAtomList->GetAtomPeak(i) ;
		mPeakDisplayList->AddRow(theAtomPeak) ;
	}
	CreateDisplayAtoms() ;
	if (mOverlayAtoms) DisplayMap() ;
}

void	TPeaksControlWindow::SetSelectedSolutionAsCurrent(short selectedSolution) {
	// Create the file "peaks.new" from the current solution and 
	// send the command to import the file
	TPeakSolution   thePeakSolution ;
	ListCellT inCell ;
	inCell.col = 1 ;
	inCell.row = selectedSolution ;
	mSolutionList->FetchCellData(inCell,&thePeakSolution) ;
	// Write out the atom peak list
	
	FILE	*fp = fopen("peaks.new","w") ;
	if (fp == NULL) return ;
	TAtomPeak		*theAtomPeak ;
	for(int i = 0; i < thePeakSolution.mAtomPeakList->GetNumberOfAtomPeaks() ; i++) {
		theAtomPeak = thePeakSolution.mAtomPeakList->GetAtomPeak(i) ;
		//LDM Added a "0" for the z co-ordinate
		fprintf(fp,"%s %d %10.6f %10.6f 0 %10.6f %10.6f \n",theAtomPeak->symbol,theAtomPeak->type,theAtomPeak->xc,theAtomPeak->yc,theAtomPeak->peak,theAtomPeak->dw) ;
	}
	
	fflush(fp) ;
	fclose(fp) ;
	SendPeaksCommand(kPeakEnter) ;
	CalculateCurrentModel() ;
	// Display the current model annd set switches
	mSelectedDisplay->SetState(0) ;
	if (mSelectedDisplay != mShowGeneticSolutionMap && mSelectedDisplay != mShowCurrentMap && mSelectedDisplay != mShowDifferenceMap) {
		mScaleFactor = 0. ;
		mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
		mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
		mImageMagnification = 1.0 ;
	}
	mSelectedDisplay = mShowCurrentModel ;
	mDisplayMode = kPeakDisplayCurrentModel ;
	if (!mPeakDisplayList->IsVisible()) {
		mHKLDisplayList->SetVisible(false) ;
		mDifferencePeakDisplayList->SetVisible(false) ;
		mPeakDisplayList->SetVisible(true) ;
	}
	mCurrentImage = mCurrentModel ;
	mShowCurrentModel->SetState(true) ;	
	DisplayMap() ;
}

Boolean	TPeaksControlWindow::WriteConstraintsFile() {
	short	i,numConstraints ;
	//char	text[256] ;
	
	FILE	*fp = fopen(".constraints","w") ;
	if (fp == nil) return false ;
		
	if (mConstraints->mBonds == nil) {
		fprintf(fp,"BONDS NO\n") ;
	}
	else {
		fprintf(fp,"BONDS YES\n") ;
		if (mConstraints->mBonds->mActive) 
			fprintf(fp,"ACTIVE YES\n") ;
		else
			fprintf(fp,"ACTIVE NO\n") ;
		fprintf(fp,"WEIGHT %f\n",mConstraints->mBonds->mWeight) ;
		numConstraints = mConstraints->mBonds->mNumBonds ;
		fprintf(fp,"NUMBER %d\n",numConstraints) ;
		for(i = 0 ; i < numConstraints; i++) {
			fprintf(fp,"%s %s %f\n",
				mConstraints->mBonds->mBondRec[i].atom1,
				mConstraints->mBonds->mBondRec[i].atom2,
				mConstraints->mBonds->mBondRec[i].distance) ;
		}
	}
	if (mConstraints->mBumpingBonds == nil) {
		fprintf(fp,"BUMPS NO\n") ;
	}
	else {
		fprintf(fp,"BUMPS YES\n") ;
		if (mConstraints->mBumpingBonds->mActive) 
			fprintf(fp,"ACTIVE YES\n") ;
		else
			fprintf(fp,"ACTIVE NO\n") ;
		fprintf(fp,"WEIGHT %f\n",mConstraints->mBumpingBonds->mWeight) ;
		numConstraints = mConstraints->mBumpingBonds->mNumBonds ;
		fprintf(fp,"NUMBER %d\n",numConstraints) ;
		for(i = 0 ; i < numConstraints; i++) {
			fprintf(fp,"%s %s %f\n",
				mConstraints->mBumpingBonds->mBondRec[i].atom1,
				mConstraints->mBumpingBonds->mBondRec[i].atom2,
				mConstraints->mBumpingBonds->mBondRec[i].distance) ;
		}
	}
	if (mConstraints->mStochiometry == nil) {
		fprintf(fp,"STOCHIOMETRY NO\n") ;
	}
	else {
		fprintf(fp,"STOCHIOMETRY YES\n") ;
		if (mConstraints->mStochiometry->mActive) 
			fprintf(fp,"ACTIVE YES\n") ;
		else
			fprintf(fp,"ACTIVE NO\n") ;
		fprintf(fp,"WEIGHT %f\n",mConstraints->mStochiometry->mWeight) ;
		fprintf(fp,"BASE %f\n",mConstraints->mStochiometry->mBase) ;
		numConstraints = mConstraints->mStochiometry->mNumConstraints ;
		fprintf(fp,"NUMBER %d\n",numConstraints) ;
		for(i = 0 ; i < numConstraints; i++) {
			fprintf(fp,"%s %f\n",
				mConstraints->mStochiometry->mStochiometryRecord[i].atom,
				mConstraints->mStochiometry->mStochiometryRecord[i].valence) ;
		}
	}
	if (mConstraints->mCoordination == nil) {
		fprintf(fp,"COORDINATION\tNO\n") ;
	}
	else {
		fprintf(fp,"COORDINATION\tYES\n") ;
		if (mConstraints->mCoordination->mActive) 
			fprintf(fp,"ACTIVE YES\n") ;
		else
			fprintf(fp,"ACTIVE NO\n") ;
		fprintf(fp,"WEIGHT %f\n",mConstraints->mCoordination->mWeight) ;
		numConstraints = mConstraints->mCoordination->mNumConstraints ;
		fprintf(fp,"NUMBER %d\n",numConstraints) ;
		for(i = 0 ; i < numConstraints; i++) {
			fprintf(fp,"%s %d %d\n",
				mConstraints->mCoordination->mCoordinationRecord[i].atom,
				mConstraints->mCoordination->mCoordinationRecord[i].minNeighbors,
				mConstraints->mCoordination->mCoordinationRecord[i].maxNeighbors) ;
		}
	}
	if (mConstraints->mCellContent == nil) {
		fprintf(fp,"CONTENT NO\n") ;
	}
	else {
		fprintf(fp,"CONTENT YES\n") ;
		if (mConstraints->mCellContent->mActive) 
			fprintf(fp,"ACTIVE YES\n") ;
		else
			fprintf(fp,"ACTIVE NO\n") ;
		fprintf(fp,"WEIGHT %f\n",mConstraints->mCellContent->mWeight) ;
		numConstraints = mConstraints->mCellContent->mNumConstraints ;
		fprintf(fp,"NUMBER %d\n",numConstraints) ;
		for(i = 0 ; i < numConstraints; i++) {
			//LDM, changed format (was %s %s %f)
			fprintf(fp,"%s %d %d\n",
				mConstraints->mCellContent->mCellContentRecord[i].atom,
				mConstraints->mCellContent->mCellContentRecord[i].minNumber,
				mConstraints->mCellContent->mCellContentRecord[i].maxNumber) ;
		}
	}
	fflush(fp) ;
	fclose(fp) ;
	return true ;
}

Boolean	TPeaksControlWindow::WriteAtomsToTestFile() {
	TAtomPeak theAtomPeak ;
	int	i,j,flag,len ;
	// Get all the entries from the display list
	ListCellT theCell ;
	theCell.col = 1 ;
	FILE *fp = fopen("atest.lst","w") ;
	if (fp == nil) return false ;
	char	*cp,symbol[5] ;
	for(i = 1 ; i <= mPeakDisplayList->GetNumberOfListItems() ; i++) {
		theCell.row = i ;
		mPeakDisplayList->FetchCellData(theCell,&theAtomPeak) ;
		strcpy(symbol,theAtomPeak.symbol) ;
		len = strlen(symbol) ;
		if (len < 4) {
			for(j=len, cp = symbol+len; j < 4;j++) {*cp++ = ' ' ; }
			*cp = '\0' ;
		}
		if (theAtomPeak.usage == kUsePeak) flag = 1 ; else if (theAtomPeak.usage == kTestPeak) flag = 2 ; else flag = 3 ; 
		fprintf(fp,"%s %d %f %f %f %f %d\n",symbol,theAtomPeak.type,theAtomPeak.xc,theAtomPeak.yc,theAtomPeak.zc,theAtomPeak.peak,flag) ;
	}
	if (mDifferencePeakDisplayList != nil) {
		for(i = 1 ; i <= mDifferencePeakDisplayList->GetNumberOfListItems() ; i++) {
			theCell.row = i ;
			mDifferencePeakDisplayList->FetchCellData(theCell,&theAtomPeak) ;
			strcpy(symbol,theAtomPeak.symbol) ;
			len = strlen(symbol) ;
			if (len < 4) {
				for(j=len, cp = symbol+len; j < 4;j++) {*cp++ = ' ' ; }
				*cp = '\0' ;
			}
			if (theAtomPeak.usage == kUsePeak) flag = 1 ; else if (theAtomPeak.usage == kTestPeak) flag = 2 ; else flag = 3 ; 
			// Only add if uasge is different from kDoNotUsePeak
			if (flag != 3) {
				fprintf(fp,"%s %d %f %f %f %f %d\n",symbol,theAtomPeak.type,theAtomPeak.xc,theAtomPeak.yc,theAtomPeak.zc,theAtomPeak.peak,flag) ;
			}
		}
	}
	fflush(fp) ;
	fclose(fp) ;
	return true ;	
}

void	TPeaksControlWindow::SetAtomList() {
	char	inputLine[256] ;
	
	// We are getting all our data from .edm_3
	// Set up the display list based on the calculated data from peaks
	// Remove all entries from the list
	mPeakDisplayList->RemoveAllRows() ;
	
	FILE *fp = fopen(".edm_3","r") ;
	if (fp == NULL) return ;
	
	TAtomPeak theAtomPeak,*theTypePeak ;
	short	i = 0,j,numTypes = 1  ;
	if (mAtomTypes != nil) numTypes = mAtomTypes->GetNumberOfAtomPeaks() ;
	while(ReadLine(inputLine,256,fp)!=NULL) {
		sscanf(inputLine,"%s %hd %f %f %f %f %f",theAtomPeak.symbol,&theAtomPeak.type,&theAtomPeak.xc,&theAtomPeak.yc,&theAtomPeak.zc,&theAtomPeak.peak,&theAtomPeak.dw) ;
		theAtomPeak.baseIndex = -1 ;
		theAtomPeak.index = i ;
		theAtomPeak.xc = one(theAtomPeak.xc) ;
		theAtomPeak.yc = one(theAtomPeak.yc) ;
		if (numTypes > 1) {
			// Decide which atom type this is since we do not have a number assigned
			for(j=0; j < numTypes; j++) {
				theTypePeak = mAtomTypes->GetAtomPeak(j) ;
				if (theTypePeak != nil) {
					if (strncmp(theTypePeak->symbol,theAtomPeak.symbol,strlen(theTypePeak->symbol)) == 0) {
						theAtomPeak.type = j+1 ;
						break ;
					}
				}
			}
		}
		mPeakDisplayList->AddRow(&theAtomPeak) ;
		i++ ;
	}
	fclose(fp) ;
	CreateDisplayAtoms() ;	
}


void	TPeaksControlWindow::SetDifferenceAtomList() {
	char	inputLine[256] ;
	
	// We are getting all our data from difference.lst
	// Set up the display list based on the calculated data from peaks
	// Remove all entries from the list
	mDifferencePeakDisplayList->RemoveAllRows() ;
	
	FILE *fp = fopen("difference.lst","r") ;
	if (fp == NULL) {
		PutMessage("Unable to read the file 'difference.lst'") ;
		return ;
	}
	TAtomPeak theAtomPeak ;
	short	i = 0 ;
	while(ReadLine(inputLine,256,fp)!=NULL) {
		sscanf(inputLine,"%s %hd %f %f %f %f %f",theAtomPeak.symbol,&theAtomPeak.type,&theAtomPeak.xc,&theAtomPeak.yc,&theAtomPeak.zc,&theAtomPeak.peak,&theAtomPeak.dw) ;
		theAtomPeak.baseIndex = -1 ;
		theAtomPeak.index = i ;
		theAtomPeak.usage = kDoNotUsePeak ;
		theAtomPeak.xc = one(theAtomPeak.xc) ;
		theAtomPeak.yc = one(theAtomPeak.yc) ;
		mDifferencePeakDisplayList->AddRow(&theAtomPeak) ;
		i++ ;
	}
	fclose(fp) ;
	CreateDisplayDifferencePeaks() ;
}

void	TPeaksControlWindow::SetDiffractionList() {
}

void	TPeaksControlWindow::SendPeaksTextCommand(char *commandText) {
	short i ;
	PeakCommand command = 0 ;
	
	// Make sure we convert to upper case for comparison
	for(i = 0 ; i < strlen(commandText); i++) {
		commandText[i] = toupper(commandText[i]) ;
	}
	
	// create the command file for peaks
	if (strcmp(commandText,"1") == 0) {
		command = kPeakOne ;
	}
	else if (strcmp(commandText,"2") == 0) {
		command = kPeakTwo ;
	}
	else if (strcmp(commandText,"EDMT") == 0) {
		command = kPeakEDMT ;
	}
	else if (strcmp(commandText,"HUNT") == 0) {
		command = kPeakHUNT ;
	}
	else if (strcmp(commandText,"BOND") == 0) {
		command = kPeakBOND ;
	}
	else if (strcmp(commandText,"BUMP") == 0) {
		command = kPeakBUMP ;
	}
	else if (strcmp(commandText,"FULL") == 0) {
		command = kPeakFULL ;
	}
	else if (strcmp(commandText,"ERR") == 0) {
		command = kPeakERR ;
	}
	else if (strcmp(commandText,"ROB") == 0) {
		command = kPeakROB ;
	}
	else if (strcmp(commandText,"SEED") == 0) {
		command = kPeakSEED ;
	}
	else
		return ;
		
	SendPeaksCommand(command) ;
}

void	TPeaksControlWindow::SendPeaksCommand(PeakCommand command,float value) {
	// create the command file for peaks
	if (WritePeakCommands(command,value)) {
		TellPeaksToReceiveCommands() ;
		if (command != kPeakQuit) {
			WaitForPeaksToCompleteTask() ;
			if (!mPeaksIsRunning) {
				DisablePeakCommands() ;
			}
		}
	}
	ReportOutput() ;
}

short	TPeaksControlWindow::PeaksReadyToReceiveCommands() { 
	if (!FileExists(".edm_2")) return 0 ;
	short stat = 1 ;
	FILE *fp = fopen(".edm_2","r") ;
	char buffer[256] ;
	fscanf(fp,"%s",buffer) ;
	if (strstr(buffer,"PeaksDone") != nil) stat = -1  ;
	fclose(fp) ;
	return stat ;
} 

Boolean	TPeaksControlWindow::WritePeakCommands(PeakCommand command,float value) {
	// Assemble and write the commands to the file
	char	commandLine[256],text[256] ;
	FILE *fp_edm3 = fopen(".edm_3","w") ;
	FSInfo	theFSInfo ;
	// Put in the commands in the file
	if (fp_edm3 == NULL) return false ;
	float	val ;
	
	switch(command) {
		case kPeakStartup:	
			sprintf(commandLine,"%s%speaks2Dt.sh %s %d &",FS98_PATH,EDMBinDir,mFS98ControlRecord.baseName,mImageNum) ;
			system(commandLine) ;
			break ;
		case kPeakChangeThreshold: // 1
			mPeakThreshold->GetEditText(text) ;
			val = atof(text) ;
			fprintf(fp_edm3,"ACUT \n") ; 
			fprintf(fp_edm3,"%f \n",val) ; 
			break ;
		case kPeakShowCurrentSettings:
			// This returns all current settings for the program
			fprintf(fp_edm3,"WHAT\n") ;   	
			break ;
		case kPeakInquireAtoms:
			// This returns the r-factor for the current combination of atoms
			fprintf(fp_edm3,"ATST\n") ;   	
			break ;
		case kPeakFindBestAtomCombination:
			// Find best combination of atoms and returns the best solution
			fprintf(fp_edm3,"ASR1\n") ;   	
			break ;
		case kPeakUseAtomList :
			// Use what is in the current list, period
			fprintf(fp_edm3,"ASR2\n") ;   	
			break ;
		case kPeakShowAtomAssignments:
			// This returns the assigmnent of atomtypes to peak intensities
			fprintf(fp_edm3,"WATM \n") ;   	
			break ;
		case kPeakSendValue:
			fprintf(fp_edm3,"%f\n",value) ;   	
			break ;
		case kPeakAtoms: // 2 Atoms command
			fprintf(fp_edm3,"A\n") ;   	
			break ;
		case kPeakList: // 3 List command
			fprintf(fp_edm3,"L\n") ;
			fprintf(fp_edm3," \n") ;   	
			break ;
		case kPeakSave: // 4 Save Image command
			fprintf(fp_edm3,"S\n") ;	
			break ;
		case kPeakEnt: // 5 Entropy command
			fprintf(fp_edm3,"E\n") ;	
			break ;
		case kPeakPos: // 6 Positivity command
			fprintf(fp_edm3,"P\n") ;	
			break ;
		case kPeakOcc: // 7 Occupancy command
			fprintf(fp_edm3,"O   \n") ;
			fprintf(fp_edm3," \n \n \n \n \n") ;	
			break ;
		case kPeakRef: // 8 Refine
			fprintf(fp_edm3,"R\n") ;
			fprintf(fp_edm3," \n \n \n \n") ;	
			break ;
		case kPeakFix: // 9 Fix command
			fprintf(fp_edm3,"F\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakGOF: // 10 G-O-F command
			fprintf(fp_edm3,"G\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakDMap: // 11 Difference Map
			fprintf(fp_edm3,"D\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakDProj: // 12 Difference Project
			fprintf(fp_edm3,"J\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakModel: // 13 Current Model (Current Calculated Map from atom peaks)
			fprintf(fp_edm3,"C\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakTrim: // 14 Trim
			fprintf(fp_edm3,"TRIM\n") ;	
			break ;
		case kPeakEnter: // 15 Imports atoms from peaks.new
			fprintf(fp_edm3,"I\nP\n \n") ;	
			break ;	
		case kPeakDMapOne: // 16 Difference map without search
			fprintf(fp_edm3,"1\n") ;
			fprintf(fp_edm3," \n") ;	
			break ;	
		case kPeakTerminal: // 100 switch to terminal mode
			fprintf(fp_edm3,"T\nP\n \n") ;	
			break ;	
		case kPeakOne: // 100 switch to terminal mode
			fprintf(fp_edm3,"1\n") ;
			break ;	
		case kPeakTwo: // 2
			fprintf(fp_edm3,"2\n") ;
			break ;	
		case kPeakEDMT: // 1EDMT
			fprintf(fp_edm3,"EDMT\n") ;	
			break ;	
		case kPeakHUNT: // HUNT
			fprintf(fp_edm3,"HUNT\n") ;	
			break ;	
		case kPeakBOND: // BOND
			fprintf(fp_edm3,"BOND\n") ;	
			break ;	
		case kPeakBUMP: // BUMP
			fprintf(fp_edm3,"BUMP\n") ;	
			break ;	
		case kPeakFULL: // FULL
			fprintf(fp_edm3,"FULL\n") ;	
			break ;	
		case kPeakERR: // ERR
			fprintf(fp_edm3,"ERRO\n") ;	
			break ;
		case kPeakICons: // Intensity conservation
			fprintf(fp_edm3,"ICON\n") ;
			break ;
		case kPeakMultiplicity: // For later perhaps
            fprintf(fp_edm3,"MULT\n") ;
			break ;
		case kPeakROB: // ROB
			fprintf(fp_edm3,"ROBO\n") ;	
			break ;	
		case kPeakSEED: // SEED
			fprintf(fp_edm3,"SEED\n") ;	
			fprintf(fp_edm3," \n") ;	
			break ;
		case kPeakUseFHKL: // Refine on F's
			fprintf(fp_edm3,"TFERR\n") ;
			break ;
		case kPeakDWRef: // Refine DW's as well
			fprintf(fp_edm3,"DWREF\n") ;
			break ;
		case kBabinet: // Do a Babinet switch
			fprintf(fp_edm3,"BABINET\n") ;
			break ;
		case kPeakRefUcmin: // Use Praxis code to refine 
			fprintf(fp_edm3,"BFGS\n") ;
			break ;
		case kPeakRefTwin: // Experimental Twin Mode
				fprintf(fp_edm3,"TWIN\n") ;
			break ;
		case kPeakPurgeSeeds: //PurgeSeeds
			fprintf(fp_edm3,"T2LDM\n") ;
			break ;                       	
		case kPeakReadAtoms: //ReadAtoms
			ChooseFile("Choose Atoms File","*.ins", theFSInfo) ;
			//fprintf(stderr,"%s \n",theFSInfo.mFileName);
			fprintf(fp_edm3,"T3LDM\n") ;
			fprintf(fp_edm3,"%s END\n",theFSInfo.mFileName);
			break ;
		case kPeakSettoModel: //Set to Model
			fprintf(fp_edm3,"TMSET\n") ;
			break ;
		case kPeakConstraints:
			// The constraints have been written to the file '.constraints'
			// Now tellpeaks to read the file and act on it
			fprintf(fp_edm3,"SETC\n") ;
			break ;
		case kPeakQuit: // 1000 Quit
			fprintf(fp_edm3,"q\n") ;	
			break ;
		default:
			fflush(fp_edm3) ;
			fclose(fp_edm3) ;
			return false ;
			break ;
			
	}
	fflush(fp_edm3) ;
	fclose(fp_edm3) ;
	return true ;
}

TPeaksControlWindow::~TPeaksControlWindow() {
	if (mImageMap != nil) delete mImageMap ;
	if (mCurrentModel != nil) delete mCurrentModel ;
	if (mCurrentMap != nil) delete mCurrentMap ;
	if (mDifferenceMap != nil) delete mDifferenceMap ;
	if (mExpDP != nil) delete mExpDP ;
	if (mCurrentDP != nil) delete mCurrentDP ;
	if (mSplitDP != nil) delete mSplitDP ;
	if (mGaussian != nil) delete mGaussian ;
	if (PeaksReadyToReceiveCommands()==1) SendPeaksCommand(kPeakQuit) ;   // Just in case it is not closed
	if (mCalcAmplitude != nil) delete mCalcAmplitude ;
	if (mCalcDifference != nil) delete mCalcDifference ;
	if (mCalcH != nil) delete mCalcH ;
	if (mCalcK != nil) delete mCalcK ;
	if (mCalcL != nil) delete mCalcL ;
	
	if (mAmplitude != nil) delete mAmplitude ;
	if (mAmplitudeError != nil) delete mAmplitudeError ;
	if (mPhase != nil) delete mPhase ;
	if (mH != nil) delete mH ;
	if (mK != nil) delete mK ;
	if (mL != nil) delete mL ;
	if (mAtomPeakList != nil) delete mAtomPeakList ;
	if (mDifferencePeakList != nil) delete mDifferencePeakList ;
	if (mAtomTypes != nil) delete mAtomTypes ;
}

void	TPeaksControlWindow::DoWMRequestDelete() {
	// Send the application the close command for this window
	if (PeaksReadyToReceiveCommands()==1) SendPeaksCommand(kPeakQuit) ;   // Just in case it is not closed
	SetTargetWindow(this) ;
	SendApplicationCommand(kClose) ;
}

void	TPeaksControlWindow::DisplayMap() {
	Rect theRect ;
	TAtomPeak *thePeak ;
	float	fraction1,fraction2 ;
	long	left,top ;	
	//FPoint	atomPos ;

	// Calculate the actual image in which we are displaying			
	long rectWidth = mImageRect.right - mImageRect.left ;
	long rectHeight = mImageRect.bottom - mImageRect.top ;
	
	long	actualImageWidth,actualImageHeight ;
					
	TStOffscreen offScreen(this,&mImageRect) ;
	::SetFgColor(gBlackPixel) ;   	
	PaintRect(&gCurrentPort->GetPortRect()) ;

	// Switch here depending on which map or diffraction pattern we are showing
	switch(mDisplayMode) {
		case kPeakDisplayGeneticMap:
			mCurrentImage = mImageMap ;
			actualImageWidth = mMapWidth ;
			actualImageHeight = mMapHeight ;
			break ;
		case kPeakDisplayCurrentModel:
			if (mCurrentModel == nil) CalculateCurrentModel() ;
			mCurrentImage = mCurrentModel ;
			actualImageWidth = mMapWidth ;
			actualImageHeight = mMapHeight ;
			break ;
		case kPeakDisplayCurrentMap:
			if (mCurrentMap == nil) CalculateCurrentMap() ;
			mCurrentImage = mCurrentMap ;
			actualImageWidth = mMapWidth ;
			actualImageHeight = mMapHeight ;
			break ;
		case kPeakDisplayDifferenceMap:
			if (mDifferenceMap == nil) CalculateDifferenceMap(kPeakDMapOne) ;
			mCurrentImage = mDifferenceMap ;
			actualImageWidth = mMapWidth ;
			actualImageHeight = mMapHeight ;
			break ;
		case kPeakDisplayExperimentalDP:
			if (mExpDP == nil) CalculateExpDiffractionPattern() ;
			mCurrentImage = mExpDP ;
			actualImageWidth = 512 ;
			actualImageHeight = 512 ;
			break ;
		case kPeakDisplayCalculatedDP:
			if (mCurrentDP == nil) CalculateCurrentDiffractionPattern() ;
			mCurrentImage = mCurrentDP ;
			actualImageWidth = 512 ;
			actualImageHeight = 512 ;
			break ;
		case kPeakDisplayFourierFit:
			if (mSplitDP == nil) CalculateSplitDiffractionPattern() ;
			mCurrentImage = mSplitDP ;
			actualImageWidth = 512 ;
			actualImageHeight = 512 ;
			break ;
	}

	if (mCurrentImage == nil) return ;

	if (mScaleFactor == 0.) {
		fraction1 = ((float)rectWidth)/actualImageWidth ;
		fraction2 = ((float)rectHeight)/actualImageHeight ;
		
		mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
		mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
		
		mScaleFactor = fraction1 < fraction2 ? fraction1 : fraction2 ;
		
		long imageWidth = near(mScaleFactor*actualImageWidth) ;
		long imageHeight = near(mScaleFactor*actualImageHeight) ;		
		
		left = mImageCenter.x - imageWidth/2 ;
		top = mImageCenter.y - imageHeight/2 ;
		SetRect(&mActualImageRect,left,top,left+imageWidth,top+imageHeight) ;
		mCurrentImage->ReSize(imageWidth,imageHeight) ;
	}

	
	theRect = mActualImageRect ;
	OffsetRect(&theRect,-mImageRect.left,-mImageRect.top) ;
	mCurrentImage->Display((TWindow *)gCurrentPort,&theRect) ;
	
	if (mDisplayMode == kPeakDisplayGeneticMap 
			|| mDisplayMode == kPeakDisplayCurrentModel
			|| mDisplayMode == kPeakDisplayCurrentMap
			|| mDisplayMode == kPeakDisplayDifferenceMap) {
		TVector A,B,O ;
		float	aa,bb ;
		float   ww,hh ;
		short   nOffset ;
		ww = (theRect.right-theRect.left)/mFS98ControlRecord.width  ;
		hh = (theRect.bottom-theRect.top)/mFS98ControlRecord.height ;
		// We need to see if we have P3 or P6 symmetry
		if (mFS98ControlRecord.ga == 120.) {
			ww /= 2 ;
			hh /= 2 ;
			aa = sqrt(ww*ww+hh*hh) ;
			O.a[0] = theRect.left + ww ; 
			O.a[1] = theRect.top ; 
			B.a[0] = -ww ;
			B.a[1] = hh ;
			A.a[0] = ww ;
			A.a[1] = hh ;
			
			// Offset the origin by (n-1)*a where n is the number of cells being viewed
			// This might have to take into consideration the number along the other direction 
			// as well
			nOffset = mFS98ControlRecord.width < mFS98ControlRecord.height ? mFS98ControlRecord.width : mFS98ControlRecord.height ;
			O.a[0] += (nOffset-1)*A.a[0] ;
			O.a[1] += (nOffset-1)*A.a[1] ;
		}
		else {
			aa = ww ;
			bb = hh ;
			O.a[0] = theRect.left ; 
			O.a[1] = theRect.top ; 
			A.a[0] = aa ;
			A.a[1] = 0. ;
			B.a[0] = 0 ;
			B.a[1] = bb ;			
			O.a[0] += (mFS98ControlRecord.width-1)*A.a[0] + (mFS98ControlRecord.width-1)*B.a[0] ; //Was 2, should be 1 ?
			O.a[1] += (mFS98ControlRecord.height-1)*B.a[1] + (mFS98ControlRecord.height-1)*A.a[1];
		}
		
	    //fprintf(stderr,"Origins %d and %d \n",O.a[0],O.a[1]); //Here ??
		// Draw unit cell outline always
		::SetFgColor(gRedPixel) ; 
		MoveTo(near(O.a[0]),near(O.a[1])) ;
		LineTo(near(O.a[0]+A.a[0]),near(O.a[1]+A.a[1])) ;
		LineTo(near(O.a[0]+A.a[0]+B.a[0]),near(O.a[1]+A.a[1]+B.a[1])) ;
		LineTo(near(O.a[0]+B.a[0]),near(O.a[1]+B.a[1])) ;
		LineTo(near(O.a[0]),near(O.a[1])) ;
		::SetFgColor(gBlackPixel) ; 
		
		if (mOverlayAtoms->GetState()) {
			ListCellT theCell ;
			theCell.col = 1 ;
			float   x,y ;
			long i ;
			TAtomPeakList *theList = mShowCurrentPeakList->GetState() ? mAtomPeakList : mDifferencePeakList ;
			if (theList != nil) {
				for(i=0; i < theList->GetNumberOfAtomPeaks(); i++) {
					thePeak = theList->GetAtomPeak(i) ;
					if (thePeak->baseIndex == -1) {
						PenSize(2,2) ;
						::SetFgColor(gRedPixel) ; 
					}
					else if (thePeak->baseIndex == -2) {
						::SetFgColor(gGreenPixel) ; 
					}
					else {
						PenSize(1,1) ;
						::SetFgColor(gBluePixel) ; 
					}
					x = O.a[0] + thePeak->xc*A.a[0] + thePeak->yc*B.a[0] ;
					y = O.a[1] + thePeak->xc*A.a[1] + thePeak->yc*B.a[1] ;
					thePeak->screenPos.x = x ;
					thePeak->screenPos.y = y ;
					thePeak->screenRad = 6 ;
					DrawCircle(near(thePeak->screenPos.x),near(thePeak->screenPos.y),thePeak->screenRad) ;
					if (thePeak->state) {
						::SetFgColor(gWhitePixel) ; 
						DrawCircle(near(thePeak->screenPos.x),near(thePeak->screenPos.y),thePeak->screenRad+2) ;
						::SetFgColor(gBlackPixel) ; 
						DrawCircle(near(thePeak->screenPos.x),near(thePeak->screenPos.y),thePeak->screenRad-2) ;
					}
				}
				::SetFgColor(gBlackPixel) ; 
				PenSize(1,1) ;
			}
		}
	}
}

void	TPeaksControlWindow::FindUnitCellPosition(FPoint &screenPos,FPoint &atomPos) {
	TVector A,B,O ;
	float	aa,bb ;
	float   ww,hh ;
	short   nOffset ;

	Rect theRect = mActualImageRect ;
	
	FPoint	sPos = screenPos ;
	sPos.x += mImageRect.left ;
	sPos.y += mImageRect.top ;
	
	float nx = mFS98ControlRecord.width ;
	float ny = mFS98ControlRecord.height ;

	ww = (theRect.right-theRect.left)/nx  ;
	hh = (theRect.bottom-theRect.top)/ny ;
	// We need to see if we have P3 or P6 symmetry
	if (mFS98ControlRecord.ga == 120.) {
		ww /= 2 ;
		hh /= 2 ;
		aa = sqrt(ww*ww+hh*hh) ;
		O.a[0] = theRect.left + ww ; 
		O.a[1] = theRect.top ; 
		B.a[0] = -ww ;
		B.a[1] = hh ;
		A.a[0] = ww ;
		A.a[1] = hh ;
		
		// Offset the origin by (n-1)*a where n is the number of cells being viewed
		// This might have to take into consideration the number along the other direction 
		// as well
		nOffset = nx < ny ? nx : ny ;
		O.a[0] += (nOffset-1)*A.a[0] ;
		O.a[1] += (nOffset-1)*A.a[1] ;
	}
	else {
		aa = ww ;
		bb = hh ;
		O.a[0] = theRect.left ; 
		O.a[1] = theRect.top ; 
		A.a[0] = aa ;
		A.a[1] = 0. ;
		B.a[0] = 0 ;
		B.a[1] = bb ;			
		O.a[0] += (nx-2)*A.a[0] + (nx-2)*B.a[0] ;
		O.a[1] += (ny-2)*B.a[1] + (ny-2)*A.a[1];
	}
	
	float	sx = sPos.x  ;
	float	sy = sPos.y ;
	
	float	det = A.a[0]*B.a[1] - A.a[1]*B.a[0] ;

	sx -= O.a[0] ;
	sy -= O.a[1] ;
	
	atomPos.x = (sx*B.a[1] - sy*B.a[0])/det ;
	atomPos.y = (sy*A.a[0] - sx*A.a[1])/det ;
	
}

void	TPeaksControlWindow::ReadAtomTypes() {
	SendPeaksCommand(kPeakShowAtomAssignments) ;

	// Read back the result
	char	inputLine[256] ; //,buffer[256] ;
	//int		i ;
	
	FILE *fp = fopen(".edm_3","r") ;
	if (fp == NULL) return ;
	
	if (mAtomTypes != nil) delete mAtomTypes ; 
	mAtomTypes = new TAtomPeakList ;
	TAtomPeak   *thePeak ;
	while(ReadLine(inputLine,256,fp)!=NULL) {
		thePeak = new TAtomPeak ;
		sscanf(inputLine,"%s %hd %f",thePeak->symbol,&thePeak->type,&thePeak->peak) ;
		mAtomTypes->AddAtomPeak(thePeak) ;
	}
	fclose(fp) ;
	// This is here for debug purposes only
	//
	//if (mAtomTypes->GetNumberOfAtomPeaks() > 0) {
	//	thePeak = mAtomTypes->GetAtomPeak(0) ;
	//	sprintf(inputLine,"Got: %s %d %f",thePeak->symbol,thePeak->type,thePeak->peak) ;
	//	for(i=1; i < mAtomTypes->GetNumberOfAtomPeaks(); i++) {
	//		thePeak = mAtomTypes->GetAtomPeak(i) ;
	//		sprintf(buffer," , %s %d %f",thePeak->symbol,thePeak->type,thePeak->peak) ;
	//		strcat(inputLine,buffer) ;
	//	}
	//	WriteMessage(inputLine) ;
	//}
	//else {
	//	WriteMessage("Got no atom types") ;
	//}
	//
}
void TPeaksControlWindow::WriteResult() {
	char	inputLine[256] ;
				
	// We are getting the data from .edm_3	
	FILE *fp = fopen(".edm_3","r") ;
	if (fp == NULL) return ;
	
	if (ReadLine(inputLine,256,fp)!=NULL) {
		WriteMessage(inputLine) ;
	}
	fclose(fp) ;
}

void TPeaksControlWindow::ReportOutput() {
	char	inputLine[256] ;
	
	if (!mLogDiagnosticOutput) return ;					
				
	// We are getting all our data from .edm_3
	// Set up the display list based on the calculated data from peaks
	// Remove all entries from the list
	mLogList->RemoveAllRows() ;
	
	FILE *fp = fopen(".edm_3","r") ;
	if (fp == NULL) return ;
	while(ReadLine(inputLine,256,fp)!=NULL) {
		mLogList->AddRow(inputLine) ;
	}
	fclose(fp) ;
}

Boolean TPeaksControlWindow::Equivalent(float x,float y) {
  /* ----------------------------------------------------------	*/
  /* Routine to check if the atom whose coordinates were just	*/
  /* passed is a new one.  	*/
  /* Returns (false) if this is a 'new' atom, (true) otherwise  */
  /* ----------------------------------------------------------	*/

	long 	k ;
	Boolean xtest,ytest ;
	float 	xdiff,ydiff,a,b ;
	a = mFS98ControlRecord.a ;
	b = mFS98ControlRecord.b ;
	TAtomPeak   *existingPeak ;
	for (k=0 ; k < mAtomPeakList->GetNumberOfAtomPeaks() ; k++) {
		existingPeak = mAtomPeakList->GetAtomPeak(k) ;
		xdiff = (x-existingPeak->xc)*a ;
		ydiff = (y-existingPeak->yc)*b ;
		xtest = false ; 
		ytest = false ; 
		if (fabs(xdiff) < 0.1) xtest = true ;
		if (fabs(ydiff) < 0.1) ytest = true ;
		if (xtest && ytest) 
			return(true) ;			// The atom already exists
	}
	return(false) ;					// New atom 
} 

void	TPeaksControlWindow::SetSymmetryRelatedPeaks() {
	float		xe,ye ; //,i ;
	TAtomPeak   *thePeak,*existingPeak,theUniquePeak  ;
	ListCellT	theCell ;
	int i ;
	
	short	numUniqueAtoms = mPeakDisplayList->GetNumberOfListItems() ;
	theCell.col = 1 ;
	for(i=0 ; i < numUniqueAtoms; i++) {
		theCell.row = i+1 ;
		mPeakDisplayList->FetchCellData(theCell,&theUniquePeak) ;
		
		if (theUniquePeak.baseIndex == -2) continue ;	// Don't add symmetry related peaks
			//fprintf(stderr," Plane Group %d \n",mPlaneGroupIndex);
		switch(mPlaneGroupIndex) {
			case 0:		// p1
				break ;
			case 1:		// p2
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 2:		// pm
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 3:		// p11m
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 4:		// p1g1
				xe = one(-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 5:		// p11g
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 6:		// c1m1
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 7:		// c11m
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 8:		// p2mm
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 9:		// p2mg
				xe = one(-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 10:	// p2gm				
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
					
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 11:	// p2gg
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
					
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 12:	// c2mm
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
					
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 13:	// p4
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 14:	// p4mm
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 15:	// p4mg
				xe = one(0.5+theUniquePeak.yc) ;
				ye = one(0.5+theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break     ;
			case 16:	// p4gm
				xe = one(0.5+theUniquePeak.xc) ;
				ye = one(0.5+theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.yc) ;
				ye = one(0.5-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5-theUniquePeak.yc) ;
				ye = one(0.5+theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(0.5+theUniquePeak.yc) ;
				ye = one(0.5-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 17:	// p3
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 18:	// p3m1
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(-theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.xc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 19:	// p31m
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.xc-theUniquePeak.yc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 20:	// p6
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
			case 21: // p6mm
				xe = one(-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc-theUniquePeak.yc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.yc-theUniquePeak.xc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				xe = one(theUniquePeak.yc) ;
				ye = one(theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}

				xe = one(-theUniquePeak.xc) ;
				ye = one(theUniquePeak.yc-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(theUniquePeak.xc-theUniquePeak.yc) ;
				ye = one(-theUniquePeak.xc) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
					
				xe = one(-xe) ;
				ye = one(-ye) ;
				if (!Equivalent(xe,ye)) {
					thePeak = new TAtomPeak(theUniquePeak) ;
					thePeak->xc = xe ;
					thePeak->yc = ye ;
					thePeak->baseIndex = theUniquePeak.index ;
					mAtomPeakList->AddAtomPeak(thePeak) ;
				}
				break ;
		}	
	}
	
	short	numAtomsThisFar = mAtomPeakList->GetNumberOfAtomPeaks() ;
	for(i=0; i < numAtomsThisFar ; i++) {
		existingPeak = mAtomPeakList->GetAtomPeak(i) ;
		xe = one(existingPeak->xc) ;
		ye = one(existingPeak->yc) ;
		// Add on the fly the equivalent at 1,1's
		if (xe == 0. || ye == 0.) {
			if (xe == 0. && ye == 0.) {
				thePeak = new TAtomPeak(*existingPeak) ;
				thePeak->xc = 1 ;
				thePeak->yc = 0 ;
				if (existingPeak->baseIndex == -1) thePeak->baseIndex = existingPeak->index ;
				mAtomPeakList->AddAtomPeak(thePeak) ;
				
				thePeak = new TAtomPeak(*existingPeak) ;
				thePeak->xc = 0 ;
				thePeak->yc = 1 ;
				if (existingPeak->baseIndex == -1) thePeak->baseIndex = existingPeak->index ;
				mAtomPeakList->AddAtomPeak(thePeak) ;
				
				thePeak = new TAtomPeak(*existingPeak) ;
				thePeak->xc = 1 ;
				thePeak->yc = 1 ;
				if (existingPeak->baseIndex == -1) thePeak->baseIndex = existingPeak->index ;
				mAtomPeakList->AddAtomPeak(thePeak) ;
				
			}
			else if (ye == 0. && xe != 0.) {
				thePeak = new TAtomPeak(*existingPeak) ;
				thePeak->xc = xe ;
				thePeak->yc = 1 ;
				if (existingPeak->baseIndex == -1) thePeak->baseIndex = existingPeak->index ;
				mAtomPeakList->AddAtomPeak(thePeak) ;
			}
			else if (xe == 0. && ye != 0.) {
				thePeak = new TAtomPeak(*existingPeak) ;
				thePeak->xc = 1 ;
				thePeak->yc = ye ;
				if (existingPeak->baseIndex == -1) thePeak->baseIndex = existingPeak->index ;
				mAtomPeakList->AddAtomPeak(thePeak) ;
			}
		}
	}
}

void	TPeaksControlWindow::CreateDisplayAtoms() {
	ListCellT theCell ;
	theCell.col = 1 ;
	if (mAtomPeakList != nil) delete mAtomPeakList ;
	mAtomPeakList = new TAtomPeakList ;
	long i ; //,j ;
	TAtomPeak   *thePeak,listPeak ;
	// Add	the original atom
	for(i=0 ; i < mPeakDisplayList->GetNumberOfListItems(); i++) {
		theCell.row = i+1 ;
		mPeakDisplayList->FetchCellData(theCell,&listPeak) ;
		thePeak = new TAtomPeak(listPeak) ;
		thePeak->xc = one(listPeak.xc) ;
		thePeak->yc = one(listPeak.yc) ;
		mAtomPeakList->AddAtomPeak(thePeak) ;
	}
	// Apply the symmetry operators for the plane group
	SetSymmetryRelatedPeaks() ;
}


void	TPeaksControlWindow::CreateDisplayDifferencePeaks() {
	ListCellT theCell ;
	theCell.col = 1 ;
	if (mDifferencePeakList != nil) delete mDifferencePeakList ;
	mDifferencePeakList = new TAtomPeakList ;
	long i ; //,j ;
	TAtomPeak   *thePeak,listPeak ;
	// Add	the original atom
	for(i=0 ; i < mDifferencePeakDisplayList->GetNumberOfListItems(); i++) {
		theCell.row = i+1 ;
		mDifferencePeakDisplayList->FetchCellData(theCell,&listPeak) ;
		thePeak = new TAtomPeak(listPeak) ;
		thePeak->xc = one(listPeak.xc) ;
		thePeak->yc = one(listPeak.yc) ;
		mDifferencePeakList->AddAtomPeak(thePeak) ;
	}
}

void	TPeaksControlWindow::CalculateExpDiffractionPattern() {
	long i,j,ndxi,ndxj,h,k,w2 ; //,h2 ;
	// Square image
	
	if (mExpDP != nil) delete mExpDP ;
	mExpDP = new TImage(512,512) ;
	
	long	width = mExpDP->Width() ;
	float	du = mGMax/(width/2) ;
	float	sigma = mDiskRadius/du ;
	float	sigmasq = sigma*sigma ;
	w2 = width/2 ;
	if (mGaussian == nil) //{
		mGaussian = new TImage(mExpDP->Width(),mExpDP->Height()) ;
		for(i=-20; i < 20 ; i++) {
			ndxi = i ;
			if (ndxi < 0) ndxi += width ;
			for(j=-20; j < 20 ; j++) {
				ndxj = j ;
				if (ndxj < 0) ndxj += width ;
				*mGaussian->GetData(ndxi,ndxj) = exp(-(i*i+j*j)/sigmasq) ;
			}
		}		
	//}
	float	x,y ;
	float	gast = 180 - mFS98ControlRecord.ga ;
	float	sigast = sin(gast*asin(1.0)/90.) ;
	float	csgast = cos(gast*asin(1.0)/90.) ;	
	float	astar = 1.0/mFS98ControlRecord.a/sigast ;
	float	bstar = 1.0/mFS98ControlRecord.b/sigast ;
	float	astarx	= astar ;
	float	astary = 0 ;
	float	bstarx	= bstar*csgast ;
	float	bstary = bstar*sigast ;
	
	for(i = 0; i < mNumReflections; i++) {
		h = mH[i] ;
		k = mK[i] ;
		
		//if (h == 0 && k == 0) fprintf(stderr,"Amp %f \n",mAmplitude[i]);
		
		x = (h*astarx + k*bstarx)/du ;
		y = (h*astary + k*bstary)/du ;
		mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
		mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
		// Set equivalent reflections
		switch(mPlaneGroupIndex) {
			case 0:		// p1
				break ;
			case 1:		// p2
				break ;
			case 2:		// pm
			case 3:		// p11m
			case 4:		// p1g1
			case 5:		// p11g
			case 6:		// c1m1
			case 7:		// c11m
			case 8:		// p2mm
			case 9:		// p2mg
			case 10:	// p2gm				
			case 11:	// p2gg
			case 12:	// c2mm
				// All of these are p2mm Patterson
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 13:	// p4
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 14:	// p4mm
			case 15:	// p4mg
			case 16:	// p4gm
				// All these are p4mm Patterson
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break     ;
			case 17:	// p3
			case 20:	// p6
				// Both have p6 Patterson
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 18:	// p3m1
			case 19:	// p31m
			case 21:	// p6mm
				// All have p6mm Patterson
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mExpDP->SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				mExpDP->SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
		}	
	}
	// Convolute with a Gaussian to create a realistic diffraction pattern
	TImage temp1(*mExpDP) ;
	TImage temp2(*mGaussian) ;
	mExpDP->FFT() ;
	temp2.FFT() ;
	*mExpDP *= temp2 ;
	mExpDP->IFFT() ;
}

void	TPeaksControlWindow::CalculateCurrentModel() {
	SendPeaksCommand(kPeakModel) ;
	if (mCurrentModel != nil) {
		delete mCurrentModel ;
		mCurrentModel = nil ;
	}
	// Read in the image EDMs.tif
	mCurrentModel = ImportTiffFile("EDMs.tif") ;
	if (mCurrentModel != nil) {
		mCurrentModel->ReSize(mImageMap->Width(),mImageMap->Height()) ;
	}
}

void	TPeaksControlWindow::CalculateCurrentMap() {
	SendPeaksCommand(kPeakSave) ;
	if (mCurrentMap != nil) {
		delete mCurrentMap ;
		mCurrentMap = nil ;
	}
	// Read in the image EDMs.tif
	mCurrentMap = ImportTiffFile("EDMs.tif") ;
	if (mCurrentMap != nil) {
		mCurrentMap->ReSize(mImageMap->Width(),mImageMap->Height()) ;
	}
}

void	TPeaksControlWindow::CalculateDifferenceMap(PeakCommand cmnd) {
	SendPeaksCommand(cmnd) ;
	if (mDifferenceMap != nil) {
		delete mDifferenceMap ;
		mDifferenceMap = nil ;
	}
	// Read in the image EDMs.tif
	mDifferenceMap = ImportTiffFile("EDMs.tif") ;
	if (mDifferenceMap != nil) {
		mDifferenceMap->ReSize(mImageMap->Width(),mImageMap->Height()) ;
	}
	
	if (cmnd == kPeakDMap) {
		// This is an iterative search and we need to update the atoms from the current solution
		SendPeaksCommand(kPeakList) ;
		SetAtomList() ;	
		// Update the solution coming from occupancy if we have it
		if (mSolutionList->GetNumberOfListItems() > 0) {
			// Do a goodness of fit command to get the new value
			// float gof = GetGoodnessOfFit() ;
			// Update the atoms
			// UpdateCurrentSolution(gof) ;
			// Changed to doing a seed refine
			SendPeaksCommand(kPeakSEED) ;
			SetOccupancySolutions() ;
		}
	}
	else if (cmnd == kPeakDMapOne) {
		// We are getting a list of peaks in the difference map which is located in the file
		// 'difference.lst'
		SetDifferenceAtomList() ;
	}
}

float	TPeaksControlWindow::GetGoodnessOfFit() {
	SendPeaksCommand(kPeakGOF) ;
	char	inputLine[256],s1[256]; //,s2[256] ;
	float   gof = 0. ;
	
	FILE *fp = fopen(".edm_3","r") ;
	if (fp == NULL) return gof ;
	
	// if (ReadLine(inputLine,256,fp)==NULL) return gof ;
	// if (ReadLine(inputLine,256,fp)==NULL) return gof ;
	if (ReadLine(inputLine,256,fp)==NULL) return gof ;
	sscanf(inputLine,"%s %f",s1,&gof) ;
	fclose(fp) ;
	return gof ;
}

void	TPeaksControlWindow::UpdateCurrentSolution(float gof) {
	// We have to update the number of atoms in the list os solutions for the current solution
	TPeakSolution   thePeakSolution ;
	TAtomPeak		theAtomPeak,*solutionAtomPeak ;
	ListCellT currentSolutionCell,inCell ;
	currentSolutionCell.row = mSolutionList->mSelectedSolution ;
	currentSolutionCell.col = 1 ;
	mSolutionList->FetchCellData(currentSolutionCell,&thePeakSolution) ;
	thePeakSolution.mRValue = gof ;
	mSolutionList->SetCellData(currentSolutionCell,&thePeakSolution) ;
	inCell.col = 1 ;
	short previousNumAtoms = thePeakSolution.mAtomPeakList->GetNumberOfAtomPeaks() ;
	for (short i = 1 ; i <= mPeakDisplayList->GetNumberOfListItems(); i++) {
		inCell.row = i ;
		mPeakDisplayList->FetchCellData(inCell,&theAtomPeak) ;
		// Update the peaksolution list
		if (i <= previousNumAtoms) {
			// Modify the existing atom
			solutionAtomPeak = thePeakSolution.mAtomPeakList->GetAtomPeak(i-1) ;
			*solutionAtomPeak = theAtomPeak ;
		}
		else {
			solutionAtomPeak = new TAtomPeak ;
			*solutionAtomPeak = theAtomPeak ;
			thePeakSolution.mAtomPeakList->AddAtomPeak(solutionAtomPeak) ;
		}
	}
	mSolutionList->Refresh() ; // because of the goodness of fit change
}


void	TPeaksControlWindow::CalculateCurrentDiffractionPattern() {
	long i,j,ndxi,ndxj,h,k,w2; //,h2 ;
	// Square image
	if (mCurrentDP != nil) delete mCurrentDP ;
	mCurrentDP = new TImage(512,512) ;
	
	if (mNumCalculatedReflections == 0) return ;	// There is nothing to set

	long	width = mCurrentDP->Width() ;
	float	du = mGMax/(width/2) ;
	float	sigma = mDiskRadius/du ;
	float	sigmasq = sigma*sigma ;
	w2 = width/2 ;
	if (mGaussian == nil) //{
		mGaussian = new TImage(mCurrentDP->Width(),mCurrentDP->Height()) ;
		for(i=-20; i < 20 ; i++) {
			ndxi = i ;
			if (ndxi < 0) ndxi += width ;
			for(j=-20; j < 20 ; j++) {
				ndxj = j ;
				if (ndxj < 0) ndxj += width ;
				*mGaussian->GetData(ndxi,ndxj) = exp(-(i*i+j*j)/sigmasq) ;
			}
		}		
	//}
	float	x,y ;
	float	gast = 180 - mFS98ControlRecord.ga ;
	float	sigast = sin(gast*asin(1.0)/90.) ;
	float	csgast = cos(gast*asin(1.0)/90.) ;	
	float	astar = 1.0/mFS98ControlRecord.a/sigast ;
	float	bstar = 1.0/mFS98ControlRecord.b/sigast ;
	float	astarx	= astar ;
	float	astary = 0 ;
	float	bstarx	= bstar*csgast ;
	float	bstary = bstar*sigast ;
	//fprintf(stderr," Plane Group %d \n",mPlaneGroupIndex);
	for(i = 0; i < mNumCalculatedReflections; i++) {
		h = mCalcH[i] ;
		k = mCalcK[i] ;

		//if (h == 0 && k == 0) fprintf(stderr,"Calc %f \n",mCalcAmplitude[i]);

		x = (h*astarx + k*bstarx)/du ;
		y = (h*astary + k*bstary)/du ;
		mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
		mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
		// Set equivalent reflections
		switch(mPlaneGroupIndex) {
			case 0:		// p1
				break ;
			case 1:		// p2
				break ;
			case 2:		// pm
			case 3:		// p11m
			case 4:		// p1g1
			case 5:		// p11g
			case 6:		// c1m1
			case 7:		// c11m
			case 8:		// p2mm
			case 9:		// p2mg
			case 10:	// p2gm				
			case 11:	// p2gg
			case 12:	// c2mm
				// All of these are p2mm Patterson
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 13:	// p4
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 14:	// p4mm
			case 15:	// p4mg
			case 16:	// p4gm
				// All these are p4mm Patterson
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break     ;
			case 17:	// p3
			case 20:	// p6
				// Both have p6 Patterson
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 18:	// p3m1
			case 19:	// p31m
			case 21:	// p6mm
				// All have p6mm Patterson
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				mCurrentDP->SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				mCurrentDP->SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
		}	
	}
	// Convolute with a Gaussian to create a realistic diffraction pattern
	TImage temp1(*mCurrentDP) ;
	TImage temp2(*mGaussian) ;
	mCurrentDP->FFT() ;
	temp2.FFT() ;
	*mCurrentDP *= temp2 ;
	mCurrentDP->IFFT() ;
        //LDM comment, should set the max to the max of the experimental case (or similar)
}

void	TPeaksControlWindow::CalculateSplitDiffractionPattern() {
	// Calculate the experimental spots

	long	i,j,ndxi,ndxj,h,k,w2 ;
	float	val ;
	
	// Square image
	TImage	experiment(512,512);
	TImage	calc(512,512) ;
	TImage	gaussExp(512,512) ;
	TImage	gaussCalc(512,512) ;
	
	long	width = experiment.Width() ;
	//long	height = experiment.Height() ;
	w2 = width/2 ;
	
	float	du = mGMax/(width/2) ;
	float	sigma = mDiskRadius/du ;
	float	sigmasq = sigma*sigma ;

	gaussExp = 0 ;
	//Old code, nice idea but too hard to see (LDM)
	//gaussCalc = 0 ;
	//for( j = -20 ; j <= 20 ; j++) {
	//	ndxj = j ;
	//	if (ndxj < 0) ndxj += height ;
	//	for( i = 0; i <= 20 ; i++) {
	//		val = exp(-(i*i+j*j)/sigmasq) ;
	//		ndxi = i ;
	//		if (i > 0)
	//			gaussCalc.SetPixel(ndxi,ndxj,val) ;
	//		ndxi = width - ndxi ;
	//		if (ndxi == width) ndxi = 0 ;
	//		gaussExp.SetPixel(ndxi,ndxj,val)  ;
	//	}
	//}
        //New version, KISS
	for(i=-20; i < 20 ; i++) {
		ndxi = i ;
		if (ndxi < 0) ndxi += width ;
		for(j=-20; j < 20 ; j++) {
			ndxj = j ;
			if (ndxj < 0) ndxj += width ;
			val = exp(-(i*i+j*j)/sigmasq) ;
			gaussExp.SetPixel(ndxi,ndxj,val)  ;
                        //gaussCalc.SetPixel(ndxi,ndxj,-val)  ;
		}
	}
	float	x,y ; //,ux,uy ;
	float	gast = 180 - mFS98ControlRecord.ga ;
	float	sigast = sin(gast*asin(1.0)/90.) ;
	float	csgast = cos(gast*asin(1.0)/90.) ;	
	float	astar = 1.0/mFS98ControlRecord.a/sigast ;
	float	bstar = 1.0/mFS98ControlRecord.b/sigast ;
	float	astarx	= astar ;
	float	astary = 0 ;
	float	bstarx	= bstar*csgast ;
	float	bstary = bstar*sigast ;
	// Should just use
	// diff = mAmplitude - mCalcAmplitude ;
	for(i = 0; i < mNumReflections; i++) {
		h = mH[i] ;
		k = mK[i] ;

		//if (h == 0 && k == 0) fprintf(stderr,"Amp %f \n",mAmplitude[i]);

		x = (h*astarx + k*bstarx)/du ;
		y = (h*astary + k*bstary)/du ;
		experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
		experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
		// Set equivalent reflections
		switch(mPlaneGroupIndex) {
			case 0:		// p1
				break ;
			case 1:		// p2
				break ;
			case 2:		// pm
			case 3:		// p11m
			case 4:		// p1g1
			case 5:		// p11g
			case 6:		// c1m1
			case 7:		// c11m
			case 8:		// p2mm
			case 9:		// p2mg
			case 10:	// p2gm				
			case 11:	// p2gg
			case 12:	// c2mm
				// All of these are p2mm Patterson
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 13:	// p4
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 14:	// p4mm
			case 15:	// p4mg
			case 16:	// p4gm
				// All these are p4mm Patterson
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break     ;
			case 17:	// p3
			case 20:	// p6
				// Both have p6 Patterson
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
			case 18:	// p3m1
			case 19:	// p31m
			case 21:	// p6mm
				// All have p6mm Patterson
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				experiment.SetPixel(w2+x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2-y,mAmplitude[i]) ;
				experiment.SetPixel(w2+x,w2+y,mAmplitude[i]) ;
				experiment.SetPixel(w2-x,w2+y,mAmplitude[i]) ;
				break ;
		}
	}
	
	for(i = 0; i < mNumCalculatedReflections; i++) {
		h = mCalcH[i] ;
		k = mCalcK[i] ;

		//if (h == 0 && k == 0) fprintf(stderr,"Amp %f \n",mAmplitude[i]);

		x = (h*astarx + k*bstarx)/du ;
		y = (h*astary + k*bstary)/du ;
		calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
		calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
		// Set equivalent reflections
		switch(mPlaneGroupIndex) {
			case 0:		// p1
				break ;
			case 1:		// p2
				break ;
			case 2:		// pm
			case 3:		// p11m
			case 4:		// p1g1
			case 5:		// p11g
			case 6:		// c1m1
			case 7:		// c11m
			case 8:		// p2mm
			case 9:		// p2mg
			case 10:	// p2gm				
			case 11:	// p2gg
			case 12:	// c2mm
				// All of these are p2mm Patterson
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 13:	// p4
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 14:	// p4mm
			case 15:	// p4mg
			case 16:	// p4gm
				// All these are p4mm Patterson
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] ;
				k = mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break     ;
			case 17:	// p3
			case 20:	// p6
				// Both have p6 Patterson
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
			case 18:	// p3m1
			case 19:	// p31m
			case 21:	// p6mm
				// All have p6mm Patterson
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = mK[i] ;
				k = -mH[i] - mK[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				h = -mH[i] - mK[i] ;
				k = mH[i] ;
				x = (h*astarx + k*bstarx)/du ;
				y = (h*astary + k*bstary)/du ;
				calc.SetPixel(w2+x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2-y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2+x,w2+y,mCalcAmplitude[i]) ;
				calc.SetPixel(w2-x,w2+y,mCalcAmplitude[i]) ;
				break ;
		}
	}
	experiment -= calc ;
	// Convolute with a Gaussian to create a realistic diffraction pattern
	experiment.FFT() ;
	//calc.FFT() ;
	gaussExp.FFT() ;
	//gaussCalc.FFT() ;
	experiment *= gaussExp ;
	//calc *= gaussCalc ;
	//calc *= gaussExp ;
	experiment.IFFT() ;
	//calc.IFFT() ;
	//experiment += calc ;
	
	if (mSplitDP != nil) delete mSplitDP ;
	mSplitDP = new TImage(experiment) ;
}

void	PutMessage(char *) ;
#define	CR	'\r'
#define LF	'\n'

void	TPeaksControlWindow::ReadHKLDataSet() {
	// First count the number of lines
	char	c,c0,fileName[256],buffer[256] ;
	long	i ;
	sprintf(fileName,"%s.hkl",mFS98ControlRecord.baseName) ;

	mNumReflections = 0 ;

	FILE *fp = fopen(fileName,"r") ;
	if (fp == nil) return ;
	//LDM Get first character
	c0 = fgetc(fp) ;	
	for (; (c = fgetc(fp)) != EOF ; ) {
		if (c == CR || c == LF) mNumReflections++ ;
	}	
	
	if (mNumReflections == 0) {
		PutMessage("Did not find any reflection data") ;
		return ;
	}

	mAmplitude 	= new float[mNumReflections] ;
	mPhase 		= new float[mNumReflections] ;
	mH			= new short[mNumReflections] ;
	mK			= new short[mNumReflections] ;
	mL			= new short[mNumReflections] ;

	// Now rewind and read in the data
	rewind(fp) ;
	for (i = 0 ;  i < mNumReflections; i++) {
		if (ReadLine(buffer,256,fp) == NULL) break ;
		//LDM skip first line if it starts with h
		if ( i == 0 && buffer[0] == 'h' ) {
			//fprintf(stderr , "Inside logical\n" );
			if (ReadLine(buffer,256,fp) == NULL) break ;
		}
		sscanf(buffer,"%hd %hd %hd %f %f",&mH[i],&mK[i],&mL[i],&mAmplitude[i],&mPhase[i]) ;	
	}	
	fclose(fp) ;
	//LDM Correct the number of reflections if needed
	if (c0 == 'h') mNumReflections = mNumReflections - 1 ;
}


void	TPeaksControlWindow::ReadCalculatedHKLDataSet() {
	// First count the number of lines
	char	c,buffer[256] ; //,c0,fileName[256] ;
	long	i ;
	//float	expValue ;
	FILE	*fp ;
	
	mNumCalculatedReflections = 0 ;
	
	//switch(mHKLCalculatedFileType) {
		//case kRFIT:
			fp = fopen("rfit.dat","r") ;
			if (fp == nil) return ;
		//	break ;
		//case kRBFIT:
		//	fp = fopen("rbfit.dat","r") ;
		//	if (fp == nil) return ;
		//	break ;
	//}
	
	
	for (; (c = fgetc(fp)) != EOF ; ) {
		if (c == CR || c == LF) mNumCalculatedReflections++ ;
	}	
	
	mNumCalculatedReflections -= 2 ;	// Two text lines before the data
	
	if (mNumCalculatedReflections < 1) {
		PutMessage("Did not find any reflection data") ;
		return ;
	}

	if (mNumReflections != mNumCalculatedReflections) {
		if (mAmplitude != nil) delete mAmplitude ;
		if (mAmplitudeError != nil) delete mAmplitudeError ;
		if (mPhase != nil) delete mPhase ;
		if (mH != nil) delete mH ;
		if (mK != nil) delete mK ;
		if (mL != nil) delete mL ;
		mNumReflections = mNumCalculatedReflections ;
		mAmplitude 	= new float[mNumReflections] ;
		mPhase 		= new float[mNumReflections] ;
		mH			= new short[mNumReflections] ;
		mK			= new short[mNumReflections] ;
		mL			= new short[mNumReflections] ;
	}

	
	mCalcAmplitude 	= new float[mNumCalculatedReflections] ;
	mCalcDifference = new float[mNumCalculatedReflections] ;
	mCalcH			= new short[mNumCalculatedReflections] ;
	mCalcK			= new short[mNumCalculatedReflections] ;
	mCalcL			= new short[mNumCalculatedReflections] ;
	
	// Now rewind and read in the data
	rewind(fp) ;

	ReadLine(buffer,256,fp) ;	// Output of R**2 on S.F. fitted data 
	ReadLine(buffer,256,fp) ;	//    H   K   L      Fobs        Fcalc     Diff*100

	for (i = 0 ;  i < mNumCalculatedReflections; i++) {
		if (ReadLine(buffer,256,fp) == NULL) break ;
		sscanf(buffer,"%hd %hd %hd %f %f %f",&mCalcH[i],&mCalcK[i],&mCalcL[i],&mAmplitude[i],&mCalcAmplitude[i],&mCalcDifference[i]) ;	
		mH[i] = mCalcH[i] ;
		mK[i] = mCalcK[i] ;
		mL[i] = mCalcL[i] ;
	}	
	fclose(fp) ;

	PeakHKLRecord hklData ;
	mHKLDisplayList->RemoveAllRows() ;
	for(i=0; i < mNumCalculatedReflections; i++) {
		hklData.h = mCalcH[i] ;
		hklData.k = mCalcK[i] ;
		hklData.l = mCalcL[i] ;
		hklData.expVal = mAmplitude[i] ;
		hklData.calcVal = mCalcAmplitude[i] ;
		hklData.error = mCalcDifference[i]  ;	// For Now
		mHKLDisplayList->AddRow(&hklData) ;
	}
	CalculateExpDiffractionPattern() ;
}

void	TPeaksControlWindow::Draw() {
	SetPort(this) ;
	EraseRect(&mPortRect) ;
	DisplayMap() ;
	
	TPane::Draw() ;
	DrawInfoWindow() ;
}

void TPeaksControlWindow::WriteMessage(char *text) {
	Rect		theRect ;

	strcpy(mMessageText,text) ;

	theRect = mInfo->GetRect() ;
	InsetRect(&theRect,2,2) ;
	
	SetFgColor(gWhitePixel) ;
	PaintRect(&theRect) ;
	MoveTo(theRect.left + 4,theRect.bottom - 4) ;
	SetFgColor(gRedPixel) ;
	DrawString(mMessageText) ;
	SetFgColor(gBlackPixel) ;
	
}

void TPeaksControlWindow::DrawInfoWindow() {
	Rect		theRect ;
	
	theRect	= mInfo->GetRect() ;
	
	FrameRect(&theRect) ;
	InsetRect(&theRect,1,1) ;
	SetFgColor(gDarkerGray) ;
	MoveTo(theRect.left,theRect.bottom) ;
	LineTo(theRect.left,theRect.top) ;
	LineTo(theRect.right,theRect.top) ;	
	SetFgColor(gGrayPixel) ;
	MoveTo(theRect.left+1,theRect.bottom-1) ;
	LineTo(theRect.right-1,theRect.bottom-1) ;
	LineTo(theRect.right-1,theRect.top+1) ;	
	
	InsetRect(&theRect,1,1) ;	
	SetFgColor(gWhitePixel) ;
	PaintRect(&theRect) ;

	MoveTo(theRect.left + 4,theRect.bottom - 4) ;
	SetFgColor(gRedPixel) ;
	DrawString(mMessageText) ;
	SetFgColor(gBlackPixel) ;
}

void	TPeaksControlWindow::ConvertToImagePos(FPoint &mousePos) {
	mousePos.x -= mImageRect.left ;
	mousePos.y -= mImageRect.top ;
}

TAtomPeak	*TPeaksControlWindow::FindAtomPeak(FPoint &imagePos) {
	long		i,dsq,rsq ; //,x,y ;
	TAtomPeak	*thePeak ;
	//FPoint		theUCPos ;
	
	TAtomPeakList *theList = mShowCurrentDifferenceList->GetState() ? mDifferencePeakList : mAtomPeakList ;
	if (theList != nil) {
		for(i=0; i < theList->GetNumberOfAtomPeaks(); i++) {
			thePeak = theList->GetAtomPeak(i) ;
			rsq = thePeak->screenRad*thePeak->screenRad ;
			dsq = (long) ( (imagePos.x-thePeak->screenPos.x)*(imagePos.x-thePeak->screenPos.x) + 
				(imagePos.y-thePeak->screenPos.y)*(imagePos.y-thePeak->screenPos.y) ) ;
			if (dsq <= rsq) {
				return thePeak ;
			}
		}
	}
	return nil ;
}

void		
TPeaksControlWindow::DoMouseDownInImage(Point &loc) {
	short 	i,xc,yc,dx,dy ;
	float	zoomfactor ;
	FPoint	imagePos ;
	TAtomPeak	*theAtomPeak,*thePeak ;
	TAtomPeak	theAtom ;
	FPoint		unitCellPos ;
		
	imagePos.x = loc.x ;
	imagePos.y = loc.y ;
	
	short	toolID = mCurrentTool->GetToolID() ;
	bool	UseRuler = false ;
	switch(toolID) { 
		case kPeakAddTool:
			ConvertToImagePos(imagePos) ;
			// We will add a peak at this position with repect to the unit cell
			FindUnitCellPosition(imagePos,unitCellPos) ;
			if (mShowCurrentPeakList->GetState()) {
			// Add this atom to the list
				theAtom.xc = unitCellPos.x ;
				theAtom.yc = unitCellPos.y ;
				theAtom.usage = kTestPeak ;
				theAtom.index = mPeakDisplayList->GetNumberOfListItems() ;
				theAtom.baseIndex = -2 ;	// This means it is not related to any atoms at the moment
											// It is unique, but has no symmetry related atoms associated with it yet
				// Get the first symbol from the atomtype list and assign it to this one
				if (mAtomTypes != nil && mAtomTypes->GetNumberOfAtomPeaks() > 0) {		
					thePeak = mAtomTypes->GetAtomPeak(0) ;
					sprintf(theAtom.symbol,"%s%d",thePeak->symbol,mPeakDisplayList->GetNumberOfListItems()+1) ;
					theAtom.peak = thePeak->peak ;
				}
				else {
					sprintf(theAtom.symbol,"Q%d",mPeakDisplayList->GetNumberOfListItems()+1) ;
					theAtom.peak = -1.0 ;
				}
				mPeakDisplayList->AddRow(&theAtom) ;
				CreateDisplayAtoms() ;
				DisplayMap() ;	// To update the map
			}
			else {
				theAtom.xc = unitCellPos.x ;
				theAtom.yc = unitCellPos.y ;
				theAtom.usage = kTestPeak ;
				theAtom.index = mDifferencePeakDisplayList->GetNumberOfListItems() ;
				theAtom.baseIndex = -2 ;	// This means it is not related to any atoms at the moment
											// It is unique, but has no symmetry related atoms associated with it yet
				if (mAtomTypes != nil && mAtomTypes->GetNumberOfAtomPeaks() > 0) {		
					thePeak = mAtomTypes->GetAtomPeak(0) ;
					sprintf(theAtom.symbol,"%s%d",thePeak->symbol,mDifferencePeakDisplayList->GetNumberOfListItems()+1) ;
					theAtom.peak = thePeak->peak ;
				}
				else {
					sprintf(theAtom.symbol,"Q%d",mPeakDisplayList->GetNumberOfListItems()+1) ;
					theAtom.peak = -1.0 ;
				}
				mDifferencePeakDisplayList->AddRow(&theAtom) ;
				CreateDisplayDifferencePeaks() ;
				DisplayMap() ;	// To update the map
			}
			mAddAtomPeak->SetState(false) ;
			mPointerTool->SetState(true) ;
			mCurrentTool = mPointerTool ;
			break ;
		case kPeakRemoveTool:
			ConvertToImagePos(imagePos) ;
			break ;
		case kPeakRuler:
			UseRuler = true ;
		case kPeakPointer:
			ConvertToImagePos(imagePos) ;
			if ((mDisplayMode == kPeakDisplayGeneticMap || mDisplayMode == kPeakDisplayCurrentModel || 
				mDisplayMode == kPeakDisplayCurrentMap || mDisplayMode == kPeakDisplayDifferenceMap)) {
					if(mOverlayAtoms->GetState() && !UseRuler ) {
					if (mShowCurrentPeakList->GetState()) {
						theAtomPeak = FindAtomPeak(imagePos) ;
						if (theAtomPeak != nil) {
							// Deselect any peak that is selected
							for(i=0; i < mAtomPeakList->GetNumberOfAtomPeaks(); i++) {
								thePeak = mAtomPeakList->GetAtomPeak(i) ;
								thePeak->Select(kNormalState) ;
							}
							theAtomPeak->Select(kSelectedState) ;
							// Also set the atom which is the non-equivalent site if this is not
							if (theAtomPeak->baseIndex != -1 && theAtomPeak->baseIndex != -2) {
								thePeak = mAtomPeakList->GetAtomPeak(theAtomPeak->baseIndex) ;
								thePeak->Select(kSelectedState) ;
								// Highlight this atom in the list
								mPeakDisplayList->SelectRow(theAtomPeak->baseIndex+1) ;
							} 
							else {
								mPeakDisplayList->SelectRow(theAtomPeak->index+1) ;
								if (theAtomPeak->baseIndex == -1) {
									// Maybe select all equivalent positions
									for(i=0; i < mAtomPeakList->GetNumberOfAtomPeaks(); i++) {
										thePeak = mAtomPeakList->GetAtomPeak(i) ;
										if (thePeak->baseIndex == theAtomPeak->index) thePeak->Select(kSelectedState) ;
									}
								}
							}
							DisplayMap() ;
							mPeakDisplayList->Refresh() ;
							mRemoveAtomPeak->Enable() ;
						}
					}
					else {
						theAtomPeak = FindAtomPeak(imagePos) ;
						if (theAtomPeak != nil) {
							// Deselect any peak that is selected
							for(i=0; i < mDifferencePeakList->GetNumberOfAtomPeaks(); i++) {
								thePeak = mDifferencePeakList->GetAtomPeak(i) ;
								thePeak->Select(kNormalState) ;
							}
							mDifferencePeakDisplayList->SelectRow(theAtomPeak->index+1) ;
							theAtomPeak->Select(kSelectedState) ;
							DisplayMap() ;
							mDifferencePeakDisplayList->Refresh() ;
						}
					}
					}
					else {
						Point lastPoint,currentPoint ;
						long dx,dy ;
						char buffer[256];
						lastPoint = loc ;
						currentPoint = loc ;
						Rect theRect = mActualImageRect ;
						TVector A ;
						float	aa ;
						float   ww,hh ;
						ww = (theRect.right-theRect.left)/mFS98ControlRecord.width  ;
						hh = (theRect.bottom-theRect.top)/mFS98ControlRecord.height ;
						// We need to see if we have P3 or P6 symmetry
						if (mFS98ControlRecord.ga == 120.) {
							ww /= 2 ;
							hh /= 2 ;
							aa = sqrt(ww*ww+hh*hh) ;
						}
						else {
							aa = ww ;
						}
							// A axis length in pixels
							// Angstroms per pixel
							float APerPixel = mFS98ControlRecord.a/aa ;
							TImageWindow *theImageWindow = (TImageWindow *)GetTargetWindow() ;
							theImageWindow->GetImage()->SetCalibrationUnit(kAngstrom) ;
							theImageWindow->GetImage()->SetCalibration(APerPixel) ;
							
							if (mRuler != nil) {
								//delete mRuler ;
								mRuler = nil ;
							}
							mRuler = new TRuler(currentPoint,theImageWindow ) ;
							if (!mRuler->IsValid()) {
								delete mRuler ;
								mRuler = nil ;
							}
						//while(Button()) {
							GetMouse(&currentPoint) ;
							dx = currentPoint.x - lastPoint.x ;
							dy = currentPoint.y - lastPoint.y ;
							
							float rr=dx*dx+dy*dy ;
							if (rr > 1e-3) rr = sqrt(rr)*APerPixel ;
							float x = dx*APerPixel ; float y = dy*APerPixel ;
							sprintf(buffer,"Distance in Angstroms %.2f, dx = %.2f , dy = %.2f",rr,x,y) ;
							//strcat(inputLine,buffer) ;
							WriteMessage(buffer) ;
						//}
					}
			}
			break ;
		case kPeakZoom:
			float factor ;
			if (::ControlKeyDown()) {
				if (::ShiftKeyDown()) {
					factor = 2.0 ;
				}
				else {
					factor = 1.1 ;
				}
				
			}
			else {
				if (::ShiftKeyDown()) {
					factor = 0.5 ;
				}
				else {
					factor = 1./1.1 ;
				}
			}
			xc = (mImageRect.right-mImageRect.left)/2 ;
			yc = (mImageRect.bottom-mImageRect.top)/2 ;
			mImageMagnification /= factor ;
			zoomfactor = 1./factor ;
			dx = xc + near( (mImageCenter.x - xc)/factor - mImageCenter.x ) ;
			dy = yc + near( (mImageCenter.y - yc)/factor - mImageCenter.y ) ;
			mImageCenter.x = xc + near((mImageCenter.x - xc)/factor) ;
			mImageCenter.y = yc + near((mImageCenter.y - yc)/factor) ;
			PositionImage() ;
			DisplayMap() ;
			break ;
		case kPeakHand:
			// Let us try to pan the view
			Point lastPoint,currentPoint ;
			long dx,dy ;
			lastPoint = loc ;
			currentPoint = loc ;
			while(Button()) {
				GetMouse(&currentPoint) ;
				dx = currentPoint.x - lastPoint.x ;
				dy = currentPoint.y - lastPoint.y ;
				if (dx != 0 || dy != 0) {
					mImageCenter.x += dx ;
					mImageCenter.y += dy ;
					PositionImage() ;
					DisplayMap() ;
					lastPoint = currentPoint ;
				}
			}
			break ;
	}	
}

void
TPeaksControlWindow::PositionImage() {
	
	if (mCurrentImage != nil) {
		short width = near (mCurrentImage->Width()*mImageMagnification) ;
		short height = near (mCurrentImage->Height()*mImageMagnification) ;
		
		SetRect(&mActualImageRect,mImageCenter.x - width/2,
			mImageCenter.y - height/2,
			mImageCenter.x + width/2,
			mImageCenter.y + height/2) ;
	}
}

void	TPeaksControlWindow::DisablePeakCommands() {
		mCreateModelFromPeaks->Disable() ;
		mUpdateCurrentMap->Disable() ;
		mChangeThreshold->Disable() ;
		if (mCurrentModel == nil) mShowCurrentModel->Disable() ;
		if (mCurrentMap == nil) mShowCurrentMap->Disable() ;
		mCommandUpdateAtoms->Disable() ;
		mCommandListAtoms->Disable() ;
		mCommandEntropy->Disable() ;
		mCommandPositive->Disable() ;
		mCommandRefine->Disable() ;
		mCommandOccupancy->Disable() ;
		mCommandFix->Disable() ;
		mCommandSEED->Disable() ;
		mCommandDiffMap->Disable() ;
		mCommandDiffProj->Disable() ;
		mCommandDiffMapOne->Disable() ;
		mCommandTrim->Disable() ;
		mCommandSettoModel->Disable() ;
		mCommandPurgeSeeds->Disable() ;
		mCommandReadAtoms->Disable() ;
		mCommandCyclePeaks->Disable() ;
		mOptionRobust->Disable() ;
		mOptionErrors->Disable() ;
		mOptionUseFHKL->Disable() ;
		mOptionUcmin->Disable() ;
		mOptionTwin->Disable() ;
		mShowDifferenceMap->Disable() ;
		mOptionDWRef->Disable() ;
		mOptionICons->Disable() ;
		mOptionMultiplicity->Disable() ;
		mBabinet->Disable() ;
		mTestPeaks->Disable() ;
		mCommandShowCurrentSettings->Disable() ;
		mCommandSetConstraints->Disable() ;
		mQuit->SetItemText("Restart Peaks") ;
		mPeaksIsRunning = false ;
}

void	TPeaksControlWindow::EnablePeakCommands() {
		// Turn off switches (LDM)
		mOptionRobust->SetState(false);
		mOptionErrors->SetState(false);
		mOptionICons->SetState(true);
		mOptionUseFHKL->SetState(false);
		mOptionUcmin->SetState(false);
		mOptionTwin->SetState(false);
		mOptionDWRef->SetState(false) ;
		mOptionMultiplicity->SetState(true) ;
		mShowCurrentPeakList->SetState(true);
		mShowCurrentDifferenceList->SetState(false);
		mHKLDisplayList->SetVisible(false) ;
		mDifferencePeakDisplayList->SetVisible(false) ;
		mPeakDisplayList->SetVisible(true);
		mAcceptBestSolution->SetState(false);
		mUseAtomList->SetState(false);
		mCreateModelFromPeaks->Enable() ;
		mUpdateCurrentMap->Enable() ;
		mChangeThreshold->Enable() ;
		mShowCurrentModel->Enable() ;
		mShowCurrentMap->Enable() ;
		mShowDifferenceMap->Enable() ;
		mCommandUpdateAtoms->Enable() ;
		mCommandListAtoms->Enable() ;
		mCommandEntropy->Enable() ;
		mCommandPositive->Enable() ;
		mCommandRefine->Enable() ;
		mCommandOccupancy->Enable() ;
		mCommandFix->Enable() ;
		mCommandSEED->Enable() ;
		mCommandDiffMap->Enable() ;
		mCommandDiffProj->Enable() ;
		mCommandDiffMapOne->Enable() ;
		mCommandTrim->Enable() ;
		mCommandSettoModel->Enable() ;
		mCommandPurgeSeeds->Enable() ;
		mCommandReadAtoms->Enable() ;
		mOptionRobust->Enable() ;
		mOptionErrors->Enable() ;
		mOptionICons->Enable() ;
		mOptionMultiplicity->Enable() ;
		mBabinet->Enable() ;
		mOptionUseFHKL->Enable() ;
		mOptionUcmin->Enable() ;
		mOptionTwin->Enable() ;
		mOptionDWRef->Enable() ;
		mTestPeaks->Enable() ;
		mCommandCyclePeaks->Enable() ;
		mCommandShowCurrentSettings->Enable() ;
		mCommandSetConstraints->Enable() ;
		mQuit->SetItemText("Stop Peaks") ;
		mPeaksIsRunning = true ;
}

void	TPeaksControlWindow::DoMouseDownInObject(TObject *obj,Point *pt) {	
	SetPort(this) ;
	char	text[256] ;
	short   i,row ;
	//float	value ;
	//TMessageDialog	*MessageDialog ;
		
	if (pt != nil)
		if (!obj->DoMouseDown(pt)) return ;
	if (obj == mQuit) {
		if (mPeaksIsRunning) {
			SendPeaksCommand(kPeakQuit) ;
			DisablePeakCommands() ;
		}
		else {
 			EnablePeakCommands() ;
			RestartPeaks() ;
		}
	}
	else if (obj == mAddAtomPeak) {
		mCurrentTool->SetState(false) ;
		mCurrentTool = (TPushButton *)obj ;
		XUndefineCursor(gDisplay,mXWindow) ;
	}
	else if (obj == mRemoveAtomPeak) {
		// This is not actually a tool,but a button
		// Remove the selected row from the peak list
		mRemoveAtomPeak->SetState(true) ;
		short selectedRow = mPeakDisplayList->GetSelectedRow() ;
		if (selectedRow > 0) {
			mPeakDisplayList->RemoveRow(selectedRow) ;
			selectedRow = mPeakDisplayList->GetSelectedRow() ;
			if (selectedRow == 0) mRemoveAtomPeak->Disable() ;
			CreateDisplayAtoms() ;
			DisplayMap() ;	// To update the map
		}
		mRemoveAtomPeak->SetState(false) ;
	}
	else if (obj == mPointerTool) {
		mCurrentTool->SetState(false) ;
		mCurrentTool = (TPushButton *)obj ;
		XUndefineCursor(gDisplay,mXWindow) ;
	}
	else if (obj == mZoomTool) {
		mCurrentTool->SetState(false) ;
		mCurrentTool = (TPushButton *)obj ;
		XDefineCursor(gDisplay,mXWindow,gZoomCursor) ;
	}
	else if (obj == mHandTool) {
		mCurrentTool->SetState(false) ;
		mCurrentTool = (TPushButton *)obj ;
		XDefineCursor(gDisplay,mXWindow,gHandCursor) ;			
	}
	else if (obj == mRulerTool) {
		mCurrentTool->SetState(false) ;
		mCurrentTool = (TPushButton *)obj ;
		XDefineCursor(gDisplay,mXWindow,gRulerCursor) ;			
	}
	else if (obj == mResetView) {
		mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
		mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
		mScaleFactor = 0. ;
		mImageMagnification = 1.0 ;
		mCurrentTool->SetState(false) ;
		if (mCurrentTool != mPointerTool) {
			mCurrentTool->SetState(false) ;
			mCurrentTool = mPointerTool ;
			mCurrentTool->SetState(true) ;
			XUndefineCursor(gDisplay,mXWindow) ;
		}
		PositionImage() ;
		DisplayMap() ;
	}
	else if (obj == mOverlayAtoms) {
		DisplayMap() ;
	}
	else if (obj == mShowLog) {
		mLogDiagnosticOutput = mShowLog->GetState() ;
	}
	//else if (obj == mOptionDWRef) {
	else if (obj == mPeakDisplayList) {
		row = mPeakDisplayList->GetSelectedRow() ;
		TAtomPeak *thePeak ;
		if (row > 0) {
			for(i=0; i < mAtomPeakList->GetNumberOfAtomPeaks(); i++) {
				thePeak = mAtomPeakList->GetAtomPeak(i) ;
				thePeak->Select(kNormalState) ;
			}
			thePeak = mAtomPeakList->GetAtomPeak(row-1) ;
			thePeak->Select(kSelectedState) ;
			DisplayMap() ;
		}
	}
	else if (obj == mDifferencePeakDisplayList) {
		row = mDifferencePeakDisplayList->GetSelectedRow() ;
		TAtomPeak *thePeak ;
		if (row > 0) {
			for(i=0; i < mDifferencePeakList->GetNumberOfAtomPeaks(); i++) {
				thePeak = mDifferencePeakList->GetAtomPeak(i) ;
				thePeak->Select(kNormalState) ;
			}
			thePeak = mDifferencePeakList->GetAtomPeak(row-1) ;
			thePeak->Select(kSelectedState) ;
			DisplayMap() ;
		}
	}
	else if (obj == mFFTGmaxApply) {
		obj->SetState(true) ;
		mFFTGmax->GetEditText(text) ;
		float gmax = atof(text) ;
		if (gmax != mGMax) {
			mGMax = gmax ;
			if (mExpDP != nil) {
				delete mExpDP ;
				mExpDP = nil ;
				if (mDisplayMode == kPeakDisplayExperimentalDP) 
					DisplayMap() ;
			}
			if (mCurrentDP != nil) {
				delete mCurrentDP ;
				mCurrentDP = nil ;
				if (mDisplayMode == kPeakDisplayCalculatedDP) 
					DisplayMap() ;
			}
			if (mSplitDP != nil) {
				delete mSplitDP ;
				mSplitDP = nil ;
				if (mDisplayMode == kPeakDisplayFourierFit) 
					DisplayMap() ;
			}
		}
		obj->SetState(false) ;
	}
	else if (obj == mChangeThreshold) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakChangeThreshold) ;
		obj->SetState(false) ;
	}
	else if (obj == mFFTDiskRadiusApply) {
		obj->SetState(true) ;
		mFFTDiskRadius->GetEditText(text) ;
		float radius = atof(text) ;
		if (radius != mDiskRadius) {
			mDiskRadius = radius ;
			if (mExpDP != nil) {
				delete mExpDP ;
				mExpDP = nil ;
				if (mDisplayMode == kPeakDisplayExperimentalDP) 
					DisplayMap() ;
			}
			if (mCurrentDP != nil) {
				delete mCurrentDP ;
				mCurrentDP = nil ;
				if (mDisplayMode == kPeakDisplayCalculatedDP) 
					DisplayMap() ;
			}
			if (mSplitDP != nil) {
				delete mSplitDP ;
				mSplitDP = nil ;
				if (mDisplayMode == kPeakDisplayFourierFit) 
					DisplayMap() ;
			}
		}
		obj->SetState(false) ;
	}
	else if (obj == mShowGeneticSolutionMap) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowCurrentModel && mSelectedDisplay != mShowCurrentMap &&  mSelectedDisplay != mShowDifferenceMap) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowGeneticSolutionMap ;
		mDisplayMode = kPeakDisplayGeneticMap ;
		if (!mPeakDisplayList->IsVisible() && !mDifferencePeakDisplayList->IsVisible()) {
			mHKLDisplayList->SetVisible(false) ;
			if (mShowCurrentPeakList->GetState()) {
				mDifferencePeakDisplayList->SetVisible(false) ;
				mPeakDisplayList->SetVisible(true) ;
			}
			else {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(true) ;
			}
		}
		mAddAtomPeak->Enable() ;
		mRemoveAtomPeak->Enable() ;
		mCurrentImage = mImageMap ;
		DisplayMap() ;
	}
	else if (obj == mShowCurrentModel) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowGeneticSolutionMap && mSelectedDisplay != mShowCurrentMap && mSelectedDisplay != mShowDifferenceMap) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowCurrentModel ;
		mDisplayMode = kPeakDisplayCurrentModel ;
		if (!mPeakDisplayList->IsVisible() && !mDifferencePeakDisplayList->IsVisible()) {
			mHKLDisplayList->SetVisible(false) ;
			if (mShowCurrentPeakList->GetState()) {
				mDifferencePeakDisplayList->SetVisible(false) ;
				mPeakDisplayList->SetVisible(true) ;
			}
			else {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(true) ;
			}
		}
		mAddAtomPeak->Enable() ;
		mRemoveAtomPeak->Enable() ;
		mCurrentImage = mCurrentModel ;
		DisplayMap() ;
	}
	else if (obj == mShowCurrentMap) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowGeneticSolutionMap && mSelectedDisplay != mShowCurrentModel && mSelectedDisplay != mShowDifferenceMap) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowCurrentMap ;
		mDisplayMode = kPeakDisplayCurrentMap ;
		if (!mPeakDisplayList->IsVisible() && !mDifferencePeakDisplayList->IsVisible()) {
			mHKLDisplayList->SetVisible(false) ;
			if (mShowCurrentPeakList->GetState()) {
				mDifferencePeakDisplayList->SetVisible(false) ;
				mPeakDisplayList->SetVisible(true) ;
			}
			else {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(true) ;
			}
		}
		mAddAtomPeak->Enable() ;
		mRemoveAtomPeak->Enable() ;
		mCurrentImage = mCurrentMap ;
		DisplayMap() ;
	}
	else if (obj == mShowDifferenceMap) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowGeneticSolutionMap && mSelectedDisplay != mShowCurrentModel && mSelectedDisplay != mShowCurrentMap) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowDifferenceMap ;
		mDisplayMode = kPeakDisplayDifferenceMap ;
		if (!mPeakDisplayList->IsVisible() && !mDifferencePeakDisplayList->IsVisible()) {
			mHKLDisplayList->SetVisible(false) ;
			if (mShowCurrentPeakList->GetState()) {
				mDifferencePeakDisplayList->SetVisible(false) ;
				mPeakDisplayList->SetVisible(true) ;
			}
			else {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(true) ;
			}
		}
		if (mDifferenceMap == nil) SendPeaksCommand(kPeakDMapOne) ;
		mAddAtomPeak->Enable() ;
		mRemoveAtomPeak->Enable() ;
		mCurrentImage = mDifferenceMap ;
		DisplayMap() ;
	}
	else if (obj == mShowExperimentalDP) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowCalculatedDP && mSelectedDisplay != mShowFourierFit) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowExperimentalDP ;
		mDisplayMode = kPeakDisplayExperimentalDP ;
		mHKLDisplayList->SetDisplayMode(kHKLDisplayExperimentalDP) ;
		if (!mHKLDisplayList->IsVisible()) {
			mPeakDisplayList->SetVisible(false) ;
			mDifferencePeakDisplayList->SetVisible(false) ;
			mHKLDisplayList->SetVisible(true) ;
		}
		mCurrentImage = mExpDP ;
		mAddAtomPeak->Disable() ;
		mRemoveAtomPeak->Disable() ;
		DisplayMap() ;
	}
	else if (obj == mShowCalculatedDP) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowExperimentalDP && mSelectedDisplay != mShowFourierFit) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowCalculatedDP ;
		mDisplayMode = kPeakDisplayCalculatedDP ;
		mHKLDisplayList->SetDisplayMode(kHKLkDisplayCalculatedDP) ;
		if (!mHKLDisplayList->IsVisible()) {
			mPeakDisplayList->SetVisible(false) ;
			mDifferencePeakDisplayList->SetVisible(false) ;
			mHKLDisplayList->SetVisible(true) ;
		}
		mCurrentImage = mCurrentDP ;
		mAddAtomPeak->Disable() ;
		mRemoveAtomPeak->Disable() ;
		DisplayMap() ;
	}
	else if (obj == mShowFourierFit) {
		mSelectedDisplay->SetState(0) ;
		if (mSelectedDisplay != mShowExperimentalDP && mSelectedDisplay != mShowCalculatedDP) {
			mScaleFactor = 0. ;
			mImageCenter.x = (mImageRect.right+mImageRect.left)/2 ;
			mImageCenter.y =  (mImageRect.bottom+mImageRect.top)/2 ;
			mImageMagnification = 1.0 ;
		}
		mSelectedDisplay = mShowFourierFit ;
		mDisplayMode = kPeakDisplayFourierFit ;
		mHKLDisplayList->SetDisplayMode(kHKLDisplayFourierFit) ;
		if (!mHKLDisplayList->IsVisible()) {
			mPeakDisplayList->SetVisible(false) ;
			mDifferencePeakDisplayList->SetVisible(false) ;
			mHKLDisplayList->SetVisible(true) ;
		}
		mCurrentImage = mSplitDP ;
		mAddAtomPeak->Disable() ;
		mRemoveAtomPeak->Disable() ;
		DisplayMap() ;
	}
	else if (obj == mCreateModelFromPeaks) {
		obj->SetState(true) ;
		CalculateCurrentModel() ;
		if (mDisplayMode == kPeakDisplayCurrentModel) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mUpdateCurrentMap) {
		obj->SetState(true) ;
		CalculateCurrentMap() ;
		if (mDisplayMode == kPeakDisplayCurrentMap) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandUpdateAtoms) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakAtoms) ;
		obj->SetState(false) ;
	}
	else if (obj == mOptionRobust) {
		SendPeaksCommand(kPeakROB) ;
	}
	else if (obj == mOptionErrors) {
		SendPeaksCommand(kPeakERR) ;
		// Default, turn off multiplicity
		if (obj->GetState() ) {
			if(mOptionMultiplicity->GetState()) {
				SendPeaksCommand(kPeakMultiplicity) ;
				mOptionMultiplicity->SetState(false);
			}
		}
		else {
			if(!mOptionMultiplicity->GetState()) {
				SendPeaksCommand(kPeakMultiplicity) ;
				mOptionMultiplicity->SetState(true);
			}
		}
	}
	else if (obj == mOptionICons) {
		SendPeaksCommand(kPeakICons) ;
    }
    else if (obj == mOptionMultiplicity)  {
         SendPeaksCommand(kPeakMultiplicity) ;
	}
	else if (obj == mBabinet) {
		obj->SetState(true) ;
		SendPeaksCommand(kBabinet) ;
		SendPeaksCommand(kPeakEnt) ;
		SendPeaksCommand(kPeakEnt) ;
		SendPeaksCommand(kPeakPos) ;
		CalculateCurrentMap() ;
		DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mOptionUseFHKL) {
	        SendPeaksCommand(kPeakUseFHKL)  ;
	}
	else if (obj == mOptionUcmin) {
	        SendPeaksCommand(kPeakRefUcmin)  ;
	}
	else if (obj == mOptionTwin) {
			SendPeaksCommand(kPeakRefTwin) ;
	}
	else if (obj == mOptionDWRef) {
			SendPeaksCommand(kPeakDWRef)  ;
	}
	else if (obj == mCommandPurgeSeeds) {
	        SendPeaksCommand(kPeakPurgeSeeds) ;
	}
	else if (obj == mCommandReadAtoms) {
		obj->SetState(true) ;
        SendPeaksCommand(kPeakReadAtoms) ;
		SendPeaksCommand(kPeakGOF) ;
        SendPeaksCommand(kPeakList) ;
        SetAtomList() ;
		ReadCalculatedHKLDataSet() ;
		if (mExpDP == nil) CalculateExpDiffractionPattern() ;
		CalculateCurrentDiffractionPattern() ;
		CalculateSplitDiffractionPattern() ;
		CalculateCurrentModel() ;
		if (mDisplayMode == kPeakDisplayCurrentModel) DisplayMap() ;
		if (mDisplayMode == kPeakDisplayCalculatedDP) {
			mHKLDisplayList->SetDisplayMode(kHKLkDisplayCalculatedDP) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mCurrentDP ;
			DisplayMap() ;
		}
		else if (mDisplayMode == kPeakDisplayFourierFit) {
			mHKLDisplayList->SetDisplayMode(kHKLDisplayFourierFit) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mSplitDP ;
			DisplayMap() ;
		}
		else if (mDisplayMode == kPeakDisplayExperimentalDP) {
			mHKLDisplayList->SetDisplayMode(kHKLDisplayExperimentalDP) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mExpDP ;
			DisplayMap() ;
		}
		SendPeaksCommand(kPeakList) ;
		// We have a new list of atom peaks in .edm_3
		SetAtomList() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandSettoModel) {
	        SendPeaksCommand(kPeakSettoModel) ;
	}
	else if (obj == mCommandShowCurrentSettings) {
		bool	savedState = mLogDiagnosticOutput ;
		mLogDiagnosticOutput = true ;
		SendPeaksCommand(kPeakShowCurrentSettings) ;
		mLogDiagnosticOutput = savedState ;
	}
	else if (obj == mShowCurrentPeakList) {
		mShowCurrentDifferenceList->SetState(false) ;
		if (mDifferencePeakDisplayList->IsVisible() || mPeakDisplayList->IsVisible()) {
			mDifferencePeakDisplayList->SetVisible(false) ;
			mPeakDisplayList->SetVisible(true) ;
			DisplayMap() ;
		}
	}
	else if (obj == mAcceptBestSolution) {
		mUseAtomList->SetState(false) ;
		}
	else if (obj == mUseAtomList) {
		mAcceptBestSolution->SetState(false) ;
		}
	else if (obj == mShowCurrentDifferenceList) {
		mShowCurrentPeakList->SetState(false) ;
		if (mDifferencePeakDisplayList->IsVisible() || mPeakDisplayList->IsVisible()) {
			mPeakDisplayList->SetVisible(false) ;
			mDifferencePeakDisplayList->SetVisible(true) ;
			DisplayMap() ;
		}
	}
	else if (obj == mTestPeaks) {
		obj->SetState(true) ;
		// Create the file 'atest.lst' which contains all the atoms to tested
		if (WriteAtomsToTestFile()) {
			if (mAcceptBestSolution->GetState()) {
				SendPeaksCommand(kPeakFindBestAtomCombination) ;
					WriteResult() ;
			}
			else {
				if (mUseAtomList->GetState()) {
					SendPeaksCommand(kPeakUseAtomList) ;
					WriteResult() ;
					}
				else {
					SendPeaksCommand(kPeakInquireAtoms) ;
					WriteResult() ;
					}
			}
		}
		obj->SetState(false) ;
	}
	else if (obj == mCommandListAtoms) {
		SendPeaksCommand(kPeakList) ;
		// We have a new list of atom peaks in .edm_3
		SetAtomList() ;
		DisplayMap() ;
	}
	else if (obj == mCommandEntropy) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakEnt) ;
		CalculateCurrentMap() ;
		if (mDisplayMode == kPeakDisplayCurrentMap) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandPositive) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakPos) ;
		CalculateCurrentMap() ;
		if (mDisplayMode == kPeakDisplayCurrentMap) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandRefine) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakRef) ;
		WriteResult();
		ReadCalculatedHKLDataSet() ;
		if (mExpDP == nil) CalculateExpDiffractionPattern() ;
		CalculateCurrentDiffractionPattern() ;
		CalculateSplitDiffractionPattern() ;
		if (mDisplayMode == kPeakDisplayCalculatedDP) {
			mHKLDisplayList->SetDisplayMode(kHKLkDisplayCalculatedDP) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mCurrentDP ;
			DisplayMap() ;
		}
		else if (mDisplayMode == kPeakDisplayFourierFit) {
			mHKLDisplayList->SetDisplayMode(kHKLDisplayFourierFit) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mSplitDP ;
			DisplayMap() ;
		}
		else if (mDisplayMode == kPeakDisplayExperimentalDP) {
			mHKLDisplayList->SetDisplayMode(kHKLDisplayExperimentalDP) ;
			if (!mHKLDisplayList->IsVisible()) {
				mPeakDisplayList->SetVisible(false) ;
				mDifferencePeakDisplayList->SetVisible(false) ;
				mHKLDisplayList->SetVisible(true) ;
			}
			mCurrentImage = mExpDP ;
			DisplayMap() ;
		}
		CalculateCurrentModel() ;
		if (mDisplayMode == kPeakDisplayCurrentModel) DisplayMap() ;
		SendPeaksCommand(kPeakList) ;
		// We have a new list of atom peaks in .edm_3
		SetAtomList() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandOccupancy) {
		//MessageDialog = new TMessageDialog("This might take a while.....") ;
		//MessageDialog->Draw() ;
		//MessageDialog->Show() ;
      		obj->SetState(true) ;
		SendPeaksCommand(kPeakOcc) ;
		//delete MessageDialog ;
		SetOccupancySolutions() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandFix) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakFix) ;
		CalculateCurrentMap() ;
		if (mDisplayMode == kPeakDisplayCurrentMap) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandSEED) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakSEED) ;
		SetOccupancySolutions() ;
        WriteResult();
		obj->SetState(false) ;
	}
	else if (obj == mCommandDiffMap) {
		obj->SetState(true) ;
		CalculateDifferenceMap(kPeakDMap) ;
		// If current display is the difference map, then update
		if (mDisplayMode == kPeakDisplayDifferenceMap) DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandCyclePeaks) {
		//MessageDialog = new TMessageDialog("This might take a while.....") ;
		//MessageDialog->Draw() ;
		//MessageDialog->Show() ;
                obj->SetState(true);
        //String of Commands
        //Occupancy First
                SendPeaksCommand(kPeakOcc) ;
		//delete MessageDialog ;
		SetOccupancySolutions() ;
		obj->SetState(false);
		obj->SetState(true) ;
		SendPeaksCommand(kPeakSEED) ;
		SetOccupancySolutions() ;
   		SendPeaksCommand(kPeakRef) ;
   		WriteResult();
		obj->SetState(false);
		obj->SetState(true) ;
		SendPeaksCommand(kPeakDProj) ;
		SendPeaksCommand(kPeakPos) ;
		CalculateCurrentMap() ;
		DisplayMap() ;
		obj->SetState(false);
		obj->SetState(true) ;
		CalculateDifferenceMap(kPeakDMap) ;
		SendPeaksCommand(kPeakSEED) ;
		SetOccupancySolutions() ;
       		SendPeaksCommand(kPeakTrim) ;
		obj->SetState(false);
		obj->SetState(true) ;
		SendPeaksCommand(kPeakSEED) ;
		SendPeaksCommand(kPeakSEED) ;
		SendPeaksCommand(kPeakSEED) ;
		SetOccupancySolutions() ;
   		//SendPeaksCommand(kPeakRef) ;
   		//WriteResult();
   		////delete MessageDialog ;
        obj->SetState(false);
	}
	else if (obj == mCommandSetConstraints) {
		obj->SetState(true) ;
		TConstraintsDialog *theConstraintsDialog = new TConstraintsDialog(mAtomTypes,mConstraints) ;
		if (theConstraintsDialog->DoModalDialog()) {
			theConstraintsDialog->GetConstraints(mConstraints) ;
			delete theConstraintsDialog ;
			if (WriteConstraintsFile()) {
				SendPeaksCommand(kPeakConstraints) ;
			}
		} 
		else 
			delete theConstraintsDialog ;
		obj->SetState(false) ;

	}
	else if (obj == mCommandDiffMapOne) {
		obj->SetState(true) ;
		CalculateDifferenceMap(kPeakDMapOne) ;
		DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandDiffProj) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakDProj) ;
		CalculateCurrentMap() ;
		DisplayMap() ;
		obj->SetState(false) ;
	}
	else if (obj == mCommandTrim) {
		obj->SetState(true) ;
		SendPeaksCommand(kPeakTrim) ;
		obj->SetState(false) ;
	}
	else if (obj == mImageFrame) {
		DoMouseDownInImage(*pt) ;
	}
}
